;
; .
;    .
;     15 ( ),
;     5 ( ).
;  -  .
;   .
;   .
; ., .
; saes@mail.ru
;
;  = BUDAK.ASM
; : 25.02.03.
;   : MPLAB IDE, : 5.61.00.
;
            #INCLUDE P16F84A.INC
            __CONFIG 3FF0H
;======================================
;    32,768 K.
;======================================
; . .
;================
INDF     EQU  00H  ;    FSR.
TIMER0   EQU  01H  ;TMR0.
OPTIONR  EQU  81H  ;OPTION (RP0=1).
PC       EQU  02H  ; .
STATUS   EQU  03H  ;  .
FSR      EQU  04H  ;  .
PORTA    EQU  05H  ;  /.
PORTB    EQU  06H  ;  /.
TRISA    EQU  85H  ;   .
TRISB    EQU  86H  ;   .
INTCON   EQU  0BH  ;  .
;=============================================
;  .
;=============================================
; RB0 >   .
; RB1 >   .
; RB2 > ,  .
; RB3 > ,  .
; RA0 >   (1).
; RA1 >   (0).
; RA2 >  1   1/4 .
;=================================
;  .
;=================================
SC0      EQU  10H  ;   .
SC1      EQU  11H  ;   .
COUS     EQU  12H  ; .
;============================================
;     FLAG.
;============================================
FLAG     EQU  14H   
;
;     0->  .
;     1->   .
;     2->   .
;     3->   .
;     4->   .
;     5->  .
;==============================
FLAG1    EQU  15H
;
;     0-> 0-  . ,
;         1-  . . 
;     1->   .
;         0-  ,
;         1-  .
;     2->    ().
;==================================
;   .
;================================== 
UMNO     EQU  16H  ;  .
UHO      EQU  17H  ;  .
MIL      EQU  18H  ; .
MIH      EQU  19H  ; .
SEC1     EQU  1AH  ; .
MIN1     EQU  1BH  ; .
DSMH     EQU  1CH  ;   .
LSMH     EQU  1DH  ; ,  .
HOU1     EQU  1EH  ; .
H_LOW    EQU  1FH  ; .
H_HIGH   EQU  20H  ; .
HSMH     EQU  21H  ;,  .
;====================
;  .
;====================
W_TEMP      EQU  28H ;   W  .
STATUS_TEMP EQU  29H ;   STATUS  .
FSR_TEMP    EQU  2AH ;  FSR.
;=====================
; 1. .
;=====================
        ORG 0
           GOTO INIT 
        ORG 4
           GOTO CONST
;==================
; 2. .
;==================
INIT
 BSF   STATUS,RP0      ;   1.
 MOVLW B'00000010'     ;  , =8 =...10.
 MOVWF OPTION_REG^80H  ;
 MOVLW B'10100000'     ;    TMR0.
 MOVWF INTCON          ;
 MOVLW B'00000000'     ;  .
 MOVWF TRISA^80H
 MOVLW B'00000011'     ;RB0, RB1- ,  - .
 MOVWF TRISB^80H
 BCF   STATUS,RP0      ;   0. 
 CLRF  FLAG            ;  
 CLRF  FLAG1
 CLRF  TMR0            ;   
 CLRF  SC0
 CLRF  SC1
 CLRF  UMNO
 BSF   UMNO,0
 CLRF  UHO
 CLRF  LSMH
 CLRF  HSMH
 CLRF  SEC1
 CLRF  MIN1
 CLRF  HOU1
 CLRF  PORTB
 CLRF  PORTA
 BSF   PORTA,0
 GOTO  ZOO         ;  .
;============================
; 3.   .
;============================
KEY
       MOVFW  PORTB      ;   
       BCF    STATUS,2   ;  .
       ANDLW  B'00000011';.
       BTFSC  STATUS,2   ;  0,
       BSF    FLAG,4     ;   .
       BTFSC  FLAG,4     ;    ,
       GOTO   KOZ        ;  .
       BTFSS  PORTB,0    ;   ,
       BSF    FLAG,2     ; .
       BTFSS  PORTB,0    ;  ,  .
       RETURN
       BTFSC  FLAG,2     ;  ,
       CALL   UST        ;  .
       BTFSS  PORTB,1    ;   ,
       BSF    FLAG,3     ; .
       BTFSS  PORTB,1    ;  ,  .
       RETURN
       BTFSC  FLAG,3     ;  ,
       CALL   UST        ;  .
       RETURN            ;   , .
KOZ
       BTFSS  PORTB,0    ;  ,  .
       RETURN
       BTFSS  PORTB,1    ;  ,  .
       RETURN
       BCF    FLAG,4     ; .
       BCF    FLAG,3     ;   
       BCF    FLAG,2     ;   .
       BCF    FLAG1,2    ; 2 .
       BTFSS  FLAG,0     ;  
       GOTO   KOZO       ; .
       BCF    FLAG,0     ; .
       BCF    FLAG,5     ;     .
       RETURN
KOZO
       BSF    FLAG,0     ; .
       RETURN
;=================================
; 4.    .
;=================================
UST
        BTFSS   FLAG,0   ;  ,
        RETURN           ;.
        BTFSS   FLAG1,2  ; ,   2 .
        RETURN           ;
        BTFSC   FLAG,3   ;   ,
        GOTO    UST0     ;  .
        BTFSC   FLAG,2   ;   ,
        GOTO    USTH     ;  .
        RETURN
;=====================================================
; 5.   .
;=====================================================
UST0
        BCF     FLAG,3   ;   .
        INCF    UMNO,1   ;   .
        MOVLW   .6       ;   6.
        SUBWF   UMNO,0   ;
        BTFSC   STATUS,0 ;() = 1,  10  .
        CLRF    UMNO     ; .
        GOTO    UST3     ;   .
;========================================================
; 6.   .
;========================================================
USTH
        BCF     FLAG,2   ;   .
        MOVLW   .15      ;
        SUBWF   UHO,0    ;
        BTFSC   STATUS,0 ; = 1,  15  .
        GOTO    USTHO
        INCF    UHO,1    ;   .
        GOTO    UST3     ;   .
USTHO
        CLRF    UHO      ; .
;============================================================
; 7.      .
;============================================================
UST3
        MOVFW   UMNO    ; 
        MOVWF   SC0     ; .
        MOVFW   UHO     ;  .
        MOVWF   SC1     ;
        RETURN
;================================
; 8.   .
;================================
COMPOT
        BTFSS   PORTB,0 ;   ,
        BCF     PORTB,3 ; .
        BTFSS   PORTB,1 ;   ,
        BCF     PORTB,2 ; .
        BTFSS   FLAG,1  ; 0,25    ,
        GOTO    COMPOT  ;.
COMP
        BTFSC   FLAG,0  ;    ,
        GOTO    ZOO     ;   .
        BCF     FLAG,2  ;  .
        BCF     FLAG,3  ;
        BSF     PORTB,2 ;  .
        BSF     PORTB,3 ;
        MOVFW   HOU1    ;  
        SUBWF   UHO,0   ;   .
        BNZ     COM     ;  ,  .
        MOVFW   MIH     ;  
        SUBWF   UMNO,0  ;   .
        BZ      COMW    ;  ,  .
COM
        BCF     PORTA,0 ; .
        BSF     PORTA,1 ;.
        GOTO    COMPOT  ; .
COMW
        BSF     PORTA,0 ; .
        BCF     PORTA,1 ;.
        BSF     FLAG,5  ;
        BTFSC   COUS,1  ;   ,
        GOTO    COMPOT  ;  .
COMW0
        BTFSC   COUS,1  ;    ,
        GOTO    COMP    ;  .
        BCF     PORTA,2 ; .
        NOP             ; 
        NOP             ;
        NOP             ;  .
        NOP             ;  1,22  = 0,8 .
        BSF     PORTA,2 ; .
        GOTO    COMW0   ;.

;===========================
; 9.   .
;===========================
ZOO
        BTFSS   FLAG,0   ;  ,
        GOTO    COMPOT   ;  .
        BTFSS   PORTB,0  ;   ,
        BCF     PORTB,3  ; .
        BTFSS   PORTB,1  ;   ,
        BCF     PORTB,2  ; .
        BTFSS   FLAG1,2  ; 2    ,
        GOTO    ZOO      ;.
        BTFSS   PORTB,0  ;  ,  .
        GOTO    ZOO      ;.
        BTFSS   PORTB,1  ;  ,  .
        GOTO    ZOO      ;.
        BCF     FLAG1,2  ;  2 .
        BSF     PORTB,2  ; .
        BSF     PORTB,3  ;
;========================================
; 10.   .
;========================================
HOKL
        BTFSC   FLAG1,0  ;    ,
        GOTO    HOZH     ;  .
HOZL
        BSF     PORTB,3  ;  .
        TSTF    SC0      ;  ,
        SKPNZ            ; ,
        GOTO    HOZLO    ;   .
        BTFSC   FLAG1,1  ;  ,
        GOTO    HOZOL    ;   .
        BTFSS   COUS,0   ; ,
        GOTO    HOZOL    ;
        DECF    SC0,1    ; 1  .
        BSF     FLAG1,1  ;  .
        BCF     PORTB,2  ;  .
HOZOL
        BTFSS   FLAG,1   ;   ,
        GOTO    HOZOL1   ;
        BSF     PORTB,2  ; .
        BCF     FLAG1,1  ;  .
HOZOL1
        TSTF    SC0      ;   ,
        SKPZ             ;
        GOTO    HOKL     ; .
HOZLO
        BTFSC   FLAG1,1  ;,   
        GOTO    HOZOL    ; .
        BSF     FLAG1,0  ;   .
        BCF     FLAG1,2  ;  2 .
        GOTO    ZOO      ;   .
HOZH
        BSF     PORTB,2  ;  .
        TSTF    SC1      ;  ,
        SKPNZ            ;
        GOTO    HOZHO    ;   .
        BTFSC   FLAG1,1  ;  ,
        GOTO    HOZOH    ;   .
        BTFSS   COUS,0   ; ,
        GOTO    HOZOH    ;
        DECF    SC1,1    ; .
        BSF     FLAG1,1  ;  .
        BCF     PORTB,3  ;  .
HOZOH
        BTFSS   FLAG,1   ;   ,
        GOTO    HOZOH1   ;
        BSF     PORTB,3  ; .
        BCF     FLAG1,1  ;  .
HOZOH1
        TSTF    SC1      ;   ,
        SKPZ             ;.
        GOTO    HOKL     ; .
HOZHO
        BTFSC   FLAG1,1  ;,   
        GOTO    HOZOH    ; .
        CALL    UST3     ;  .
        BCF     FLAG1,0  ;   .
        BCF     FLAG1,2  ;  2 .
        GOTO    ZOO      ;   .
;==========================================================
; 11. .     2-10  (2-_-2-10).
;==========================================================
BINDECH
        MOVLW   .10      ;10 >W.
BDH
        BSF     STATUS,0 ;  ""  STATUS.
        SUBWF   DSMH,1   ;   10 > DSMH.
        BNC     BINDECL  ;    .
        INCF    HSMH,1   ; 1   .
        GOTO    BDH      ;.                
BINDECL
        MOVF    DSMH,0   ;   
        ADDLW   .10      ;10+W >W.               
        MOVWF   LSMH     ;    .
        RETURN           ;
;==================================================================
; 12.       .
;===================================================================
CONST
        MOVWF  W_TEMP      ;   W 
        MOVFW  STATUS      ;STATUS,
        MOVWF  STATUS_TEMP ;
        MOVFW  FSR         ;FSR.
        MOVWF  FSR_TEMP    ;
        CALL   S1          ; 1  .
        BTFSC  FLAG1,2     ;   2 .
        CALL   KEY         ; .
RECONST                    ;  .
        BCF    INTCON,2    ;  .
        MOVFW  STATUS_TEMP ; :
        MOVWF  STATUS      ;STATUS,
        MOVFW  FSR_TEMP    ;
        MOVWF  FSR         ;FSR,
        MOVFW  W_TEMP      ;W.
        RETFIE             ;  .
;==================
; 13. .
;=================
S1
        INCF   COUS,1   ;+1  .
        BTFSS  COUS,0   ;  ,
        BSF    FLAG,1   ; .
        BTFSC  COUS,0   ;  ,
        BCF    FLAG,1   ; .
        MOVLW  .4       ;  1 ,
        SUBWF  COUS,0   ;4  0,25,
        SKPZ            ;
        RETURN
        CLRF   COUS     ; .
        MOVFW  SEC1     ;  . .
        ADDLW  -3BH     ;   59.
        BZ      M1      ;  0,   ,   M1.
        INCF   SEC1,F   ; 1  .
        BTFSC  SEC1,1   ;  ,
        BSF    FLAG1,2  ;  2 .
        RETURN          ;
M1
        CLRF   SEC1     ;  .
        BTFSC  FLAG,5   ;   ,
        GOTO   HOO      ;  .
        BTFSC  FLAG,0   ;  ,
        GOTO   HOO      ;    .
M1M
        MOVFW  MIN1     ;   . .
        ADDLW  -3BH     ;-59.
        BZ     H1       ;  0,  ,   H1.
        INCF   MIN1,F   ; 1  .
        MOVFW  MIN1     ;   . .
M1U
        MOVWF  DSMH     ;W >DSMH.
        CALL   BINDECH  ;  .
        MOVFW  LSMH     ;LSMH >W .
        MOVWF  MIL      ;W > MIL     .
        MOVFW  HSMH     ;HSMH >W .
        MOVWF  MIH      ;W > MIH      .
        CLRF   HSMH     ; . . .
        CLRF   LSMH     ; .
        RETURN   
H1
        CLRF   MIN1     ;   .
H1H
        MOVFW  HOU1     ;   . .
        ADDLW  -0FH     ;- 15. 
        BZ     HOO      ;  0,  ,   HOO.
        INCF   HOU1,F   ; 1  .
        RETURN

HOO
        CLRF   HOU1     ; ,
        CLRF   MIL      ; ,
        CLRF   MIH      ; ,
        CLRF   MIN1     ;  .
        RETURN
;==============================================
        END
;==============================================

