;
;   .
;     .
;  -  .
;   .
;   .
; ., .
; saes@mail.ru
;
;  = CHASIKI.ASM
; : 01.03.03.
;   : MPLAB IDE, : 5.61.00.
;
            #INCLUDE P16F84A.INC
            __CONFIG 3FF0H
;======================================
;    32,768 K.
;======================================
; . .
;================
INDF     EQU  00H  ;    FSR.
TIMER0   EQU  01H  ;TMR0.
OPTIONR  EQU  81H  ;OPTION (RP0=1).
PC       EQU  02H  ; .
STATUS   EQU  03H  ;  .
FSR      EQU  04H  ;  .
PORTA    EQU  05H  ;  /.
PORTB    EQU  06H  ;  /.
TRISA    EQU  85H  ;   .
TRISB    EQU  86H  ;   .
INTCON   EQU  0BH  ;  .
;=============================================
;  .
;=============================================
; RB0 >   .
; RB1 >   .
; RB2 > ,  .
; RB3 > ,  .
; RB4 >    .
; RA0 >   (1).
; RA1 >   (0).
; RA2 >    0,8    1/4 .
;=================================
;  .
;=================================
SC0      EQU  10H  ;   .
SC1      EQU  11H  ;   .
COUS     EQU  12H  ; .
;============================================
;     FLAG.
;============================================
FLAG     EQU  14H   
;
;     0->   .
;     1->   .
;     2->   .
;     3->   .
;     4->   .
;     5->   .
;     6->  .
;     7->  .
;==============================
FLAG1    EQU  15H
;
;     0->    ,
;     1->   .
;         0-  ,
;         1-  .
;     2->    ().
;     3->  .
;     4->  .
;     5->  1 .
;==================================
;   .
;================================== 
BUL      EQU  16H  ;  .
BUH      EQU  17H  ;  .
MIL      EQU  18H  ;  .
MIH      EQU  19H  ;  .
SEC1     EQU  1AH  ; .
MIN1     EQU  1BH  ; .
DSMH     EQU  1CH  ;   .
LSMH     EQU  1DH  ; ,  .
HOU1     EQU  1EH  ; .
HOL      EQU  1FH  ; .
HOH      EQU  20H  ; .
HSMH     EQU  21H  ;,  .
BUDO     EQU  22H  ;    .
BUD      EQU  23H  ;  .
MIN5     EQU  24H  ;  5 .
BUML     EQU  25H  ;  .
BUMH     EQU  26H  ;  .
BUDM     EQU  27H  ;  .
;====================
;  .
;====================
W_TEMP      EQU  28H ;   W  .
STATUS_TEMP EQU  29H ;   STATUS  .
FSR_TEMP    EQU  2AH ;  FSR.
COUZ        EQU  2BH ; .
;=====================
; 1. .
;=====================
        ORG 0
           GOTO INIT 
        ORG 4
           GOTO CONST
;==================
; 2. .
;==================
INIT
 BSF   STATUS,RP0      ;   1.
 MOVLW B'00000010'     ;  , =8 =...10.
 MOVWF OPTION_REG^80H  ;
 MOVLW B'10100000'     ;    TMR0.
 MOVWF INTCON          ;
 MOVLW B'00000000'     ;  .
 MOVWF TRISA^80H
 MOVLW B'00010011'     ;RB0, RB1, RB4- ,  - .
 MOVWF TRISB^80H
 BCF   STATUS,RP0      ;   0. 
 CLRF  FLAG            ;  .
 CLRF  FLAG1
 CLRF  TMR0            ;   .
 CLRF  SC0
 CLRF  SC1
 CLRF  HOL
 CLRF  HOH
 CLRF  BUL
 CLRF  BUH
 CLRF  MIL
 CLRF  MIH
 CLRF  COUS
 CLRF  COUZ
 CLRF  MIN5
 CLRF  LSMH
 CLRF  HSMH
 CLRF  SEC1
 CLRF  MIN1
 CLRF  HOU1
 CLRF  BUDO
 CLRF  PORTB
 CLRF  PORTA
 BSF   COUZ,0     ;   1.
 BSF   FLAG,7     ;   .
 BSF   PORTA,1    ;  .
 GOTO  ZOO        ;  .
;============================
; 3.   .
;============================
KEY
         MOVFW  PORTB      ;   
         BCF    STATUS,2   ;  .
         ANDLW  B'00000011';.
         BTFSC  STATUS,2   ;  0,
         BSF    FLAG,4     ;   .
         BTFSC  FLAG,4     ;  ,
         BCF    FLAG,0     ;   .
         BTFSC  FLAG,4     ;    ,
         GOTO   KOZ        ;  .
         BTFSS  PORTB,0    ;   ,
         BSF    FLAG,2     ; .
         BTFSS  PORTB,0    ;  ,  .
         RETURN
         BTFSC  FLAG,2     ;  ,
         GOTO   UST        ;  .
         BTFSS  PORTB,1    ;   ,
         BSF    FLAG,3     ; .
         BTFSS  PORTB,1    ;  ,  .
         RETURN
         BTFSC  FLAG,3     ;  ,
         GOTO   UST        ;  .
         BCF    FLAG1,5
         RETURN            ;   , .
KBUH
         BSF    FLAG,5     ;   .
         BCF    FLAG,6     ;  .
         BCF    FLAG,7     ;
         BCF    FLAG1,3    ;
         RETURN
KMIN
         BSF    FLAG,6     ;   .
         BCF    FLAG,5     ;  .
         BCF    FLAG,7     ;
         BCF    FLAG1,3    ;
         RETURN
KHO
         BSF    FLAG,7     ;   .
         BCF    FLAG,5     ;  .
         BCF    FLAG,6     ;
         BCF    FLAG1,3    ;
         RETURN
KBUM
         BSF    FLAG1,3    ;   .
         BCF    FLAG,5     ;  .
         BCF    FLAG,6     ;
         BCF    FLAG,7     ;
         RETURN
KOZ
         BTFSS  PORTB,0    ;  ,  .
         RETURN
         BTFSS  PORTB,1    ;  ,  .
         RETURN
         CLRF   SC0        ; 
         CLRF   SC1        ;.
         BCF    FLAG1,0    ;   .
         BCF    FLAG,4     ; .
         BCF    FLAG,3     ;   
         BCF    FLAG,2     ;   .
         CLRF   MIN5       ;    5 .
         BCF    FLAG1,5    ; 1 .
         BCF    STATUS,0   ;    .
         RLF    COUZ,1     ;+1   .
         BTFSC  COUZ,4     ;     4 ,
         GOTO   KOZO       ;  .
         BTFSC  COUZ,0     ; ,
         GOTO   KHO        ;  .
         BTFSC  COUZ,1     ; ,
         GOTO   KMIN       ;  .
         BTFSC  COUZ,2     ; ,
         GOTO   KBUH       ;   .
         BTFSC  COUZ,3     ; ,
         GOTO   KBUM       ;   .
         RETURN
KOZO
         CLRF   COUZ       ; 
         BSF    COUZ,0     ;  .
         GOTO   KHO        ;  .
;==========================================================
; 4.       .
;==========================================================
DECBIN
        ADDWF   PC,1         ;
        RETLW   B'00000000'  ;0
        RETLW   B'00001010'  ;10
        RETLW   B'00010100'  ;20
        RETLW   B'00011110'  ;30
        RETLW   B'00101000'  ;40
        RETLW   B'00110010'  ;50
;============================================================
; 5.      .
;============================================================
UST3
        CLRF    BUDO    ;  .
        MOVFW   BUL     ; 
        MOVWF   SC0     ; 
        MOVFW   BUH     ;   
        MOVWF   SC1     ;  .
        CALL    DECBIN  ;  , 
        ADDWF   BUL,0   ; 
        MOVWF   BUD     ;  .
        ADDWF   BUDM,0  ;   .
        MOVWF   BUDO    ;   .
        RETURN
USTM3
        CLRF    BUDO    ;  .
        MOVFW   BUML    ; 
        MOVWF   SC0     ; 
        MOVFW   BUMH    ;   
        MOVWF   SC1     ;  .
        CALL    DECBIN  ;  , 
        ADDWF   BUML,0  ; 
        MOVWF   BUDM    ;  .
        ADDWF   BUD,0   ;   .
        MOVWF   BUDO    ;   .
        RETURN
USTW3
        BTFSS   PORTB,4 ;   ,
        CALL    UST2S   ; ,  2 .
        MOVFW   MIL     ; 
        MOVWF   SC0     ; 
        MOVFW   MIH     ;  
        MOVWF   SC1     ;  .
        BTFSS   PORTB,4 ;  ,
        RETURN          ; .
        MOVFW   MIH     ;
        CALL    DECBIN  ;  ,
        ADDWF   MIL,0   ; 
        MOVWF   MIN1    ;  .
        RETURN
USTH3
        BTFSS   PORTB,4 ;   ,
        CALL    UST2S   ; ,  2 .
        MOVFW   HOL     ; 
        MOVWF   SC0     ; 
        MOVFW   HOH     ;  
        MOVWF   SC1     ;  .
        BTFSS   PORTB,4 ;  ,
        RETURN          ; .
        MOVFW   HOH     ;  ,
        CALL    DECBIN  ; 
        ADDWF   HOL,0   ;  .
        MOVWF   HOU1    ;:  + .
        RETURN
UST2S
        BTFSC   FLAG1,2 ;   2 .
        RETURN
        GOTO    UST2S   ;  2 .
UST256
        MOVLW   .10     ;   
        SUBWF   SC0,0   ;  
        BTFSC   STATUS,0 ; 9.
        CALL    UST2OO  ;   .
        MOVLW   .10     ;  
        SUBWF   SC1,0   ;  
        BTFSS   STATUS,0 ; 9.
        RETURN
UST2OO
        CLRF    SC0     ;
        CLRF    SC1     ; .
        RETURN
;=================================
; 6.    .
;=================================
UST
        BTFSS   FLAG1,5  ; ,   1 .
        RETURN           ;
        BTFSC   FLAG,6   ;  ,
        GOTO    USTM     ;  .
        BTFSC   FLAG,7   ;  ,
        GOTO    USTH     ;  .
        BTFSC   FLAG,5   ;  ,
        GOTO    USTBH    ;  .
        BTFSC   FLAG,3   ;   ,
        GOTO    USTBML   ;   .
        BTFSC   FLAG,2   ;   ,
        GOTO    USTBMH   ;   .
        RETURN
;=====================================================
; 7.   .
;=====================================================
USTBML
        BCF     FLAG,3  ;   .
        INCF    BUML,1  ;    .
        MOVLW   .10     ;   9.
        SUBWF   BUML,0  ;
        BTFSC   STATUS,0 ;() = 1,  10  .
        CLRF    BUML    ; .
        GOTO    USTM3   ;   .
USTBMH
        INCF    BUMH,1  ;   5.
        MOVLW   .6      ;
        SUBWF   BUMH,0  ;
        BTFSC   STATUS,0 ; = 1,  6  .
        CLRF    BUMH    ;  .
        BCF     FLAG,2  ;   .
        GOTO    USTM3   ;   .
;========================================================
; 8.   .
;========================================================
USTBH
        BTFSC   FLAG,3  ;   ,
        GOTO    USTBH0  ;  .
        BTFSC   FLAG,2  ;   ,
        GOTO    USTBH1  ;  .
        RETURN
USTBH0
        BCF     FLAG,3  ;   .
        INCF    BUL,1   ;    .
USTBH2
        MOVFW   BUH     ;  
        ADDLW   -002H   ; 2,
        SKPNZ
        CALL    USTBH4  ;  .
        BTFSC   FLAG,2  ;    ,
        RETURN          ;.
        MOVLW   .10     ;   9.
        SUBWF   BUL,0   ;
        BTFSC   STATUS,0 ;() = 1,  10  .
        CLRF    BUL     ; .
        GOTO    UST3    ;    .
USTBH4
        MOVFW   BUL     ;  
        BCF     STATUS,0 ; 4,
        ADDLW   -004H   ;    2,
        SKPNC
        CLRF    BUL     ;   .
        RETURN
USTBH1
        INCF    BUH,1   ;   2.
        CALL    USTBH2  ;  24 ,   .
        MOVLW   .3      ;
        SUBWF   BUH,0   ;
        BTFSC   STATUS,0 ; = 1,  3  .
        CLRF    BUH     ; .
        BCF     FLAG,2  ;   .
        GOTO    UST3    ;    .
;========================================================
; 9.  .
;========================================================
USTM
        BTFSC   FLAG,3  ;   ,
        GOTO    USTW0   ;  .
        BTFSC   FLAG,2  ;   ,
        GOTO    USTW1   ;  .
        RETURN
USTW0
        BCF     FLAG,3  ;   .
        INCF    MIL,1   ;    .
        MOVLW   .10     ;   9.
        SUBWF   MIL,0   ;
        BTFSC   STATUS,0 ;() = 1,  10  .
        CLRF    MIL     ; .
        GOTO    USTW3   ;    .
USTW1
        INCF    MIH,1   ;   5.
        MOVLW   .6      ;
        SUBWF   MIH,0   ;
        BTFSC   STATUS,0 ; = 1,  3  .
        CLRF    MIH     ; .
        BCF     FLAG,2  ;   .
        GOTO    USTW3   ;   .
;========================================================
; 10.  .
;========================================================
USTH
        BTFSC   FLAG,3  ;   ,
        GOTO    USTH0   ;  .
        BTFSC   FLAG,2  ;   ,
        GOTO    USTH1   ;  .
        RETURN
USTH0
        BCF     FLAG,3  ;   .
        INCF    HOL,1   ;    .
USTH2
        MOVFW   HOH     ;  
        ADDLW   -002H   ; 2,
        SKPNZ
        CALL    USTH4   ;  .
        BTFSC   FLAG,2  ;    ,
        RETURN          ;.
        MOVLW   .10     ;   9.
        SUBWF   HOL,0   ;
        BTFSC   STATUS,0 ;() = 1,  10  .
        CLRF    HOL     ; .
        GOTO    USTH3   ;   .
USTH4
        MOVFW   HOL     ;  
        BCF     STATUS,0 ; 4,
        ADDLW   -004H   ;    2,
        SKPNC
        CLRF    HOL     ;  .
        RETURN
USTH1
        INCF    HOH,1   ;   2.
        CALL    USTH2   ;  24 ,   .
        MOVLW   .3      ;
        SUBWF   HOH,0   ;
        BTFSC   STATUS,0 ; = 1,  3  .
        CLRF    HOH     ; .
        BCF     FLAG,2  ;   .
        GOTO    USTH3   ;   .
;================================
; 11.   .
;================================
COMP
        BTFSS   PORTB,4 ;    ,
        GOTO    HOKL    ;   .
        BTFSS   FLAG,0  ;    ,
        GOTO    ZOO     ;   .
        BCF     FLAG,2  ;  .
        BCF     FLAG,3  ;
        BSF     PORTB,2 ;  .
        BSF     PORTB,3 ;
        TSTF    BUDO    ;   ,
        BZ      COMW    ;  ,  .
        MOVFW   HOU1    ;  
        SUBWF   BUD,0   ;   .
        BNZ     COMW    ;   ,  .
        MOVFW   MIN1    ;  
        SUBWF   BUDM,0  ;   .
        BZ      COM     ;  ,  .
COMW
        BCF     PORTA,0 ; .
        BSF     PORTA,1 ;.
        GOTO    COMP    ; .
COM
        BSF     PORTA,0 ; .
        BCF     PORTA,1 ;.
        BTFSC   COUS,0  ; 1/4  ,
        GOTO    COMP    ;  .
COMW0
        BTFSC   COUS,0  ; 1/4    ,
        GOTO    COMP    ;  .
        BCF     PORTA,2 ; .
        NOP             ; 
        NOP             ;
        NOP             ;  .
        NOP             ;  1,22  = 0,8 .
        BSF     PORTA,2 ; .
        GOTO    COMW0   ;.
;===========================
; 12.   .
;===========================
ZOO
        BTFSC   FLAG,0   ;  ,
        GOTO    COMP     ;  .
        BTFSS   PORTB,0  ;   ,
        BCF     PORTB,3  ; .
        BTFSS   PORTB,1  ;   ,
        BCF     PORTB,2  ; .
        BTFSS   FLAG1,2  ; 2    ,
        GOTO    ZOO      ;.
        BTFSS   PORTB,0  ;  ,  .
        GOTO    ZOO      ;.
        BTFSS   PORTB,1  ;  ,  .
        GOTO    ZOO      ;.
        BCF     FLAG1,2  ;  2 .
        BSF     PORTB,2  ; .
        BSF     PORTB,3  ;
        BTFSC   FLAG,5   ;  ,
        GOTO    BUHKL    ;   .
        BTFSC   FLAG,6   ;  ,
        GOTO    MUKL     ;  .
        BTFSC   FLAG,7   ;  ,
        GOTO    HOKL     ;  .
;========================================
; 13.    .
;========================================
BUMKL
        BTFSC   FLAG1,0  ;    ,
        GOTO    ZH       ;  .
ZL
        BSF     PORTB,3  ;  .
        CALL    UST256   ;   .
        TSTF    SC0      ; 
        SKPNZ            ; ,
        GOTO    ZLO      ;   .
        BTFSC   FLAG1,1  ;  ,
        GOTO    ZOL      ;   .
        BTFSS   COUS,0   ; ,
        GOTO    ZOL      ;
        DECF    SC0,1    ; 1   .
        BSF     FLAG1,1  ;  .
        BCF     PORTB,2  ;  .
ZOL
        BTFSS   FLAG,1   ;    ,
        GOTO    ZOL1
        BSF     PORTB,2  ;  .
        BCF     FLAG1,1  ;  .
ZOL1
        CALL    UST256   ;   .
        TSTF    SC0      ;     ,
        SKPZ             ;
        GOTO    BUMKL    ; .
ZLO
        BTFSC   FLAG1,1  ;,   
        GOTO    ZOL      ; .
        BSF     FLAG1,0  ;   .
        GOTO    ZOO      ; 2 .    .
ZH
        BSF     PORTB,2  ;  .
        CALL    UST256   ;   .
        TSTF    SC1      ;  ,
        SKPNZ            ;
        GOTO    ZHO      ;   .
        BTFSC   FLAG1,1  ;  ,
        GOTO    ZOH      ;   .
        BTFSS   COUS,1   ; ,
        GOTO    ZOH      ;
        DECF    SC1,1    ; 1   .
        BSF     FLAG1,1  ;  .
        BCF     PORTB,3  ;  .
ZOH
        BTFSC   COUS,1   ;   ,
        GOTO    ZOH1
        BSF     PORTB,3  ; .
        BCF     FLAG1,1  ;  .
ZOH1
        CALL    UST256   ;   .
        TSTF    SC1      ;     ,
        SKPZ             ;
        GOTO    BUMKL    ; .
ZHO
        BTFSC   FLAG1,1  ;,   
        GOTO    ZOH      ; .
        CALL    USTM3    ;  .
        BCF     FLAG1,0  ;   .
        BCF     FLAG1,2  ;  2 .
        GOTO    ZOO      ;   .
;============================================
; 14.    .
;============================================
BUHKL                    ;Ѩ   .
        BTFSC   FLAG1,0  ;    ,
        GOTO    UZH      ;  .
UZL
        BSF     PORTB,3  ;  .
        CALL    UST256   ;   .
        TSTF    SC0      ;  ,
        SKPNZ            ; ,
        GOTO    UZLO     ;   .
        BTFSC   FLAG1,1  ;  ,
        GOTO    UZOL     ;   .
        BTFSS   COUS,1   ;  ,
        GOTO    UZOL     ;   .
        DECF    SC0,1    ; 1  .
        BSF     FLAG1,1  ;  .
        BCF     PORTB,2  ;  .
UZOL
        BTFSC   COUS,1   ;   ,
        GOTO    UZOL1
        BSF     PORTB,2  ; .
        BCF     FLAG1,1  ;  .
UZOL1
        CALL    UST256   ;   .
        TSTF    SC0      ;     ,
        SKPZ             ;
        GOTO    BUHKL    ; .
UZLO
        BTFSC   FLAG1,1  ;,   
        GOTO    UZOL     ; .
        BSF     FLAG1,0  ;   .
        GOTO    ZOO      ;   .
UZH
        BSF     PORTB,2  ;  .
        CALL    UST256   ;   .
        TSTF    SC1      ;  ,
        SKPNZ            ;
        GOTO    UZHO     ;   .
        BTFSC   FLAG1,1  ;  ,
        GOTO    UZOH     ;   .
        BTFSS   COUS,0   ; ,
        GOTO    UZOH     ;
        DECF    SC1,1    ; . 
        BSF     FLAG1,1  ;  .
        BCF     PORTB,3  ;  .
UZOH
        BTFSS   FLAG,1   ;   ,
        GOTO    UZOH1
        BSF     PORTB,3  ; .
        BCF     FLAG1,1  ;  .
UZOH1
        CALL    UST256   ;   .
        TSTF    SC1      ;     ,
        SKPZ             ;
        GOTO    BUHKL    ; .
UZHO
        BTFSC  FLAG1,1  ;,   
        GOTO   UZOH     ; .
        CALL   UST3     ;  .
        BCF    FLAG1,0  ;   .
        BCF    FLAG1,2  ;  2 .
        GOTO   ZOO      ;   .
;========================================
; 15.   .
;========================================
HOKL
       BTFSC   FLAG1,0  ;    ,
       GOTO    HOZH     ;  .
       BTFSS   PORTB,4  ;   ,
       CALL    USTH3    ;  .
HOKLO
       BSF     PORTB,2  ;  .
       CALL    UST256   ;   .
       TSTF    SC1      ; ,
       SKPNZ            ;  ,
       GOTO    HOZLO    ;   .
HOZL
       BTFSS   COUS,1   ;  ,
       GOTO    HOZL     ;,   1,
       DECF    SC1,1    ;  1  .
       BCF     PORTB,3  ;  .
HOZOL
       BTFSC   COUS,1   ;    ,
       GOTO    HOZOL    ;,   0.
       BSF     PORTB,3  ;  .
       GOTO    HOKLO    ;   .
HOZLO
       BSF     FLAG1,0  ;   .
       BTFSC   PORTB,4  ;   ,
       GOTO    ZOO      ;.
HOZH
       BSF      PORTB,3 ;  .
       CALL     UST256  ;   .
       TSTF     SC0     ;   ,
       SKPNZ            ;
       GOTO     HOZHO   ; .
HOZH1
       BTFSS    COUS,1  ;   ,
       GOTO     HOZH1   ;.
       DECF     SC0,1   ; .
       BCF      PORTB,2 ; .
HOZOH
       BTFSC    COUS,1  ;   ,
       GOTO     HOZOH   ;  .
       BSF      PORTB,2 ;  .
       GOTO     HOZH    ;   .
HOZHO
       BTFSC    PORTB,4 ;   ,
       CALL     USTH3   ;   .
       BCF      FLAG1,0 ;   .
       BCF      FLAG1,2 ;  2 .
       BTFSC    PORTB,4 ;    ,
       GOTO     ZOO     ;    .
;========================================
; 16.   .
;========================================
MUKL
       BTFSC   FLAG1,0  ;    ,
       GOTO    MOZH     ;  .
       BTFSS   PORTB,4  ;   ,
       CALL    USTW3    ;  .
MOZL
       BSF     PORTB,2  ;  .
       CALL    UST256   ;   .
       TSTF    SC1      ;  ,
       SKPNZ            ; ,
       GOTO    MOZLO    ;   .
       BTFSC   FLAG1,1  ;  ,
       GOTO    MOZOL    ;   .
       BTFSS   COUS,0   ;  ,
       GOTO    MOZOL    ;   .
       DECF    SC1,1    ; 1  .
       BSF     FLAG1,1  ;  .
       BCF     PORTB,3  ;  .
MOZOL
       BTFSS   FLAG,1   ;    ,
       GOTO    MOZOL1   ;
       BSF     PORTB,3  ; .
       BCF     FLAG1,1  ;  .
MOZOL1
       CALL    UST256   ;   .
       TSTF    SC1      ;    ,
       SKPZ             ;
       GOTO    MOZL     ; .
MOZLO
       BTFSC   FLAG1,1  ;,   
       GOTO    MOZOL    ; .
       BSF     FLAG1,0  ;   .
       BTFSC   PORTB,4  ;   ,
       GOTO    ZOO      ; .
MOZH
       BSF     PORTB,3  ;  .
       CALL    UST256   ;   .
       TSTF    SC0      ;  ,
       SKPNZ            ;
       GOTO    MOZHO    ; .
       BTFSC   FLAG1,1  ;  ,
       GOTO    MOZOH    ;   .
       BTFSS   COUS,0   ;  ,
       GOTO    MOZOH    ;   .
       DECF    SC0,1    ; .
       BSF     FLAG1,1  ;  .
       BCF     PORTB,2  ;  .
MOZOH
       BTFSS   FLAG,1   ;    ,
       GOTO    MOZOH1   ;
       BSF     PORTB,2  ;  .
       BCF     FLAG1,1  ;  .
MOZOH1
       CALL    UST256   ;   .
       TSTF    SC0      ;    ,
       SKPZ             ;
       GOTO    MOZH     ; .
MOZHO
       BTFSC   FLAG1,1  ;,   
       GOTO    MOZOH    ; .
       BTFSC   PORTB,4  ;   ,
       CALL    USTW3    ;  .
       BCF     FLAG1,0  ;   .
       BCF     FLAG1,2  ;  2 .
       BTFSC   PORTB,4  ;   ,
       GOTO    ZOO      ;   .
       GOTO    HOKL     ;  .
;==========================================================
; 17. .     2-10  (2-_-2-10).
;==========================================================
BINDECH
       MOVLW   .10      ;10 >W.
BDH
       BSF     STATUS,0 ;  ""  STATUS.
       SUBWF   DSMH,1   ;   10 > DSMH.
       BNC     BINDECL  ;    .
       INCF    HSMH,1   ; 1   .
       GOTO    BDH      ;.                
BINDECL
       MOVF    DSMH,0   ;   
       ADDLW   .10      ;10+W >W.               
       MOVWF   LSMH     ;    .
       RETURN           ;
;==================================================================
; 18.       .
;===================================================================
CONST
       MOVWF  W_TEMP      ;   W 
       MOVFW  STATUS      ;STATUS,
       MOVWF  STATUS_TEMP ;
       MOVFW  FSR         ;FSR.
       MOVWF  FSR_TEMP    ;
       CALL   S1          ; 1  .
       BTFSC  FLAG1,5     ;   1 .
       CALL   KEY         ; .
RECONST                    ;  .
       BCF    INTCON,2    ;  .
       MOVFW  STATUS_TEMP ; :
       MOVWF  STATUS      ;STATUS,
       MOVFW  FSR_TEMP    ;
       MOVWF  FSR         ;FSR,
 ; MOVLW  .230
  ;MOVWF  TMR0
       MOVFW  W_TEMP      ;W.
       RETFIE             ;  .
;==================
; 19. .
;=================
S1
        INCF   COUS,1   ;+1  .
        BTFSS  COUS,0   ; ,
        BSF    FLAG,1   ;   1.
        BTFSC  COUS,0   ; ,
        BCF    FLAG,1   ;   0.
        MOVLW  .4       ;  1 ,
        SUBWF  COUS,0   ;4  1/4 .
        SKPZ            ;
        RETURN
        CLRF   COUS     ; .
        MOVFW  SEC1     ;  . .
        ADDLW  -3BH     ;   59.
        BZ     M1       ;  0,   ,   M1.
        INCF   SEC1,F   ; 1  .
        BTFSC  SEC1,0   ;   ,
        BSF    FLAG1,5  ;  1 .
        BTFSC  SEC1,1   ;   ,
        BSF    FLAG1,2  ;  2 .
        RETURN          ;
M1
        CLRF   SEC1     ;  .
        CALL   M5M      ;  5 .
M1M
        MOVFW  MIN1     ;   . .
        ADDLW  -3BH     ;-59.
        BZ     H1       ;  0,  ,   H1.
        INCF   MIN1,F   ; 1  .
        MOVFW  MIN1     ; .
MIU
        MOVWF  DSMH     ;W >DSMH.
        CALL   BINDECH  ;  .
        MOVFW  LSMH     ;LSMH >W .
        MOVWF  MIL      ;W > H_LOW     .
        MOVFW  HSMH     ;HSMH >W .
        MOVWF  MIH      ;W > H_HIGH      .
        CLRF   HSMH     ; . . .
        CLRF   LSMH     ; .
        RETURN   
H1
        CLRF   MIN1     ;   .
        CLRF   MIL      ;
        CLRF   MIH      ;
H1H
        MOVFW  HOU1     ;   . .
        ADDLW  -17H     ;- 23. 
        BZ     H10      ;  0,  ,   H10.
        INCF   HOU1,F   ; 1  .
        MOVFW  HOU1     ;HOU1 >W,  .
H1U
        MOVWF  DSMH     ;W >DSMH.
        CALL   BINDECH  ;  .
        MOVFW  LSMH     ;LSMH >W .
        MOVWF  HOL      ;W > H_LOW     .
        MOVFW  HSMH     ;HSMH >W .
        MOVWF  HOH      ;W > H_HIGH      .
        CLRF   HSMH     ; . . .
        CLRF   LSMH     ; .
        RETURN          ;
H10
        CLRF   HOU1     ;  .
        CLRF   HOL      ;  .
        CLRF   HOH      ;  .
        RETURN
M5M
        INCF   MIN5,1   ;+1   5 .
        MOVLW  .5       ;  5 ,
        SUBWF  MIN5,0   ;
        SKPNZ           ;
        BSF    FLAG,0   ;   .
        SKPNZ           ;
        CLRF   MIN5     ;  .
        RETURN
;==============================================
        END
;==============================================
;============================================================
; 10.      .
;============================================================
UST3
        CLRF    BUDO    ;  .
        MOVFW   BUL     ; 
        MOVWF   SC0     ; 
        MOVFW   BUH     ;   
        MOVWF   SC1     ;  .
        CALL    DECBIN  ;  , 
        ADDWF   BUL,0   ; 
        MOVWF   BUD     ;  .
        ADDWF   BUDM,0  ;   .
        MOVWF   BUDO    ;   .
        RETURN
USTM3
        CLRF    BUDO    ;  .
        MOVFW   BUML    ; 
        MOVWF   SC0     ; 
        MOVFW   BUMH    ;   
        MOVWF   SC1     ;  .
        CALL    DECBIN  ;  , 
        ADDWF   BUML,0  ; 
        MOVWF   BUDM    ;  .
        ADDWF   BUD,0   ;   .
        MOVWF   BUDO    ;   .
        RETURN
USTW3
        BTFSS   PORTB,4 ;   ,
        CALL    UST2S   ; ,  2 .
        MOVFW   MIL     ; 
        MOVWF   SC0     ; 
        MOVFW   MIH     ;  
        MOVWF   SC1     ;  .
        BTFSS   PORTB,4 ;  ,
        RETURN          ; .
        MOVFW   MIH     ;
        CALL    DECBIN  ;  ,
        ADDWF   MIL,0   ; 
        MOVWF   MIN1    ;  .
        RETURN
USTH3
        BTFSS   PORTB,4 ;   ,
        CALL    UST2S   ; ,  2 .
        MOVFW   HOL     ; 
        MOVWF   SC0     ; 
        MOVFW   HOH     ;  
        MOVWF   SC1     ;  .
        BTFSS   PORTB,4 ;  ,
        RETURN          ; .
        MOVFW   HOH     ;  ,
        CALL    DECBIN  ; 
        ADDWF   HOL,0   ;  .
        MOVWF   HOU1    ;:  + .
        RETURN
UST2S
        BTFSC   FLAG1,2 ;   2 .
        RETURN
        GOTO    UST2S   ;  2 .

        MOVLW   .255       ;   ,
        SUBWF   EEDATA,0   ; -0.
        BTFSC   STATUS,Z   ;
        CALL    AKTEO      ;

