; 
;    80 ,
; .
;   .
;   .
; ., .
; saes@mail.ru
;
;  = KABELPD.ASM
; : 08-03-03.
;   : MPLAB IDE, : 5.61.00.
;
            #include p16f84a.inc
            __CONFIG 3FF1H
;=========================================
;    4,0 .
;=========================================
; RB0=1, RB1=2, RB2=3, RB4=4, RB5=6, RB6=7, RB7=8,
; RA3=9, RA4=10, RA0-RA2 -  .
;=========================================
;  .
;=========================================
INDF     EQU  00H  ;    FSR.
TIMER0   EQU  01H  ;TMR0.
OPTIONR  EQU  81H  ;OPTION (RP0=1).
PC       EQU  02H  ; .
STATUS   EQU  03H  ;  .
FSR      EQU  04H  ;  .
PORTA    EQU  05H  ;  /.
PORTB    EQU  06H  ;  /.
TRISA    EQU  85H  ;   .
TRISB    EQU  86H  ;   .
INTCON   EQU  0BH  ;  .
;===========================================
;  .
;===========================================
SC0        EQU  0CH   ;   .
SC1        EQU  0DH   ;
SC2        EQU  0EH   ;
SC3        EQU  0FH   ;
SC4        EQU  10H   ;
SC5        EQU  11H   ;
SC6        EQU  12H   ;
SC7        EQU  13H   ;
SC8        EQU  14H   ;
SC9        EQU  15H   ; .
COU        EQU  16H   ; .
SMC        EQU  17H   ; .
ANOD       EQU  18H   ; .
;========================================
;  .
;========================================
W_TEMP      EQU  19H  ;   W  .
STATUS_TEMP EQU  1AH  ;   STATUS  .
FSR_TEMP    EQU  1BH  ;  FSR.
;=========================
; 1. .   
;=========================
        ORG 0
           GOTO INIT 

        ORG 4
           GOTO CONST
;======================
; 2. .
;======================
INIT
 BSF   STATUS,RP0       ;   1.
 MOVLW B'00000100'      ;  , =32 ...100,
 MOVWF OPTION_REG^80H   ;  .
 MOVLW B'10100000'      ;  =   .
 MOVWF INTCON           ;
 MOVLW B'00000000'      ; RA0-RA4- .
 MOVWF TRISA^80H
 MOVLW B'00000000'      ; RB0-RB7- .
 MOVWF TRISB^80H
 BCF   STATUS,RP0       ;   0.
 CLRF  TMR0             ;   
 CLRF  SC0
 CLRF  SC1
 CLRF  SC2
 CLRF  SC3
 CLRF  SC4
 CLRF  SC5
 CLRF  SC6
 CLRF  SC7
 CLRF  SC8
 CLRF  SC9
 GOTO  IDOO         ;   .
;======================================
; 3.  .
;======================================
DES
        ADDWF   PC,1
        RETLW   .0
        RETLW   .10
        RETLW   .20
        RETLW   .30
        RETLW   .40
        RETLW   .50
        RETLW   .60
        RETLW   .70
;========================================
; 4.  .
;========================================
IDOO
        CLRF    ANOD     ; .
IDAO
        MOVFW   ANOD     ;  
        MOVWF   PORTA    ;  .
;==============================================
ID0
        BSF     INTCON,7 ; .
        MOVLW   .1       ; 
        MOVWF   SC0      ;  .
        MOVFW   ANOD     ;
        CALL    DES      ;.
        ADDWF   SC0,1    ;.
ID0Z
        TSTF    SC0      ;
        SKPNZ            ; ,
        GOTO    ID0I     ;  .
        DECF    SC0,1    ; 1  .
        BSF     PORTB,0  ; .
        CALL    ID200    ; ,   .
        BCF     PORTB,0  ; .
        CALL    ID200    ; ,   .
        GOTO    ID0Z     ; .
ID0I
        BTFSC   INTCON,7 ; .
        GOTO    ID0I     ;  .
;=========================================
ID1
        BSF     INTCON,7 ; 9  
        MOVLW   .2       ; .
        MOVWF   SC1      ;
        MOVFW   ANOD     ;
        CALL    DES      ;
        ADDWF   SC1,1    ;
ID1Z
        TSTF    SC1      ;
        SKPNZ            ;
        GOTO    ID1I     ;
        DECF    SC1,1    ;
        BSF     PORTB,1  ; .
        CALL    ID200
        BCF     PORTB,1  ; .
        CALL    ID200
        GOTO    ID1Z     ;
ID1I
        BTFSC   INTCON,7 ;
        GOTO    ID1I     ;
;=========================================
ID2
        BSF     INTCON,7 ;
        MOVLW   .3
        MOVWF   SC2
        MOVFW   ANOD
        CALL    DES
        ADDWF   SC2,1
ID2Z
        TSTF    SC2      ;
        SKPNZ            ;
        GOTO    ID2I     ;
        DECF    SC2,1    ;
        BSF     PORTB,2  ; .
        CALL    ID200
        BCF     PORTB,2  ; .
        CALL    ID200
        GOTO    ID2Z     ;
ID2I
        BTFSC   INTCON,7 ;
        GOTO    ID2I     ;
;=========================================
ID3
        BSF     INTCON,7 ;
        MOVLW   .4
        MOVWF   SC3
        MOVFW   ANOD
        CALL    DES
        ADDWF   SC3,1
ID3Z
        TSTF    SC3      ;
        SKPNZ            ;
        GOTO    ID3I     ;
        DECF    SC3,1    ;
        BSF     PORTB,3  ; .
        CALL    ID200
        BCF     PORTB,3  ; .
        CALL    ID200
        GOTO    ID3Z     ;
ID3I
        BTFSC   INTCON,7 ;
        GOTO    ID3I     ;
;=========================================
ID4
        BSF     INTCON,7 ;
        MOVLW   .5
        MOVWF   SC4
        MOVFW   ANOD
        CALL    DES
        ADDWF   SC4,1
ID4Z
        TSTF    SC4      ;
        SKPNZ            ;
        GOTO    ID4I     ;
        DECF    SC4,1    ;
        BSF     PORTB,4  ; .
        CALL    ID200
        BCF     PORTB,4  ; .
        CALL    ID200
        GOTO    ID4Z     ;
ID4I
        BTFSC   INTCON,7 ;
        GOTO    ID4I     ;
;=========================================
ID5
        BSF     INTCON,7 ;
        MOVLW   .6
        MOVWF   SC5
        MOVFW   ANOD
        CALL    DES
        ADDWF   SC5,1
ID5Z
        TSTF    SC5
        SKPNZ
        GOTO    ID5I
        DECF    SC5,1
        BSF     PORTB,5  ; .
        CALL    ID200
        BCF     PORTB,5  ; .
        CALL    ID200
        GOTO    ID5Z     ; .
ID5I
        BTFSC   INTCON,7
        GOTO    ID5I
;=========================================
ID6
        BSF     INTCON,7
        MOVLW   .7
        MOVWF   SC6
        MOVFW   ANOD
        CALL    DES
        ADDWF   SC6,1
ID6Z
        TSTF    SC6
        SKPNZ
        GOTO    ID6I
        DECF    SC6,1
        BSF     PORTB,6  ; .
        CALL    ID200
        BCF     PORTB,6  ; .
        CALL    ID200
        GOTO    ID6Z
ID6I
        BTFSC   INTCON,7
        GOTO    ID6I
;=========================================
ID7
        BSF     INTCON,7
        MOVLW   .8
        MOVWF   SC7
        MOVFW   ANOD
        CALL    DES
        ADDWF   SC7,1
ID7Z
        TSTF    SC7
        SKPNZ
        GOTO    ID7I
        DECF    SC7,1
        BSF     PORTB,7  ; .
        CALL    ID200
        BCF     PORTB,7  ; .
        CALL    ID200
        GOTO    ID7Z
ID7I
        BTFSC   INTCON,7
        GOTO    ID7I
;=========================================
ID8
        BSF     INTCON,7
        MOVLW   .9
        MOVWF   SC8
        MOVFW   ANOD
        CALL    DES
        ADDWF   SC8,1
ID8Z
        TSTF    SC8
        SKPNZ
        GOTO    ID8I
        DECF    SC8,1
        BSF     PORTA,3  ; .
        CALL    ID200
        BCF     PORTA,3  ; .
        CALL    ID200
        GOTO    ID8Z
ID8I
        BTFSC   INTCON,7
        GOTO    ID8I
;=========================================
ID9
        BSF     INTCON,7
        MOVLW   .10
        MOVWF   SC9
        MOVFW   ANOD
        CALL    DES
        ADDWF   SC9,1
ID9Z
        TSTF    SC9
        SKPNZ
        GOTO    ID9I
        DECF    SC9,1
        BSF     PORTA,4  ; .
        CALL    ID200
        BCF     PORTA,4  ; .
        CALL    ID200
        GOTO    ID9Z
ID9I
        BTFSC   INTCON,7
        GOTO    ID9I
;==========================================
IDA
        INCF    ANOD,1   ; .
        MOVLW   .8       ;  80.
        SUBWF   ANOD,0   ;.
        BTFSC   STATUS,2 ; ,
        GOTO    IDOO     ;  .
        GOTO    IDAO     ;  .
;===========================
; 5. .
;===========================
ID200
        MOVLW  .3     ; 24 .
        MOVWF  COU    ;
PAUSA
        DECF   COU,1  ; 1.
        NOP
        TSTF   COU    ;  .
        SKPZ          ;   ,
        GOTO   PAUSA  ;.
        RETURN
;===================================================================
; 6.       .
;===================================================================
CONST
        MOVWF  W_TEMP      ;   W 
        MOVFW  STATUS      ;STATUS,
        MOVWF  STATUS_TEMP ;
        MOVFW  FSR         ;FSR.
        MOVWF  FSR_TEMP    ;
        CALL   S1          ; 1  .

RECONST                    ;  .
        BCF    INTCON,2    ;  (T0IF)  .
        MOVFW  STATUS_TEMP ; :
        MOVWF  STATUS      ;STATUS,
        MOVFW  FSR_TEMP    ;
        MOVWF  FSR         ;FSR,
        MOVLW  .119        ;  ,   
        MOVWF  TMR0        ;  80  .
        MOVFW  W_TEMP      ;W.
        RETURN             ;  .
;============================
; 7.  .
;============================
S1
        INCF  SMC,1    ;   .
        RETURN
;==============================================
        END
;==============================================
