;
;  . .
;     28 .
; 2  .
; 
;   .
;   .
; ., .
; saes@mail.ru
;
;  = KABELPM.ASM
; : 08-03-03.
;   : MPLAB IDE, : 5.61.00.
;
            #include p16f84a.inc
            __CONFIG 3FF2H
;======================================
;    4,0 .
; RB0 - .
; RA0, RA1 -  .
; RB1-RB7 -  .
;======================================
;  .
;================
INDF     EQU  00H  ;    FSR.
TIMER0   EQU  01H  ;TMR0.
OPTIONR  EQU  81H  ;OPTION (RP0=1).
PC       EQU  02H  ; .
STATUS   EQU  03H  ;  .
FSR      EQU  04H  ;  .
PORTA    EQU  05H  ;  /.
PORTB    EQU  06H  ;  /.
TRISA    EQU  85H  ;   .
TRISB    EQU  86H  ;   .
INTCON   EQU  0BH  ;  .
;=================================
;   .
;=================================
SC0      EQU  0CH  ;  .
SC1      EQU  0DH  ; .
SC00     EQU  0EH  ;  .
SC11     EQU  0FH  ;  
ANOD     EQU  10H  ;.
SEG      EQU  11H  ; .
COU3     EQU  12H  ; .
COU      EQU  14H  ;
;====================
;  .
;====================
W_TEMP      EQU  021H  ;   W  .
STATUS_TEMP EQU  022H  ;   STATUS  .
FSR_TEMP    EQU  023H  ;  FSR.
;==================
; 1. .
;==================
        ORG 0
           GOTO INIT 
        ORG 4
           GOTO CONST
;==================
; 2. .
;==================
INIT
 BSF   STATUS,RP0       ;   1.
 MOVLW B'01000100'      ;  , =32 ...100.
 MOVWF OPTION_REG^80H   ;
 MOVLW B'10110000'      ;  =    , 0.
 MOVWF INTCON           ;
 MOVLW B'00000000'      ; -  .
 MOVWF TRISA^80H
 MOVLW B'00000001'      ; RB1-RB7- , RB0-.
 MOVWF TRISB^80H
 BCF   STATUS,RP0       ;   0. 
 CLRF  TMR0             ;   
 CLRF  SC0
 CLRF  SC1
 CLRF  SC00
 CLRF  SC11
 CLRF  COU3
 CLRF  COU
 CLRF  SEG
 GOTO  ZS0         ;  .
;========================================
; 3.     .
;========================================
SEGDATA                      ;  7, 6, 5, 4, 3, 2, 1, 0.
         ADDWF   PCL,F       ;  G, F, E, D, C, B, A, IN.
;        :               
         RETLW   B'01111110' ;   B'1000000'  0 
         RETLW   B'00001100' ;   B'1111001'  1 
         RETLW   B'10110110' ;   B'0100100'  2 
         RETLW   B'10011110' ;   B'0110000'  3 
         RETLW   B'11001100' ;   B'0011001'  4 
         RETLW   B'11011010' ;   B'0010010'  5 
         RETLW   B'11111010' ;   B'0000010'  6 
         RETLW   B'00001110' ;   B'1111000'  7 
         RETLW   B'11111110' ;   B'0000000'  8 
         RETLW   B'11011110' ;   B'0010000'  9 
;==============================================
; 4. . .
;============================================== 
ZS0
        CLRF    ANOD      ;  .
        BSF     ANOD,1 
        MOVFW   SC00      ;    
        CALL    INDZIKL   ;   .
        CALL    MC4       ; 5 .
ZS1
        CLRF    ANOD
        BSF     ANOD,0
        MOVFW   SC11      ;  .
        CALL    INDZIKL   ;
        CALL    MC4       ; 5 .
        GOTO    ZS0       ; .
INDZIKL
        CALL    SEGDATA   ;  .
        MOVWF   PORTB     ;    B   .
        MOVFW   ANOD      ;  
        MOVWF   PORTA     ;  .
        RETURN
MC4
        CLRF    COU3
        MOVLW   .200      ;   5 .
        MOVWF   COU3
MC2
        DECF    COU3,1    ; 1  .
        SKPNZ             ;  ,
        RETURN            ;.
        MOVLW   .5        ;5200
MC1
        ADDLW   -01H
        BNZ     MC1
        GOTO    MC2      ;   .
;===================================
; 5.    .
;===================================
SEC
        INCF   COU,1
        MOVLW  .80       ;  1 ,
        SUBWF  COU,0   ;4  0,25,
        SKPZ            ;
        RETURN
        CLRF   COU
        MOVFW  SC0
        MOVWF  SC00
        MOVFW  SC1
        MOVWF  SC11
        CLRF   SC0
        CLRF   SC1
        RETURN
;==================================================================
; 6.       .
;===================================================================
CONST
        MOVWF  W_TEMP      ;   W 
        MOVFW  STATUS      ;STATUS,
        MOVWF  STATUS_TEMP ;
        MOVFW  FSR         ;FSR.
        MOVWF  FSR_TEMP    ;
        BTFSC  INTCON,1
        GOTO   S01         ; 1  .
        CALL   SEC
RECONST                    ;  .
        BCF    INTCON,2    ;    .
        BCF    INTCON,1    ;     R0.
        MOVFW  STATUS_TEMP ; :
        MOVWF  STATUS      ;STATUS,
        MOVFW  FSR_TEMP    ;
        MOVWF  FSR         ;FSR,
        MOVLW  .120        ;    
        MOVWF  TMR0        ; .
        MOVFW  W_TEMP      ;W.
        RETFIE             ;  .
;=================
; 7. .
;=================
S01
        CLRF   TMR0      ;   .
        MOVLW  .9        ;  9,
        SUBWF  SC0,0
        BC     S10       ;   .
        INCF   SC0,1     ;  .
        GOTO   RECONST
S10
        CLRF   SC0
        MOVLW  .9        ;  9,
        SUBWF  SC1,0
        BC     SOO       ;  .
        INCF   SC1,1     ;  .
        GOTO   RECONST
SOO
        CLRF   SC0
        CLRF   SC1
        GOTO   RECONST
;=============================================
        END
;==============================================

