;
;  .
; 3    304.
;  ,   999.
;   9.99,  99.9,  999. .
;   .
;    .
;     .
;
;   .
;    .
; .,  .
; saes@mail.ru
;
;  = KUXTIM.ASM
;  : 10-11-02 (: 10.11.02).
;   : MPLAB IDE, : 5.61.00.
;
            #INCLUDE P16F84A.INC
            __CONFIG 3FF0H
;_______________________________________________
;     32768 .
;     32,  
;  TMR0 (256)  ,  4 ,
;     1  (432256=32768).
;_________________________________________________
;   .
;__________________________________________________
INDF     EQU  00H  ;    FSR.
TMR0     EQU  01H  ;.
OPTIONR  EQU  81H  ;(RP0=1)   .
PCL      EQU  02H  ; .
STATUS   EQU  03H  ; .
FSR      EQU  04H  ;  .
PORTA    EQU  05H  ;  /.
PORTB    EQU  06H  ;  /.
TRISA    EQU  85H  ;   .
TRISB    EQU  86H  ;   .
EEDATA   EQU  08H  ; .
EECON1   EQU  88H  ; - .
EEADR    EQU  09H  ; .
EECON2   EQU  89H  ; - .
INTCON   EQU  0BH  ;  .
;__________________________________________
;   .
;__________________________________________
SEC0        EQU  0CH   ;  .
SEC1        EQU  0DH   ; .
SEC2        EQU  0EH   ; .
CAT         EQU  0FH   ; .
;_________________________________________
;     .
;_________________________________________
FLAG        EQU  020H   
;  :
;     0-> .
;     1->  .
;     2->  .
;     3->   .
;     4-> 
;     5-> :  - .
;     6->   .
;     7-> .
;____________________________
FLA         EQU  021H
;   :
;     0->  .
;     1-> .
;     2-> .
;     3->   .
;     4->
;     5->
;     6->
;     7->
;________________________________________________
;   .
;________________________________________________
SECL        EQU  010H  ;  .  
SECH        EQU  011H  ;   .
MINL        EQU  012H  ;  .
MINH        EQU  013H  ;  .
HOUL        EQU  014H  ;  .
HOUH        EQU  015H  ;  .
DEYL        EQU  016H  ;  .
ANOD        EQU  017H  ;.
SEGD        EQU  018H  ;.

;
; : , .
;
PAUSA       EQU  019H  ;     .
PAUSI       EQU  01AH  ;   .
COU         EQU  01BH  ;  .
ABC         EQU  01CH  ;  .
W_TEMP      EQU  01DH  ;   W  .
STATUS_TEMP EQU  01EH  ;   STATUS  .
FSR_TEMP    EQU  01FH  ;  FSR.
SEC         EQU  022H  ;  .
COUI        EQU  023H  ;  .
;___________________________________________________________________
; 1. .   
;____________________________________________________________________
        ORG 0
           GOTO INIT
        ORG 4
           GOTO   CONST         ;
;____________________________________________________________________
; 2. .
;______________________________________________________________________
INIT
 BSF   STATUS,RP0       ;   1.
 MOVLW B'00000100'      ;  , =32 ...100,
 MOVWF OPTION_REG^80H   ;  .
 MOVLW B'10100000'      ;  = TMR0.
 MOVWF INTCON           ;
 MOVLW B'00001000'      ; RA0-RA2, RA4 -  , RA3 - .
 MOVWF TRISA^80H
 MOVLW B'00000000'      ;RB0- RB7-
 MOVWF TRISB^80H
 BCF   STATUS,RP0       ;   0. 
 CLRF  FLAG             ;  
 CLRF  FLA
 CLRF  TMR0             ;   
 CLRF  SEC0
 CLRF  SEC1
 CLRF  SEC2
 CLRF  SECL
 CLRF  SECH
 CLRF  MINL
 CLRF  MINH
 CLRF  HOUL
 CLRF  HOUH
 CLRF  DEYL
 CLRF  PAUSA
 CLRF  PAUSI
 CLRF  COU
 CLRF  COUI
 CLRF  ABC
 MOVLW .1           ;
 MOVWF CAT          ; .
 GOTO   INDZIKL0    ;

;_______________________________________________________________
; 3.    .
;________________________________________________________________
KEY
        BTFSS  PORTB,7     ;   ( ),
        GOTO   KEY3        ;   .
        BTFSS  PORTB,6     ;  
        BSF    FLAG,1      ;
        BTFSS  PORTB,5     ;
        BSF    FLAG,2      ;.
        TSTF   FLAG        ;   ,
        BZ     KEY2        ;     .
        CLRF   PAUSA       ;  .
        GOTO   RECONST     ;
KEY2
        BCF    STATUS,2    ;
        INCF   PAUSA,1     ; 256   
        BTFSC  STATUS,2    ;  ,
        BSF    FLA,0       ;   .
        GOTO   RECONST     ; .
KEY3
        BSF    FLAG,0      ;  .
        GOTO   IND         ;     .

;__________________________________________________
; 4.   .
;_________________________________________________
CATI
        TSTF   CAT         ;    ,
        BZ     CATO        ; .
        BCF    STATUS,0    ; ,     0.
        RLF    CAT,1       ;   1  .
        BTFSS  CAT,3       ;   3 ,
        GOTO   RECONST     ;
        CLRF   CAT         ;  
        BSF    CAT,0       ; .
        GOTO   IND         ; .
CATO
        BSF    CAT,0       ;  .
        GOTO   RECONST     ;
;__________________________________________________
; 5.   .
;___________________________________________________
SEGDATA                      ;7, 6, 5, 4, 3, 2, 1, 0.
         ADDWF   PCL,F       ;H, G, F, E, D, C, B, A.
;                               
         RETLW   B'11000000' ; 0 B'0111111'
         RETLW   B'11111001' ; 1 B'0000110'
         RETLW   B'10100100' ; 2 B'1011011'
         RETLW   B'10110000' ; 3 B'1001111'
         RETLW   B'10011001' ; 4 B'1100110'
         RETLW   B'10010010' ; 5 B'1101101'
         RETLW   B'10000010' ; 6 B'1111101'
         RETLW   B'11111000' ; 7 B'0000111'
         RETLW   B'10000000' ; 8 B'1111111'
         RETLW   B'10010000' ; 9 B'1101111'
;________________________________________
; 6. .
;_________________________________________ 
INDZIKL0
         BSF     INTCON,7   ;   .
         BTFSC   FLA,0      ;    , 
         GOTO    MRAK       ;  .
         CLRF    ANOD       ; ,    .
         BSF     ANOD,0     ; .  .
         BTFSS   FLAG,0     ;   ,
         GOTO    ZIKLS      ;  .
         BTFSC   CAT,1      ;    ,
         GOTO    ZIKLM      ;  .
         BTFSC   CAT,2      ;    ,
         GOTO    ZIKLH      ;  .
ZIKLS
         MOVLW   010H       ;   .  
         MOVWF   SEGD       ;   .
         GOTO    ZIKLC      ;
ZIKLM
         MOVLW   012H       ; .  
         MOVWF   SEGD       ;   .
         GOTO    ZIKLC      ;
ZIKLH
         MOVLW   014H       ; .  .
         MOVWF   SEGD       ;   .
ZIKLC
         BTFSS   FLAG,5     ;   
         GOTO    ZIKLA      ;
         INCF    COUI,1     ;+1   .
         MOVLW   .150       ;150    ,
         SUBWF   COUI,0     ;  .
         BZ      COUZ       ;
         BTFSS   FLA,3      ;    0,
         GOTO    ZIKLA      ; .
         GOTO    ZIKLF      ;   .
COUZO
         BCF      FLA,3     ;  .
ZIKLA
         MOVFW   ANOD       ;  
         SUBWF   CAT,0      ;  .
         BTFSC   STATUS,2   ;  ,
         BSF     FLA,1      ;  .
         GOTO    ZIKLF      ;.
COUZ
         CLRF     COUI      ;   .
         BTFSC    FLA,3     ;,  0.
         GOTO     COUZO     ;      .
         BSF      FLA,3     ;  .
ZIKLF

         BTFSC   FLA,2      ;  ,
         BCF     ANOD,4     ;     (0-).
         BTFSS   FLA,2      ;  ,
         BSF     ANOD,4     ;    .
         MOVFW   SEGD       ; 
         MOVWF   FSR        ;   .
         MOVFW   INDF       ; 2-10 .
         CALL    SEGDATA    ;    
         MOVWF   PORTB      ;  .
         BTFSC   FLA,1      ;   ,
         BCF     PORTB,7    ;  .
         BTFSC   FLA,3      ;   =1,
         BCF     PORTB,7    ;  .
         MOVFW   ANOD       ;  .
         MOVWF   PORTA      ;  .
         BCF     FLA,1      ;  .
         BCF     ANOD,4     ;  ,    .
         BCF     STATUS,0   ;,     . .
         RLF     ANOD,1     ; 1   1  .
         BTFSC   ANOD,3     ;    3 ,
         GOTO    INDZIKL0   ; .
         INCF    SEGD,F     ;+1    .
         GOTO    ZIKLC      ; .
MRAK
         MOVLW   0FFH       ; .
         MOVWF   PORTB      ;
         BTFSS   FLA,0      ;  ,
         GOTO    INDZIKL0   ; .
         BTFSC   FLA,2      ;  ,
         GOTO    MRAKI      ;  .
         BSF    INTCON,7    ;   .
         GOTO    MRAK       ;.
MRAKI
         BCF     FLA,0      ; .
         GOTO    INDZIKL0   ; .
;___________________________________
; 7.   .
;__________________________________
AKT
         BCF     FLAG,7     ;  .
         CLRF    EEADR      ; .
         CALL    AKTETE     ;  .
         MOVWF   SEC0       ;   .
         INCF    EEADR,1    ;1 .
         CALL    AKTETE     ;  .
         MOVWF   SEC1       ;   .
         INCF    EEADR,1    ;2 .
         CALL    AKTETE     ;  .
         MOVWF   SEC2       ;   .
         INCF    EEADR,1    ;3 .
         CALL    AKTETE     ;  .
         MOVWF   CAT        ;   .
         CLRF    EEADR      ; .
         GOTO    IND        ; .
AKTETE
         BSF     STATUS,RP0 ; 1.
         BSF  EECON1^80H,RD ;.
         BCF     STATUS,RP0 ; 0.
         MOVLW   .255       ;   ,
         SUBWF   EEDATA,0   ; -0.
         BTFSC   STATUS,Z   ;
         CALL    AKTEO      ;
         MOVFW   EEDATA     ; .
         RETURN
AKTEO
         CLRF    EEDATA     ;
         RETURN
;__________________________________
; 8.   .
;__________________________________
ZAPISO
         CLRF    EEADR        ; .
         MOVLW   0CH          ;    EEDATA.
         MOVWF   ABC          ;  .
ZAPISE
         MOVFW   ABC          ;  
         MOVWF   FSR          ; 
         MOVFW   INDF         ;.
         MOVWF   EEDATA       ;.
         BCF     INTCON,GIE   ; .
         BSF     STATUS,RP0   ; 1.
         BSF     EECON1^80H,WREN ; .
         MOVLW   55H          ; 
         MOVWF   EECON2^80H   ;/
         MOVLW   0AAH         ;/
         MOVWF   EECON2^80H   ;/
         BSF     EECON1^80H,WR ;    .
ZAPIZ
         BTFSS   EECON1^80H,4 ;    
         GOTO    ZAPIZ        ;  .
         BCF     EECON1^80H,4 ;
         BCF     EECON1^80H,WREN ; .2
         BCF     STATUS,RP0   ; 0.
         INCF    EEADR,1      ;
         MOVFW   EEADR        ;  4,
         SUBLW   .4           ;
         BZ      EEOO         ;  .
         INCF    ABC,1        ;+1   .
         GOTO    ZAPISE       ;    .
EEOO
         CLRF    EEADR        ; 
         BCF     FLAG,3       ; .
         GOTO    RECONST      ;
;________________________________
; 9.  - .
;________________________________

MINUS
         BCF      FLAG,2     ;  .
         BTFSC    CAT,1      ;    ,
         GOTO     MINUS1     ;   .
         BTFSC    CAT,2      ;    ,
         GOTO     MINUS2     ;   .
;
         DECF     SEC0,1     ;-1    .
         MOVLW    .255       ;   0,   =255.
         SUBWF    SEC0,0     ;  0, 
         BZ       MINUS9     ;  9   .
         GOTO     IND        ;   .
MINUS9
         MOVLW    .9         ;
         MOVWF    SEC0       ; 9   .
         GOTO     IND        ;   .
MINUS1
         DECF     SEC1,1       ;-1    .
         MOVLW    .255       ;   0,   =255.
         SUBWF    SEC1,0     ;  0, 
         BZ       MINUS19    ;  9   .
         GOTO     IND        ;   .
MINUS19
         MOVLW    .9         ;
         MOVWF    SEC1       ; 9   .
         GOTO     IND        ;   .
MINUS2
         DECF     SEC2,1       ;-1    .
         MOVLW    .255       ;   0,   =255.
         SUBWF    SEC2,0     ;  0, 
         BZ       MINUS29    ;  9   .
         GOTO     IND        ;   .
MINUS29
         MOVLW    .9         ;
         MOVWF    SEC2       ; 9   .
         GOTO     IND        ;   .
;_________________________________
; 10.  - .
;_________________________________
PLUS
         BCF      FLAG,1     ;  .
         BTFSC    CAT,1      ;    ,
         GOTO     PLUS1      ;   .
         BTFSC    CAT,2      ;    ,
         GOTO     PLUS2      ;   .
;
         INCF     SEC0,1     ;+1  .
         MOVLW    .10        ;   10, 
         SUBWF    SEC0,0     ;
         BZ       PLUS0      ; .
         GOTO     IND        ;   .
PLUS0
         CLRF     SEC0       ;
         GOTO     IND        ;   .
PLUS1
         INCF     SEC1,1       ;+1  .
         MOVLW    .10        ;   10, 
         SUBWF    SEC1,0     ;
         BZ       PLUS10     ; .
         GOTO     IND        ;   .
PLUS10
         CLRF     SEC1       ;
         GOTO     IND        ;   .
PLUS2
         INCF     SEC2,1       ;+1  .
         MOVLW    .10        ;   10, 
         SUBWF    SEC2,0     ;
         BZ       PLUS20     ; .
         GOTO     IND        ;   .
PLUS20
         CLRF     SEC2       ;
         GOTO     IND        ;   .


;_______________________________________________________________________________
; 11.    .
;________________________________________________________________________________ 
IND
         BTFSS    FLAG,0     ;  ,
         GOTO     INDS       ;  .
         BTFSC    CAT,1      ;    ,
         GOTO     INDM       ;  .
         BTFSC    CAT,2      ;    ,
         GOTO     INDH       ;  .
INDS
         CLRF     DEYL       ; 
         CLRF     HOUH       ; .
         CLRF     HOUL       ;
         CLRF     MINH       ;
         MOVFW    SEC0       ; .  
         MOVWF    SECL       ;  .  .
         MOVFW    SEC1       ; .  
         MOVWF    SECH       ;  .  .
         MOVFW    SEC2       ; .  
         MOVWF    MINL       ;  .  .
         GOTO     RECONST    ;
INDM
         CLRF     SECL       ; 
         CLRF     SECH       ; .
         CLRF     HOUH       ;  .
         CLRF     DEYL       ;
         MOVFW    SEC0       ; .  
         MOVWF    MINL       ;  .  .
         MOVFW    SEC1       ; .  
         MOVWF    MINH       ;  .  .
         MOVFW    SEC2       ; .  
         MOVWF    HOUL       ;  .  .
         GOTO     RECONST    ;
INDH
         CLRF     SECL       ; 
         CLRF     SECH       ;
         CLRF     MINL       ;.
         CLRF     MINH       ;
         MOVFW    SEC0       ; .  
         MOVWF    HOUL       ;  .  .
         MOVFW    SEC1       ; .  
         MOVWF    HOUH       ;  .  .
         MOVFW    SEC2       ; .  
         MOVWF    DEYL       ;  .  .
         GOTO     RECONST    ;
;____________________________________________________________________
; 12. .
;__________________________________________________________________
STOP
         BTFSC    FLA,2     ;  ,
         GOTO     STOPO     ;  .
         CLRF     FLAG      ;    ,
         CLRF     FLA       ; .
         BTFSS    PORTB,6   ;    ,
         BSF      FLAG,3    ;  .
         BTFSS    PORTB,5   ;    ,
         BSF      FLAG,7    ;  .
         BTFSS    PORTA,3   ;    .,
         BSF      FLAG,5    ;   .
         TSTF     FLAG      ;  ,
         BTFSC    STATUS,2  ;
         CLRF     PAUSA     ; .
         GOTO     RECONST   ;
STOPO
         BCF      FLA,2     ;  .
         BTFSC    FLAG,0    ;   (  ),
         GOTO     SL        ;  .
         GOTO     RECONST   ;  .
;_______________________________________________
; 13.       .
;__________________________________________________________________
CONST
         MOVWF  W_TEMP      ;   W 
         MOVFW  STATUS      ;STATUS,
         MOVWF  STATUS_TEMP ;
         MOVFW  FSR         ;FSR.
         MOVWF  FSR_TEMP    ;
         BSF    STATUS,5    ; 1.
         MOVLW  B'11110000' ;  RB4-RB7
         MOVWF  TRISB^80H   ;   .
         MOVLW  B'10100000' ;
         MOVWF  INTCON      ;
         BCF    STATUS,5    ; 0.
         BTFSS  PORTB,4     ;   "",
         GOTO   STOP        ;  .
         BTFSC  FLAG,0      ;   =1,
         GOTO   SL          ;  .
         BTFSS  PORTA,3     ;   ,
         GOTO   CATI        ;  .
         BTFSC  FLAG,3      ;   ,
         GOTO   ZAPISO      ;  .
         BTFSC  FLAG,1      ;   ,
         GOTO   PLUS        ;  .
         BTFSC  FLAG,2      ;   ,
         GOTO   MINUS       ;  .
         BTFSC  FLAG,7      ;   ,
         GOTO   AKT         ; .
         GOTO   KEY         ;  .

RECONST                     ;  .
         BSF    STATUS,5    ; 1.
         MOVLW  B'00000000' ;   .
         MOVWF  TRISB^80H   ;
         BCF    STATUS,5    ; 0.
         MOVFW  STATUS_TEMP ; :
         MOVWF  STATUS      ;STATUS,
         MOVFW  FSR_TEMP    ;
         MOVWF  FSR         ;FSR,
         MOVFW  W_TEMP      ;W.
         RETFIE             ;  .
;______________________________________________________________
; 14.    .
;______________________________________________________________
SL
         BTFSS PORTB,7      ;   ,
         BCF   FLA,0        ; .
         TSTF  SECL         ;    ,
         BZ    SH           ;   .
         DECF  SECL,F       ; -1   . .
         GOTO  RECONST      ;
SH
         BCF   STATUS,2     ;   .
         TSTF  SECH         ;    ,
         BZ    ML           ;   .
         MOVLW .9           ;
         MOVWF  SECL        ;  .  .
         DECF  SECH,F       ;-1    .
         GOTO  RECONST      ; .
ML
         BCF   STATUS,2     ;   .
         TSTF  MINL         ;    ,
         BZ    MH           ;   .
         MOVLW .9           ;
         MOVWF  SECL        ;  .  .
         MOVLW .5           ;
         MOVWF SECH         ;
         DECF  MINL,F       ;-1  . .
         GOTO  RECONST      ; .
MH
         BCF   STATUS,2     ;   .
         TSTF  MINH         ;     ,
         BZ    HL           ;   .
         MOVLW .9           ;
         MOVWF SECL         ;  .   
         MOVWF MINL         ;  .  .
         MOVLW .5           ;
         MOVWF SECH         ;  .  .
         DECF  MINH,F       ;-1    .  .
         BSF   FLA,0        ; .
         GOTO  RECONST      ; .
HL
         BCF   STATUS,2     ;   .
         TSTF  HOUL         ;    ,
         BZ    HH           ;   .
         MOVLW .9           ;
         MOVWF SECL         ;  .   
         MOVWF MINL         ;  .  .
         MOVLW .5           ;
         MOVWF SECH         ;  .   
         MOVWF MINH         ;  .  .
         DECF  HOUL,F       ;-1  .  .
         GOTO  RECONST      ; .
HH
         BCF   STATUS,2     ;   .
         TSTF  HOUH         ;     ,
         BZ    DL           ;  .
         MOVLW .9           ;
         MOVWF SECL         ;  .  ,
         MOVWF MINL         ;  .  ,
         MOVWF HOUL         ;  .  .
         MOVLW .5           ;
         MOVWF SECH         ;  .   
         MOVWF MINH         ;  .  .
         DECF  HOUH,F       ;-1     .
         GOTO  RECONST      ; .
DL
         BCF   STATUS,2     ;   .
         TSTF  DEYL         ;    ,
         BZ    TUS0         ;  .
         MOVLW .9           ; 
         MOVWF  SECL        ;  .  ,
         MOVWF MINL         ;  .  ,
         MOVLW .5           ;
         MOVWF SECH         ;  .   
         MOVWF MINH         ;  .  .
         MOVLW .2           ;
         MOVWF HOUH         ;  .  .
         MOVLW .3           ;
         MOVWF HOUL         ;  .  .
         DECF  DEYL,F       ;-1   .
         GOTO  RECONST      ; .
TUS0
         BTFSC FLAG,5       ;   ,
         GOTO  NEPER        ;.
         BSF   FLA,2        ;  .
         BCF   FLAG,0       ;  .
         GOTO  IND          ;   .
NEPER
         INCF  COU,1        ;+1  .
         BTFSC COU,0        ;   1,
         BSF   FLA,2        ;  .
         BTFSS COU,0        ;   0,
         BCF   FLA,2        ;  .
         GOTO  AKT          ;  .
;
         END
