; 
;   11 ,
;  .
;   .
;   .
; ., .
; saes@mail.ru
;
;  = OXPANAPD.ASM
; : 11-04-03.
;   : MPLAB IDE, : 5.61.00.
;
            #include p16f84a.inc
            __CONFIG 3FF0H
;=========================================
;    32768 .
;=========================================
; RB0=1, RB1=2, RB2=3, RB4=4, RB5=6, RB6=7, RB7=8,
; RA0=9, RA1=10, RA2=11 -  .
; RA3- , RA4-  .
;=========================================
;  .
;=========================================
INDF     EQU  00H  ;    FSR.
TIMER0   EQU  01H  ;TMR0.
OPTIONR  EQU  81H  ;OPTION (RP0=1).
PC       EQU  02H  ; .
STATUS   EQU  03H  ;  .
FSR      EQU  04H  ;  .
PORTA    EQU  05H  ;  /.
PORTB    EQU  06H  ;  /.
TRISA    EQU  85H  ;   .
TRISB    EQU  86H  ;   .
INTCON   EQU  0BH  ;  .
;===========================================
;  .
;===========================================
SC         EQU  0CH   ; .
COU        EQU  0DH   ; .
;========================================
;  .
;========================================
W_TEMP      EQU  0EH  ;   W  .
STATUS_TEMP EQU  0FH  ;   STATUS  .
FSR_TEMP    EQU  10H  ;  FSR.
;=======================================
;    FLAG.
;=======================================
FLAG       EQU  11H   ;
;
;    0->    .
;    1->    1 .
;
;=========================
; 1. .   
;=========================
        ORG 0
           GOTO INIT
        ORG 4
           GOTO CONST
;========================================
; 4.   .
;========================================
ID2
        MOVLW   .2       ; .
        MOVWF   SC       ;
        GOTO    IDZ      ;
;=========================
ID3
        MOVLW   .3
        MOVWF   SC
        GOTO    IDZ      ;
;========================
ID4
        MOVLW   .4
        MOVWF   SC
        GOTO    IDZ      ;
;=========================
ID5
        MOVLW   .5
        MOVWF   SC
        GOTO    IDZ      ;
;=========================
ID6
        MOVLW   .6
        MOVWF   SC
        GOTO    IDZ      ;
;=========================
ID7
        MOVLW   .7
        MOVWF   SC
        GOTO    IDZ      ;
;=========================
ID8
        MOVLW   .8
        MOVWF   SC
        GOTO    IDZ      ;
;=========================
ID9
        MOVLW   .9
        MOVWF   SC
        GOTO    IDZ      ;
;=========================
ID10
        MOVLW   .10
        MOVWF   SC
        GOTO    IDZ      ;
;=========================
ID11
        MOVLW   .11
        MOVWF   SC
        GOTO    IDZ      ;
;=========================================
ID1
        MOVLW   .1       ;  
        MOVWF   SC       ;  .
IDZ
        TSTF    SC       ;
        SKPNZ            ; ,
        GOTO    ID0I     ;  .
        DECF    SC,1     ; 1  .
        BSF     PORTA,3  ; .
        CALL    ID21     ; ,   .
        BCF     PORTA,3  ; .
        CALL    ID2O     ; ,   .
        GOTO    IDZ      ; .
ID0I
        CLRWDT
        BCF     PORTA,4  ; .
        BSF     FLAG,0   ;   .
        BTFSC   FLAG,1   ;     .
        GOTO    ID0I     ;  .
        GOTO    KEY      ; .
;===========================
; 5. .
;===========================
ID2O
        MOVLW  .2     ; 2,69 .
        MOVWF  COU    ; -22 .
PAUSA
        DECF   COU,1  ; 1.
        TSTF   COU    ;  .
        SKPZ          ;   ,
        GOTO   PAUSA  ;.
        RETURN
ID21
        MOVLW  .2     ; 2,69 .
        MOVWF  COU    ; -22 .
PAUSA1
        DECF   COU,1  ; 1.
        CLRWDT
        NOP
        NOP
        TSTF   COU    ;  .
        SKPZ          ;   ,
        GOTO   PAUSA1 ;.
        RETURN
;=============================
; 3.  .
;=============================
KEY
        CLRWDT
        BTFSS   FLAG,1   ;  ,
        GOTO    KEY      ;   .
        BTFSC   PORTB,0  ;  ,
        GOTO    ID1      ;   .
        BTFSC   PORTB,1
        GOTO    ID2
        BTFSC   PORTB,2
        GOTO    ID3
        BTFSC   PORTB,3
        GOTO    ID4
        BTFSC   PORTB,4
        GOTO    ID5
        BTFSC   PORTB,5
        GOTO    ID6
        BTFSC   PORTB,6
        GOTO    ID7
        BTFSC   PORTB,7
        GOTO    ID8
        BTFSC   PORTA,0
        GOTO    ID9
        BTFSC   PORTA,1
        GOTO    ID10
        BTFSC   PORTA,2
        GOTO    ID11
        BCF     FLAG,0
        GOTO    KEY      ;   .
;===================================================================
; 6.       .
;===================================================================
CONST
        MOVWF  W_TEMP      ;   W 
        MOVFW  STATUS      ;STATUS,
        MOVWF  STATUS_TEMP ;
        MOVFW  FSR         ;FSR.
        MOVWF  FSR_TEMP    ;
        CALL   S1          ; 1  .
RECONST                    ;  .
        BCF    INTCON,2    ;  (T0IF)  .
        MOVFW  STATUS_TEMP ; :
        MOVWF  STATUS      ;STATUS,
        MOVFW  FSR_TEMP    ;
        MOVWF  FSR         ;FSR,
        MOVFW  W_TEMP      ;W.
        RETFIE             ;  .
;============================
; 7.  .
;============================
S1
        BTFSC  FLAG,1   ;   ,
        GOTO   S10      ;  .
        BSF    PORTA,4  ; ,
        BSF    FLAG,1   ;  .
        BTFSC  FLAG,0   ;    ,
        RETURN          ;  .
        CALL   ID2O     ;,  .
        BSF    PORTA,3  ; .
        CALL   ID21     ; ,   .
        BCF    PORTA,3  ; .
        CALL   ID2O     ;,  .
        BCF    PORTA,4  ; .
        RETURN
S10
        BCF    FLAG,1   ;   .
        BTFSC  FLAG,0   ;    ,
        RETURN          ;  .
        BSF    PORTA,4  ; ,
        CALL   ID2O     ;,  .
        BSF    PORTA,3  ; .
        CALL   ID21     ; ,   .
        BCF    PORTA,3  ; .
        CALL   ID2O     ;,  .
        BCF    PORTA,4  ; .
        RETURN
;======================
; 2. .
;======================
INIT
 BSF   STATUS,RP0       ;   1.
 MOVLW B'00000100'      ;  , =32 ...100,
 MOVWF OPTION_REG^80H   ;  .
 MOVLW B'10100000'      ;  =   .
 MOVWF INTCON           ;
 MOVLW B'00000111'      ;RA3,RA4- , RA0-RA2-.
 MOVWF TRISA^80H
 MOVLW B'11111111'      ;RB0-RB7- .
 MOVWF TRISB^80H
 BCF   STATUS,RP0       ;   0.
 CLRF  TMR0             ;   
 CLRF  FLAG
 CLRF  PORTA
 CLRF  COU
 GOTO  KEY         ;   .
;==============================================
        END
===============================================
