;
;  "" .
;    .
;    15.
;  -  .
;   .
;   .
; ., .
; saes@mail.ru
;
;  = PESOK.ASM
; : 28.02.03.
;   : MPLAB IDE, : 5.61.00.
;
            #INCLUDE P16F84A.INC
            __CONFIG 3FF0H
;======================================
;    32,768 K.
;======================================
; . .
;================
INDF     EQU  00H  ;    FSR.
TIMER0   EQU  01H  ;TMR0.
OPTIONR  EQU  81H  ;OPTION (RP0=1).
PC       EQU  02H  ; .
STATUS   EQU  03H  ;  .
FSR      EQU  04H  ;  .
PORTA    EQU  05H  ;  /.
PORTB    EQU  06H  ;  /.
TRISA    EQU  85H  ;   .
TRISB    EQU  86H  ;   .
INTCON   EQU  0BH  ;  .
;=============================================
;  .
;=============================================
; RB0 >   .
; RB1 >    .
; RB2 >  .
; RA0 >   (1).
; RA1 >   (0).
; RA2 >  1   1/4 .
;=================================
;  .
;=================================
SC0      EQU  10H  ;  .
COUS     EQU  11H  ; .
UMNO     EQU  12H  ; .
SEC1     EQU  13H  ; .
MIN1     EQU  14H  ; .
;============================================
;     FLAG.
;============================================
FLAG     EQU  15H   
;
;     0->  .
;     1->  .
;     2->    .
;     3->  1 .
;     5->  .
;==============================
FLAG1    EQU  16H
;
;     0->  . 
;     2->    ().
;====================
;  .
;====================
W_TEMP      EQU  17H ;   W  .
STATUS_TEMP EQU  18H ;   STATUS  .
FSR_TEMP    EQU  19H ;  FSR.
;=====================
; 1. .
;=====================
        ORG 0
           GOTO INIT 
        ORG 4
           GOTO CONST
;==================
; 2. .
;==================
INIT
 BSF   STATUS,RP0      ;   1.
 MOVLW B'00000010'     ;  , =8 =...10.
 MOVWF OPTION_REG^80H  ;
 MOVLW B'10100000'     ;    TMR0.
 MOVWF INTCON          ;
 MOVLW B'00000000'     ;  .
 MOVWF TRISA^80H
 MOVLW B'00000011'     ;RB0- ,  - .
 MOVWF TRISB^80H
 BCF   STATUS,RP0      ;   0. 
 CLRF  FLAG            ;  
 CLRF  FLAG1
 CLRF  TMR0            ;   
 CLRF  SC0
 CLRF  UMNO
 CLRF  SEC1
 CLRF  MIN1
 CLRF  COUS
 CLRF  PORTB
 CLRF  PORTA
 BSF   UMNO,0     ; 1 .
 BSF   PORTA,1    ;  .
 BSF   FLAG,1     ; .
 GOTO  ZOO        ;  .
;============================
; 3.   .
;============================
KEY
       BTFSS  PORTB,0   ;  ,
       BSF    FLAG,0    ; .
       BTFSS  PORTB,0   ;  ,  .
       RETURN
       BTFSC  FLAG,0    ;  ,
       CALL   UST       ;  .
       BTFSS  PORTB,1   ;  ,
       BSF    FLAG,2    ;    .
       BTFSS  PORTB,1   ;  ,  .
       RETURN
       BTFSS  FLAG,2    ;  ,  .
       RETURN
       BCF    FLAG,0    ;  .
       BCF    FLAG,2    ;
       BCF    FLAG,3    ;  1 .
       BTFSS  FLAG,1    ;  
       GOTO   KOZO      ; .
       BCF    FLAG,1    ; .
       BCF    FLAG,5    ;     .
       CLRF   MIN1      ;    .
       CLRF   SEC1      ;
       RETURN
KOZO
       BSF    FLAG,1     ; .
       RETURN
;================================
; 4.   .
;================================
COMP
        BTFSC   FLAG,1  ;   ,
        GOTO    ZOO     ;  .
        BTFSS   PORTB,1 ;  ,
        BCF     PORTB,2 ; .
        BTFSC   PORTB,1 ;   ,
        BSF     PORTB,2 ; .
        BTFSS   PORTB,1 ;  ,
        GOTO    COMP    ; .
;
        MOVFW   MIN1    ;  
        SUBWF   UMNO,0  ;   .
        BZ      COMW    ;  ,  .
;
        BCF     PORTA,0 ; .
        BSF     PORTA,1 ;.
        GOTO    COMP    ; .
COMW
        BSF     PORTA,0 ; .
        BCF     PORTA,1 ;.
        BSF     FLAG,5  ;  .
        BTFSC   COUS,0  ; 1/4  ,
        GOTO    COMP    ;  .
COMW0
        BTFSC   COUS,0  ; 1/4    ,
        GOTO    COMP    ;  .
        BCF     PORTA,2 ; .
        NOP             ; 
        NOP             ;
        NOP             ;  .
        NOP             ;  1,22  = 0,8 .
        BSF     PORTA,2 ; .
        GOTO    COMW0   ;.

;=================================
; 5.   .
;=================================
UST
        BTFSS   FLAG,1   ;  ,
        RETURN           ;.
        BTFSS   FLAG,3   ; ,   1 .
        RETURN           ;
        BCF    FLAG,3    ;  1 .
        BCF     FLAG,0   ;  .
        MOVLW   .15      ;  15.
        SUBWF   UMNO,0   ;
        BTFSC   STATUS,0 ; = 1,  15  .
        GOTO    USTH1    ; .
        INCF    UMNO,1   ;   .
        GOTO    UST3     ;   .
USTH1
        CLRF   UMNO      ;  .
        BSF    UMNO,0    ;  .
;============================================================
; 6.      .
;============================================================
UST3
        MOVFW   UMNO    ; 
        MOVWF   SC0     ; .
        RETURN
;===========================
; 7.   .
;===========================
ZOO
        BTFSS   FLAG,1   ;  ,
        GOTO    COMP     ;  .
        BTFSS   PORTB,0  ;  ,
        BCF     PORTB,2  ; .
        BTFSS   PORTB,1  ;  ,
        BCF     PORTB,2  ; .
        BTFSS   FLAG1,2  ; 2    ,
        GOTO    ZOO      ;.
        BTFSS   PORTB,0  ;  ,  .
        GOTO    ZOO      ;.
        BTFSS   PORTB,1  ;  ,  .
        GOTO    ZOO      ;.
        BCF     PORTA,0  ;  .
        BSF     PORTA,1  ;  .
        BCF     FLAG,3   ;  1 .
        BCF     FLAG1,2  ;  2 .
        BSF     PORTB,2  ; .
        CALL    UST3     ;  .
;========================================
; 8.  .
;========================================
HOKL
        TSTF    SC0      ;  ,
        SKPNZ            ; ,
        GOTO    HOZOO    ;  .
HOKL1
        BTFSS   COUS,0   ;   ,
        GOTO    HOKL1    ;
        DECF    SC0,1    ; 1  .
        BCF     PORTB,2  ; .
HOZKLO
        BTFSC   COUS,0   ;   ,
        GOTO    HOZKLO   ;
        BSF     PORTB,2  ; .
        GOTO    HOKL     ; .
HOZOO
        BCF     FLAG1,2  ;  2 .
        CLRF    COUS     ;    .
        GOTO    ZOO      ;  2 .
;==================================================================
; 9.       .
;===================================================================
CONST
        MOVWF  W_TEMP      ;   W 
        MOVFW  STATUS      ;STATUS,
        MOVWF  STATUS_TEMP ;
        MOVFW  FSR         ;FSR.
        MOVWF  FSR_TEMP    ;
        CALL   S1          ; 1  .
        BTFSC  FLAG,3      ;   1 .
        CALL   KEY         ; .
RECONST                    ;  .
        BCF    INTCON,2    ;  .
        MOVFW  STATUS_TEMP ; :
        MOVWF  STATUS      ;STATUS,
        MOVFW  FSR_TEMP    ;
        MOVWF  FSR         ;FSR,
        MOVFW  W_TEMP      ;W.
        RETFIE             ;  .
;==================
; 10. .
;=================
S1
        INCF   COUS,1   ;+1  .
        MOVLW  .4       ;  1 ,
        SUBWF  COUS,0   ;4  0,25,
        SKPZ            ;
        RETURN
        CLRF   COUS     ; .
        MOVFW  SEC1     ;  . .
        ADDLW  -3BH     ;   59.
        BZ      M1      ;  0,   ,   M1.
        INCF   SEC1,F   ; 1  .
        BTFSC  SEC1,1   ;  ,
        BSF    FLAG1,2  ;  2 .
        BTFSC  SEC1,0   ;  ,
        BSF    FLAG,3   ;  1 .
        RETURN          ;
M1
        CLRF   SEC1     ;  .
        BTFSC  FLAG,5   ;   ,
        GOTO   MOO      ;  .
        BTFSC  FLAG,1   ;  ,
        GOTO   MOO      ;  .
M1M
        MOVFW  MIN1     ;   . .
        ADDLW  -0FH     ;-15.
        BZ     MOO      ;  0,  , .
        INCF   MIN1,1   ; 1  .
        RETURN
MOO
        CLRF   MIN1     ;   .
        RETURN
;==============================================
        END
;==============================================

