;
;    .
;      
;     .
;   .
; , .
;    -
; : SVET,ASM.
; : 14-01-03.
; saes@mail.ru
            #INCLUDE P16F84A.INC
           __CONFIG 3FF0
;============================================
;  = 32768 . 256432= 1 .
;
;    .
;============================================
INDF     EQU  00H  ;    FSR.
TIMER0   EQU  01H  ;TMR0.
OPTIONR  EQU  01H  ;OPTION (RP0=1).
PC       EQU  02H  ; .
STATUS   EQU  03H  ; .
FSR      EQU  04H  ;  .
PORTA    EQU  05H  ;
PORTB    EQU  06H  ;
INTCON   EQU  0BH  ; .
;
DAY1     EQU  0CH  ; .
MON      EQU  0DH  ; .
ATT      EQU  0EH  ;  ( ).
MIN1     EQU  0FH  ; .
SEC1     EQU  010H ; .
DAY1L    EQU  011H ; .
SC0      EQU  012H ;  .
SC1      EQU  013H ;  .
SC2      EQU  014H ;  .
SC3      EQU  015H ;  .
DAY1H    EQU  016H ; .
MON1L    EQU  017H ; .
HOU1     EQU  018H ;.
BDEKM    EQU  019H ;   .
UDEKM    EQU  01AH ;   .
KATOD    EQU  01BH ;= ,   ( ).
COUI     EQU  01CH ;  .
FLAG     EQU  01DH
; 0-    ,
; 1-  ,
; 2-  ,  
; 5- , 
; 7- .
ANOD        EQU  01EH  ;=,  .
SEGD        EQU  01FH  ;   .
CAT         EQU  020H  ;  .
MON0        EQU  021H  ; .
DAY0        EQU  022H  ; .
BM          EQU  023H  ;   .
W_TEMP      EQU  024H  ;   W  .
STATUS_TEMP EQU  025H  ;   STATUS  .
DSMH        EQU  026H  ;   .
LSMH        EQU  027H  ;   .
HSMH        EQU  028H  ;   .
FSR_TEMP    EQU  029H  ;  FSR.
SUMUL       EQU  02AH  ;   .
FLAG1       EQU  02BH  ;    .
;
; 0-      ,
; 1-     ,
; 2-   ,
; 3-   ,
; 4-   ,
; 6-     (256).
; 7-    .
;
SUMBL       EQU  02CH  ;   .
MON1        EQU  02DH  ; .
MON1H       EQU  02EH  ;  .
DAYZ        EQU  02FH  ;    .
DAY         EQU  030H  ;  .
DATAU       EQU  031H  ;   .
DATAV       EQU  032H  ;   .
SUMU        EQU  033H  ;     .
M_LOW       EQU  034H  ;  .
M_HIGH      EQU  035H  ;  .
H_LOW       EQU  036H  ;  .
H_HIGH      EQU  037H  ;  .
POPU0       EQU  038H  ; ,   .
POPU1       EQU  039H  ; .
POPU2       EQU  03AH  ; .
POPU3       EQU  03BH  ;  .
POPV0       EQU  03CH  ; ,   .
POPV1       EQU  03DH  ; .
POPV2       EQU  03EH  ; .
POPV3       EQU  03FH  ;  .
FIK0        EQU  040H  ;   .
FIK1        EQU  041H  ; .
FIK2        EQU  042H  ; .
FIK3        EQU  043H  ; .
POPUL       EQU  044H  ;  .
POPVL       EQU  045H  ;  .
FIKM        EQU  046H  ;  .
FIKH        EQU  047H  ;  .
SUMB        EQU  048H  ;     .
SUMUH       EQU  049H  ;   .
SUMBH       EQU  04AH  ;   .
UM          EQU  04BH  ;  .
BH          EQU  04CH  ;  .
UDEKH       EQU  04DH  ;   .
BDEKH       EQU  04EH  ;   .
UH          EQU  04FH  ;  .
;====================
; 1. .   
;====================
        ORG 0
        GOTO INIT 
;
        ORG 4
        GOTO   CONST
;=======================================
; 2.     .
;=======================================
SEGDATA                     ; 6, 5, 4, 3, 2, 1, 0
        ADDWF   PCL,F       ; A, B, C, D, E, F, G
        RETLW   B'01111110' ;0
        RETLW   B'00110000' ;1
        RETLW   B'01101101' ;2
        RETLW   B'01111001' ;3
        RETLW   B'00110011' ;4
        RETLW   B'01011011' ;5
        RETLW   B'01011111' ;6
        RETLW   B'01110000' ;7
        RETLW   B'01111111' ;8
        RETLW   B'01111011' ;9
;==========================================================
; 3.      .
;==========================================================
DECBIN

        ADDWF   PC,1         ;
        RETLW   B'00000000'  ;0
        RETLW   B'00001010'  ;10
        RETLW   B'00010100'  ;20
        RETLW   B'00011110'  ;30
        RETLW   B'00101000'  ;40
        RETLW   B'00110010'  ;50
        RETLW   B'00111100'  ;60
        RETLW   B'01000110'  ;70
        RETLW   B'01010000'  ;80
        RETLW   B'01011010'  ;90
;====================================
; 4.    .
;====================================
UST4
         MOVFW   ATT    ;  
         ADDWF   PC,1   ;:
         GOTO    VETSHI ; .
         GOTO    FIKSI  ;  .
         GOTO    DAMONI ;  . 
         GOTO    UTROI  ; .
         GOTO    HOMII  ;.
;===============================================
; 5.   .
;================================================
DUMA
        MOVFW  MON1    ;..
        SUBWF  MON0,0  ;.
        SKPNZ          ;  ,
        GOTO   DIMA12  ;   .
        SKPZ           ;   ,
        CALL   DIMA9   ;    .
DUMAO
        MOVFW  MON1    ;  
        SUBWF  MON,0   ;  .
        SKPNZ          ;   ,
        GOTO   DUMOO   ; .

        MOVFW  MON     ; .
        CALL   DAYMON  ;   ?
        ADDWF  DAYZ,1  ;   .
        INCF   MON,F   ;  .
DU6M
        MOVLW  .183    ;   
        SUBWF  DAYZ,0  ;   ?
        SKPNC          ;   ,
        CALL   DIMF    ;.
        GOTO   DUMA    ;   .
DIMF
        BTFSC  FLAG1,2 ;   ,
        RETURN         ;.
        BSF    FLAG1,2 ;  .
        MOVWF   DAYZ   ;   .
        RETURN
DIMA9
        BTFSC  FLAG1,0 ;  ,
        RETURN         ;.
        MOVLW  .9      ;   
        ADDWF  DAYZ,1  ;.
        CLRF   MON     ;
        BSF    MON,0   ;.
        BSF    FLAG1,0 ;   .
        RETURN
DIMA12
        BCF    STATUS,0
        MOVFW  DAY0    ;    .
        SUBWF  DAY1,0  ;
        BC     DIMAP   ;   ,   .
        GOTO   DIMAM   ;   .
DIMAP
        MOVWF  DAYZ    ;     .
        BCF    FLAG1,2 ;  .
        BSF    FLAG1,1 ;   .
        RETURN
DIMAM
        ADDLW  0B7H    ;183
        MOVWF  DAYZ    ;   .
        BSF    FLAG1,2 ; .
        BSF    FLAG1,1 ;   .
        RETURN
DUMOO
        BTFSC  FLAG1,1 ;  ,
        RETURN         ;.
        BSF    FLAG1,1 ;   .
        MOVFW  DAY1    ;  
        ADDWF  DAYZ,1  ;  .
        MOVLW  .183    ; ?
        SUBWF  DAYZ,0  ;
        SKPC
        RETURN         ;
        MOVWF  DAYZ    ;,   .
        BTFSC  FLAG1,2 ;  ,
        BCF    FLAG1,2 ; .
        BTFSS  FLAG1,2 ;  - .
        BSF    FLAG1,2 ;  .
        RETURN
;===================================================
; 6.   .
;===================================================
DAYMON
        ADDWF  PCL,F  ;
        NOP           ;0
        RETLW  .31    ;1-
        RETLW  .29    ;2-
        RETLW  .31    ;3-
        RETLW  .30    ;4-
        RETLW  .31    ;5-
        RETLW  .30    ;6-
        RETLW  .31    ;7-
        RETLW  .31    ;8-
        RETLW  .30    ;9-
        RETLW  .31    ;10-
        RETLW  .30    ;11-
        RETLW  .31    ;12-
;=======================================
; 7.   .
;=======================================
UST

        MOVFW   CAT   ;   
        ADDWF   PC,1  ;  .
        GOTO    UST0  ;0
        GOTO    UST1  ;1
        GOTO    UST2  ;2
        GOTO    UST3  ;3
        GOTO    OOOO  ;.
        RETURN
;===========================
; 8.   .
;===========================
ATTK
        INCF    ATT,F ;  .
        MOVFW   ATT   ;
        SUBLW   .5    ;   4  (0-4).
        SKPNZ         ;    ,
        CLRF    ATT   ;  .
ATKU
        MOVFW   ATT   ;  
        ADDWF   PCL,1 ;:
        GOTO    VETSH ; .
        GOTO    FIKS  ; .
        GOTO    DAMON ;  . 
        GOTO    UTRO  ; .
        GOTO    HOMI  ; .
;===================================================================
; 9.       .
;===================================================================
CONST
        MOVWF  W_TEMP       ;   W 
        MOVFW  STATUS       ;STATUS,
        MOVWF  STATUS_TEMP  ;
        MOVFW  FSR          ;FSR.
        MOVWF  FSR_TEMP     ;
        CALL   S1  ;      D1UI  ;  M1M       ; 
        BTFSC   PORTB,7     ;  ( )?
        GOTO    RETCONT         ;.
        BSF     STATUS,RP0  ; 1.
        MOVLW  B'00010000'  ;RA4     .
        MOVWF  TRISA^80H    ;
        MOVLW   B'10000110' ;     (1, 2, 7).
        MOVWF   TRISB^80H   ;
        BCF     STATUS,RP0  ; 0.
        CALL   KEY          ;
RETCONT                     ;  
        BTFSS   FLAG,1      ;
        BSF     PORTB,4     ;
        BTFSC   FLAG,1      ;
        BSF     PORTB,3     ;
        BSF     STATUS,RP0  ;1 .
        MOVLW   B'10000000' ; , 7- .
        MOVWF   TRISB^80H   ;
        MOVLW  B'00000000'  ; .
        MOVWF  TRISA^80H    ;
        BCF     STATUS,RP0  ; 0.
        BCF    INTCON,2     ;  (T0IF)   ( ).
        MOVFW STATUS_TEMP   ;  
        MOVWF STATUS        ; W  STATUS,
        MOVFW FSR_TEMP      ;FSR.
        MOVWF   FSR         ;
; MOVLW  .230
; MOVWF  TMR0
        MOVFW W_TEMP        ;
        RETFIE              ;  .
;================================================
; 10.    .
;================================================
VETSHI
         MOVFW   SC0     ;  .
         MOVWF   POPV0   ;
         MOVFW   SC1     ;
         MOVWF   POPV1   ;
         CALL    DECBIN  ; .
         ADDWF   POPV0,0 ;
         MOVWF   POPVL   ; .
         MOVFW   SC2     ;
         MOVWF   POPV2   ;
         MOVFW   SC3     ;
         MOVWF   POPV3   ; .
         RETURN
FIKSI
         BSF     FLAG,0  ; .
         MOVFW   SC0     ;  .
         MOVWF   FIK0    ;
         MOVFW   SC1     ;
         MOVWF   FIK1    ;
         CALL    DECBIN  ; 
         ADDWF   FIK0,0  ;
         MOVWF   FIKM    ;   .
         MOVFW   SC2     ;
         MOVWF   FIK2    ;
         MOVFW   SC3     ;
         MOVWF   FIK3    ; 
         CALL    DECBIN  ;
         ADDWF   FIK2,0  ;
         MOVWF   FIKH    ;  .
         RETURN
DAMONI
         MOVFW   SC0     ;  .
         MOVWF   MON1L   ;
         MOVFW   SC1     ;
         MOVWF   MON1H   ; .
         CALL    DECBIN  ;
         ADDWF   MON1L,0 ; .
         MOVWF   MON1    ; .
         CALL    MO1U    ;
         MOVFW   SC2     ;
         MOVWF   DAY1L   ;
         MOVFW   SC3     ;
         MOVWF   DAY1H   ;
         CALL    DECBIN  ;
         ADDWF   DAY1L,0 ;
         MOVWF   DAY1    ; 
         CALL    D1U     ;  .
         CALL    DAMON   ;    .
         CLRF    FLAG1   ;    .
         RETURN
UTROI
         BCF     FLAG,0  ; .
         MOVFW   SC0     ;
         MOVWF   POPU0   ;
         MOVFW   SC1     ;
         MOVWF   POPU1   ;
         CALL    DECBIN  ;
         ADDWF   POPU0,0 ;
         MOVWF   POPUL   ;  .
         MOVFW   SC2     ;
         MOVWF   POPU2   ;
         MOVFW   SC3     ;
         MOVWF   POPU3   ; .
         RETURN
HOMII
         MOVFW   SC0     ;  .
         MOVWF   M_LOW   ;
         MOVFW   SC1     ;
         MOVWF   M_HIGH  ;
         CALL    DECBIN  ;
         ADDWF   M_LOW,0 ;
         MOVWF   MIN1    ;-   .
         MOVFW   SC2     ;
         MOVWF   H_LOW   ;
         MOVFW   SC3     ;
         MOVWF   H_HIGH  ;
         CALL    DECBIN  ;
         ADDWF   H_LOW,0 ;
         MOVWF   HOU1    ;-   .
         RETURN
;=======================================
; 11.    .
;=======================================
KEY
         BTFSS   PORTB,1 ;    ?
         CALL    ATTK    ;.
         BTFSC   PORTB,1 ;   ,
         CALL    ATKU    ; .
         BTFSS   PORTB,2 ;  ?
         CALL    CATK    ;.
         BTFSS   PORTA,4 ; +1?
         CALL    UST     ;.
         BTFSS   PORTA,4 ;
         RETURN          ;
         BTFSC   FLAG1,1 ;  ,
         RETURN          ;.
KEYU
         CLRF    FLAG1   ; 
         CLRF    DAYZ    ;  .
         CALL    DUMA    ;  .
         CALL    ZET     ; .
         CALL    OBSAK   ;    .
         RETURN
;=================================================
; 12.    ( ).
;=================================================
CATK
         INCF    CAT,1   ;+1   .
         MOVFW   CAT     ;
         SUBLW   .5      ;  4,   .
         SKPNZ           ;
         CLRF   CAT      ;.
         RETURN          ;
;==============================================
; 13.      .
;==============================================
VETSH
         MOVFW   POPV0  ; .
         MOVWF   SC0
         MOVFW   POPV1
         MOVWF   SC1
         MOVFW   POPV2
         MOVWF   SC2
         MOVFW   POPV3
         MOVWF   SC3
         RETURN
FIKS
         MOVFW   FIK0  ;  .
         MOVWF   SC0
         MOVFW   FIK1
         MOVWF   SC1
         MOVFW   FIK2
         MOVWF   SC2
         MOVFW   FIK3
         MOVWF   SC3
         RETURN
DAMON
         CALL    D1U    ;   .
         CALL    MO1U   ;   .
         MOVFW   MON1L
         MOVWF   SC0
         MOVFW   MON1H
         MOVWF   SC1
         MOVFW   DAY1L
         MOVWF   SC2
         MOVFW   DAY1H
         MOVWF   SC3
         RETURN
UTRO
         MOVFW   POPU0  ; .
         MOVWF   SC0
         MOVFW   POPU1
         MOVWF   SC1
         MOVFW   POPU2
         MOVWF   SC2
         MOVFW   POPU3
         MOVWF   SC3
         RETURN
HOMI
         MOVFW   M_LOW  ;  .
         MOVWF   SC0
         MOVFW   M_HIGH
         MOVWF   SC1
         MOVFW   H_LOW
         MOVWF   SC2
         MOVFW   H_HIGH
         MOVWF   SC3
         RETURN
;=================================
; 14. .
;=================================
UST0
        MOVLW   .2        ; 
        SUBWF   ATT,0     ;,
        BZ      UST0A     ;    .
        INCF    SC0,1     ;   9.
        MOVLW   .10       ;
        SUBWF   SC0,0     ;
        BTFSC   STATUS,0  ;() = 1,  10  .
        CLRF    SC0       ;
        GOTO    UST4      ;   .
UST0A
        INCF    SC0,1     ;   9.
        MOVLW   .10       ;
        SUBWF   SC0,0     ;
        BTFSC   STATUS,0  ;() = 1,  10  .
        BSF     SC1,0     ;  .
        BTFSC   STATUS,0  ;
        CLRF    SC0       ; .
        GOTO    UST4      ;    .
UST1
        INCF    SC1,1     ;   9.
        MOVLW   .10       ;
        SUBWF   SC1,0     ;
        BTFSC   STATUS,0  ;
        CLRF    SC1       ;
        GOTO    UST4      ;   .
UST2
        INCF    SC2,1     ;   9.
        MOVLW   .10       ;
        SUBWF   SC2,0     ;
        BTFSC   STATUS,0  ;
        CLRF    SC2       ;
        GOTO    UST4      ;   .
UST3
        INCF    SC3,1     ;   9.
        MOVLW   .10       ;
        SUBWF   SC3,0     ;
        BTFSC   STATUS,0  ;
        CLRF    SC3       ;
        GOTO    UST4      ;   .
OOOO
        BTFSC   PORTA,4   ; 
        GOTO    UST4      ;.
        BTFSC   ATT,2     ;   ,
        CLRF    SEC1      ;  
        BTFSC   ATT,2     ; .
        GOTO    OOOS      ;
        CLRF    SC2
        CLRF    SC3
OOOS
        CLRF    SC0
        CLRF    SC1
        GOTO    UST4      ;   .
;=======================================
; 15. .    0-7 ; 0-3.
;=======================================
ZIKL0
        BTFSC   PORTB,7     ;    .
        GOTO    KRUG        ;     .
        BSF     INTCON,7    ;   .
        MOVLW   B'11101110' ;  .
        MOVWF   ANOD        ;  .
        CLRF    KATOD       ;  2-10.
        MOVLW   012H        ;    .
        MOVWF   SEGD        ;   .
        GOTO    COUZ
ZIKL
        INCF    KATOD,1     ;+1   .
COUZ
        INCF    COUI,1     ;+1    .
        MOVLW   .50        ;50-   
        SUBWF   COUI,0     ; .
        BNZ     COUZ3      ;   0, .
COUZ1
        CLRF    COUI       ;  .
        BTFSC   FLAG,2     ;,  0,
        GOTO    COUZ2      ;     .
        BSF     FLAG,2     ;  1.
        GOTO    COUZ3      ;
COUZ2
        BCF     FLAG,2     ;    0.
        GOTO    INDCO      ; .
COUZ3
        BTFSS   FLAG,2     ;,  1.
        GOTO    INDCO      ; .
        MOVFW   KATOD      ;     
        SUBWF   CAT,0      ; .
        BNZ     INDCO      ;   .
INDCG
        MOVLW   B'11111'   ;   
        MOVWF   PORTA      ;   
        GOTO    INDC1      ; ( ).
INDCO
        MOVFW   KATOD      ;  ,
        SUBWF   ATT,0      ;\
        SKPNZ              ;   .
        BSF     FLAG,5     ; .
GDATA
        MOVFW   SEGD       ;     
        MOVWF   FSR        ;   .
        MOVFW   INDF       ; 2-10 .
        CALL    SEGDATA    ;    
        MOVWF   PORTB      ;  .
        MOVFW   ANOD       ; 
        MOVWF   PORTA      ;  .
        BTFSC   FLAG,5     ;  ,
        BSF     PORTA,4    ; .
        BTFSS   FLAG,5     ;
        BCF     PORTA,4    ; .
        BCF     FLAG,5     ; .
INDC1
        INCF    SEGD,F     ;+1    .
        MOVLW   B'01110111';   ,
        XORWF   ANOD,0     ;    ""  1.
        BTFSC   STATUS,Z   ; 0, .
        GOTO    ZIKL0      ;   .
INDO
        BSF     STATUS,C   ;  1.
        RLF     ANOD,1     ; .
        GOTO    ZIKL       ;
KRUG
        MOVLW   0FFH       ;
        MOVWF   PORTA      ;
        BTFSS   PORTB,7    ;  
        GOTO    ZIKL0      ;  .
        CALL    ITOG       ; .
        GOTO    KRUG       ;.
;===========================================
; 16.     .
;===========================================
ZET
        CLRF    SUMU       ;
        CLRF    SUMB       ;
        CLRF    DAY        ;.
        BTFSS   FLAG1,2    ;  ,
        GOTO    ZET0       ;  .
        MOVLW   .183       ;
        MOVWF   DAY        ;
        NEGF    DAYZ,0     ;   .
        ADDWF   DAY,0      ;   182.
        MOVWF   DAYZ       ;   .
ZET0
        CALL    DELTA      ;   .
        CLRF    PCLATH     ;    .
        MOVWF   DATAU      ; 
        MOVWF   DATAV      ;  .
        MOVLW   B'00001111';  .
        ANDWF   DATAV,1    ;     .
        MOVLW   B'11110000';  .
        ANDWF   DATAU,1    ;    .
        SWAPF   DATAU,1    ;  .
        MOVFW   DATAU      ;  
        ADDWF   SUMU,1     ;  .
        SKPNC              ;   ,
        BSF     FLAG1,6    ;  (256).
        MOVFW   DATAV      ;  
        ADDWF   SUMB,1     ;  .
        SKPNC              ;   ,
        BSF     FLAG1,7    ;  (256).
        MOVFW   DAYZ       ;   
        SUBWF   DAY,0      ; .
        SKPNZ              ;   ,
        RETURN             ;,    ,
        BTFSC   FLAG1,2    ;
        DECF    DAY,1      ;
        BTFSS   FLAG1,2    ; 
        INCF    DAY,1      ; .
        GOTO    ZET0       ; .
;==============================
; 17.  . . . . .
;===============================
S1
        MOVFW SEC1          ;  . .
        ADDLW  -3BH         ;   59.
        BZ      M1          ;  0,   ,   M1.
        INCF  SEC1,F        ; 1  .
        RETURN              ;
M1
        CLRF   SEC1         ;   .   
M1M
        MOVFW  MIN1         ;   . .
        ADDLW  -3BH         ;-59.
        BZ     H1           ;  0,  ,   H1.
        INCF   MIN1,F       ; 1  .
        MOVFW  MIN1         ;MIN1 >W.
M1U
        MOVWF  DSMH         ;W >DSMH.
        CALL   BINDECH      ;  .
        MOVFW  LSMH         ;LSMH >W .
        MOVWF  M_LOW        ;W > M_LOW     .
        MOVFW  HSMH         ;HSMH >W .
        MOVWF  M_HIGH       ;W > M_HIGH      .
        CLRF   HSMH         ; . . .
        CLRF   LSMH         ; .
        RETURN              ;
H1
        CLRF   MIN1         ;   .
        CLRF   M_LOW        ;  .
        CLRF   M_HIGH       ;  .
H1H
        MOVFW  HOU1         ;   . .
        ADDLW  -17H         ;- 23. 
        BZ     H10          ;  0,  ,   H10.
        INCF   HOU1,F       ; 1  .
        MOVFW  HOU1         ;HOU >W.
H1U
        MOVWF  DSMH         ;W >DSMH.
        CALL   BINDECH      ;  .
        MOVFW  LSMH         ;LSMH >W .
        MOVWF  H_LOW        ;W > H_LOW     .
        MOVFW  HSMH         ;HSMH >W .
        MOVWF  H_HIGH       ;W > H_HIGH      .
        CLRF   HSMH         ; . . .
        CLRF   LSMH         ; .
        RETURN              ;
H10
        CLRF   HOU1         ;  .
        CLRF   H_LOW        ;  .
        CLRF   H_HIGH       ;  .
D1UI
        MOVFW  MON1
        CALL   DAYMON       ;   ?
        SUBWF  DAY1,0       ;  ?
        BC     DO1          ;.  .
        INCF   DAY1,F       ;. +1  .
D1U
        MOVFW  DAY1         ;     .
        MOVWF  DSMH         ;W >DSMH.
        CALL   BINDECH      ;  .
        MOVFW  LSMH         ;LSMH >W .
        MOVWF  DAY1L        ;W > H_LOW     .
        MOVFW  HSMH         ;HSMH >W .
        MOVWF  DAY1H        ;W > H_HIGH      .
        CLRF   HSMH         ; . . .
        CLRF   LSMH         ;.
        BTFSS  PORTB,7      ;  ,
        RETURN              ;.
        BTFSC  FLAG1,1      ;  ,
        INCF   DAYZ,1       ;  .
        CALL   KEYU         ;     .
        RETURN              ;
DO1
        MOVLW  01H          ;  .
        MOVWF  DAY1         ;  .
        MOVWF  DAY1L        ;
        CLRF   DAY1H        ;  .
        INCF   DAYZ,1       ;  .
MO1U
        MOVFW  MON1         ;     .
        MOVWF  DSMH         ;W >DSMH.
        CALL   BINDECH      ;  .
        MOVFW  LSMH         ;LSMH >W .
        MOVWF  MON1L        ;W > H_LOW     .
        MOVFW  HSMH         ;HSMH >W .
        MOVWF  MON1H        ;W > H_HIGH      .
        CLRF   HSMH         ; . . .
        CLRF   LSMH         ;
        BTFSC  PORTB,7      ;  ,
        INCF   MON,1        ;  .
        BTFSC  PORTB,7      ;  ,        
        GOTO   MOD          ;
        BCF    STATUS,2     ;   .
        TSTF   MON1         ;  .
        BTFSC  STATUS,2     ;  ,   
        GOTO   MOO          ;,   .
        RETURN
MOD
        MOVFW  MON1         ;
        ADDLW  -0CH         ; 12 ?
        BC     MOO          ;.
        INCF   MON1,F       ; +1  
        CALL   KEYU         ;     .
        RETURN
MOO
        MOVLW  01H          ; 1  (0-).
        MOVWF  MON1         ;
        MOVWF  MON
        CALL   KEYU         ;     .
        RETURN
;===========================================================
; 18.    22.12  21.06.
;============================================================
DELTA
        MOVLW   HIGH  021B
        MOVWF   PCLATH
        MOVFW   DAY
        ADDWF   PC,1   ;
        RETLW   00H    ;0
        RETLW   00H    ;1
        RETLW   01H    ;2
        RETLW   01H    ;3
        RETLW   00H    ;4
        RETLW   01H    ;5
        RETLW   01H    ;6
        RETLW   01H    ;7
        RETLW   01H    ;8
        RETLW   01H    ;9 31..
        RETLW   02H    ;10
        RETLW   01H    ;11
        RETLW   01H    ;12
        RETLW   11H    ;13
        RETLW   12H    ;14
        RETLW   11H    ;15
        RETLW   12H    ;16
        RETLW   01H    ;17
        RETLW   12H    ;18
        RETLW   11H    ;19
        RETLW   12H    ;20
        RETLW   12H
        RETLW   12H    ;1 .
        RETLW   11H
        RETLW   12H
        RETLW   12H
        RETLW   01H
        RETLW   11H
        RETLW   12H
        RETLW   12H
        RETLW   12H    ;30
        RETLW   22H
        RETLW   12H
        RETLW   12H
        RETLW   12H
        RETLW   22H
        RETLW   22H
        RETLW   12H
        RETLW   22H
        RETLW   11H
        RETLW   11H    ;40 31 .
        RETLW   11H
        RETLW   12H
        RETLW   12H
        RETLW   22H
        RETLW   22H
        RETLW   22H
        RETLW   23H
        RETLW   22H
        RETLW   22H
        RETLW   32H    ;50
        RETLW   22H
        RETLW   22H    ;1 .
        RETLW   23H
        RETLW   22H
        RETLW   22H
        RETLW   00H
        RETLW   21H
        RETLW   22H
        RETLW   33H
        RETLW   22H    ;60
        RETLW   22H
        RETLW   32H
        RETLW   22H
        RETLW   32H
        RETLW   22H
        RETLW   23H
        RETLW   32H
        RETLW   22H
        RETLW   00H
        RETLW   21H    ;70 1 .
        RETLW   32H
        RETLW   22H
        RETLW   22H
        RETLW   32H
        RETLW   22H
        RETLW   32H
        RETLW   33H
        RETLW   22H
        RETLW   32H
        RETLW   22H    ;80 
        RETLW   32H
        RETLW   22H
        RETLW   32H    ;1 .
        RETLW   32H
        RETLW   21H
        RETLW   22H
        RETLW   22H     
        RETLW   32H
        RETLW   32H
        RETLW   22H    ;90
        RETLW   32H
        RETLW   22H
        RETLW   32H
        RETLW   32H
        RETLW   22H
        RETLW   32H
        RETLW   32H
        RETLW   32H
        RETLW   32H
        RETLW   32H    ;100
        RETLW   33H    ;1 .
        RETLW   33H
        RETLW   22H
        RETLW   32H
        RETLW   22H
        RETLW   32H
        RETLW   32H
        RETLW   22H
        RETLW   32H    ;
        RETLW   22H
        RETLW   32H
        RETLW   23H
        RETLW   32H    ;110 1 .
        RETLW   22H
        RETLW   32H
        RETLW   33H
        RETLW   32H
        RETLW   22H
        RETLW   32H
        RETLW   22H    ;120
        RETLW   32H
        RETLW   22H
        RETLW   22H
        RETLW   32H
        RETLW   22H
        RETLW   32H
        RETLW   32H
        RETLW   32H
        RETLW   32H
        RETLW   32H    ;130
        RETLW   33H    ;1 .
        RETLW   33H
        RETLW   23H
        RETLW   33H  
        RETLW   22H
        RETLW   22H
        RETLW   22H
        RETLW   22H
        RETLW   22H
        RETLW   22H    ;140
        RETLW   22H
        RETLW   22H
        RETLW   22H
        RETLW   22H    ;1 
        RETLW   22H
        RETLW   23H
        RETLW   23H
        RETLW   22H
        RETLW   22H
        RETLW   22H    ;150
        RETLW   22H
        RETLW   22H
        RETLW   22H
        RETLW   22H
        RETLW   22H
        RETLW   22H
        RETLW   22H
        RETLW   22H
        RETLW   22H
        RETLW   22H    ;160
        RETLW   22H
        RETLW   22H    ;1 .
        RETLW   22H
        RETLW   22H
        RETLW   22H
        RETLW   22H
        RETLW   12H
        RETLW   12H
        RETLW   11H
        RETLW   11H    ;170
        RETLW   10H
        RETLW   11H
        RETLW   11H
        RETLW   11H    ;1 .
        RETLW   11H
        RETLW   01H
        RETLW   01H
        RETLW   01H
        RETLW   01H
        RETLW   01H    ;180
        RETLW   01H
        RETLW   00H    ;21 .
        RETLW   00H    ;22 .
;===============================
; 19. .
;===============================
INIT
 BSF   STATUS,RP0       ; 1.
 MOVLW B'00000100'      ;  , =32 ...100.
 MOVWF OPTION_REG^80H   ;
 MOVLW B'10100000'      ;  =   ,
 MOVWF INTCON           ;
 MOVLW B'00000000'      ;RA0-RA4- .
 MOVWF TRISA^80H
 MOVLW B'10000000'      ;RB0-RB6- , RB7-.
 MOVWF TRISB^80H
 BCF   STATUS,RP0       ; 0.
 CLRF  TMR0
 CLRF  SEC1
 CLRF  MIN1
 CLRF  HOU1
 CLRF  M_LOW
 CLRF  M_HIGH
 CLRF  H_LOW
 CLRF  H_HIGH
 CLRF  HSMH
 CLRF  LSMH
 CLRF  ATT
 CLRF  MON
 CLRF  DAYZ
 CLRF  CAT
 CLRF  FLAG
 CLRF  FLAG1
 CLRF  POPU0
 CLRF  POPU1
 CLRF  POPU2
 CLRF  POPU3
 CLRF  POPUL
 CLRF  POPV0
 CLRF  POPV1
 CLRF  POPV2
 CLRF  POPV3
 CLRF  POPVL
 CLRF  FIK0
 CLRF  FIK1
 CLRF  FIK2
 CLRF  FIK3
 CLRF  FIKM
 CLRF  FIKH
 MOVLW .12
 MOVWF MON0         ;=12.
 MOVWF MON1
 MOVLW .22
 MOVWF DAY0         ;=22.
 MOVWF DAY1
     GOTO ZIKL0
;================================
; 20. .  2-_-2-10.
;================================
BINDECH                  ;    2-10 .
        MOVLW   .10      ;10 >W.
BDH
        BSF     STATUS,0 ;  ""  STATUS.
        SUBWF   DSMH,1   ;   10 > DSMH.
        BNC     BINDECL  ;    .
        INCF    HSMH,1   ; 1   .
        GOTO    BDH      ;.                
BINDECL
        MOVF    DSMH,0   ;   
        ADDLW   .10      ;10+W >W.               
        MOVWF   LSMH     ;    .
        RETURN           ;
;=======================================
; 21.   .
;=======================================
OBSAK
        BTFSC   FLAG1,2  ;  ,
        CALL    POPION   ;.
        BTFSS   FLAG1,2  ;  ,
        CALL    POPDEK   ;.
        BTFSC   POPU3,0  ;   ,
        CALL    NEGATU   ;.
        BTFSC   POPV3,0  ;    ,
        CALL    NEGATB   ;.
        BTFSS   POPU3,0  ;   ,
        CALL    POLU     ;.
        BTFSS   POPV3,0  ;    ,
        CALL    POLB     ;.
        GOTO    POLUM    ;  .
POPION
        MOVLW .30        ;    
        MOVWF UDEKM      ;  
        MOVLW .32        ;
        MOVWF BDEKM      ;22 .
        MOVLW .10        ;
        MOVWF BDEKH      ;
        MOVLW .14        ;
        MOVWF UDEKH      ;
        RETURN
POPDEK
        MOVLW .5         ;    
        MOVWF BDEKH      ;  
        MOVLW .20        ;22 .
        MOVWF UDEKH      ;
        CLRF  UDEKM      ;
        CLRF  BDEKM      ;
        RETURN
NEGATU
        MOVFW   POPU2    ;  
        SUBWF   UDEKH,0  ;   .
        MOVWF   SUMUH    ;.
        MOVFW   POPUL    ;.
        BSF     STATUS,0 ;
        SUBWF   UDEKM,0  ;
        BTFSC   STATUS,0 ;
        MOVWF   SUMUL    ;
        BTFSC   STATUS,0 ;
        RETURN
        MOVLW   .60      ; ,
        ADDWF   UDEKM,0  ; 
        MOVWF   SUMUL    ;
        MOVFW   POPUL    ;
        SUBWF   SUMUL,1  ;
        DECF    SUMUH,1  ;.
        RETURN
NEGATB
        BSF     STATUS,0 ; 
        MOVFW   POPV2    ;
        SUBWF   BDEKH,0  ;
        BTFSS   STATUS,0 ;  .
        CALL    NEGB24   ; ,  24 .
        MOVWF   SUMBH    ;.
        MOVFW   POPVL    ;.
        BSF     STATUS,0 ;
        SUBWF   BDEKM,0  ;
        BTFSC   STATUS,0 ;
        MOVWF   SUMBL    ;
        BTFSC   STATUS,0 ;
        RETURN
        MOVLW   .60      ;
        ADDWF   BDEKM,0  ;
        MOVWF   SUMBL    ;
        MOVFW   POPVL    ;
        SUBWF   SUMBL,1  ;.
        DECF    SUMBH,1  ;
        RETURN
NEGB24
        MOVLW   .24      ; 
        ADDWF   BDEKH,0  ; 24 
        MOVWF   SUMBH    ;
        MOVFW   POPV2    ; 
        SUBWF   SUMBH,0  ;.
        RETURN
POLU
        MOVFW   UDEKH    ;  
        ADDWF   POPU2,0  ;    .
        MOVWF   SUMUH    ;   .
        MOVFW   UDEKM    ; 
        ADDWF   POPUL,0  ; .
        MOVWF   SUMUL    ;
        RETURN
POLB
        MOVFW   BDEKH    ;   
        ADDWF   POPV2,0  ;.
        MOVWF   SUMBH    ;
        MOVFW   BDEKM    ;
        ADDWF   POPVL,0  ;
        MOVWF   SUMBL    ;
        RETURN
;==================================
; 22.   - .
;==================================
POLUM
        CLRF    UM       ;
        CLRF    UH       ;
        CLRF    BM       ;.
        CLRF    BH       ;
        CALL    HDECU    ;
        CALL    HDECB    ;
        BTFSC   FLAG1,2  ;  ,
        CALL    NEGBM    ; .
        BTFSS   FLAG1,2  ;  ,
        CALL    POLSUM   ; .
        RETURN 
HDECU
        BSF     STATUS,0 ;
        MOVLW   .60      ;  
        SUBWF   SUMU,1   ;  
        BTFSC   STATUS,0 ;   .
        INCF    UH,1     ;
        BTFSC   STATUS,0 ;
        GOTO    HDECU    ;
        BTFSS   FLAG1,6  ;
        GOTO    HDCU     ;
        BCF     FLAG1,6  ;
        INCF    UH,1     ;
        GOTO    HDECU    ;
HDCU
        MOVLW   .60      ;
        ADDWF   SUMU,0   ;
        MOVWF   UM       ;
        RETURN
HDECB
        BSF     STATUS,0 ;
        MOVLW   .60      ;  
        SUBWF   SUMB,1   ;  
        BTFSC   STATUS,0 ;   .
        INCF    BH,1     ;
        BTFSC   STATUS,0 ;
        GOTO    HDECB    ;
        BTFSS   FLAG1,7  ;
        GOTO    HDCB     ;
        BCF     FLAG1,7  ;
        INCF    BH,1     ;
        GOTO    HDECB    ;
HDCB
        MOVLW   .60      ;
        ADDWF   SUMB,0   ;
        MOVWF   BM       ;
        RETURN
POLSUM        
        MOVFW   UH       ;   
        SUBWF   SUMUH,1  ; 
        MOVFW   UM       ;  .
        BSF     STATUS,0 ;
        SUBWF   SUMUL,1  ;
        BTFSC   STATUS,0 ;
        GOTO    POLBM    ;
        MOVLW   .60      ;
        ADDWF   SUMUL,1  ;
        DECF    SUMUH,1  ;
POLBM
        MOVFW   BH       ; 
        ADDWF   SUMBH,1  ;
        MOVFW   BM       ; 
        ADDWF   SUMBL,1  ;.
PLBM
        MOVLW   .60      ; 
        BSF     STATUS,0 ;
        SUBWF   SUMBL,1  ;
        BTFSC   STATUS,0 ;.
        INCF    SUMBH,1  ;
        BTFSC   STATUS,0 ;
        GOTO    PLBM     ;
        MOVLW   .60      ;
        ADDWF   SUMBL,1  ;
        RETURN        
NEGBM
        MOVFW   BH       ;  
        SUBWF   SUMBH,1  ;  
        MOVFW   BM       ;.
        BSF     STATUS,0 ;
        SUBWF   SUMBL,1  ;
        BTFSC   STATUS,0 ;
        GOTO    NEGUM    ;  .
        MOVLW   .60      ; ,  
        ADDWF   SUMBL,1  ;
        DECF    SUMBH,1  ;.
        GOTO    NEGO     ;
NEGUM
        BTFSC   STATUS,0 ;
        CALL    PLBM     ;
NEGO
        MOVFW   UH       ; 
        ADDWF   SUMUH,1  ;.
        MOVFW   UM       ;
        ADDWF   SUMUL,1  ;
NGUM
        MOVLW   .60      ;  
        BSF     STATUS,0 ;
        SUBWF   SUMUL,1  ; .
        BTFSC   STATUS,0 ;
        INCF    SUMUH,1  ;
        BTFSC   STATUS,0 ;
        GOTO    NGUM     ;
        MOVLW   .60      ;
        ADDWF   SUMUL,1  ;
        RETURN
;===================================
; 23.    .
;===================================
ITOG
        BTFSC   FLAG,0   ;   
        GOTO    FITOG    ;  .
        MOVFW   SUMUH    ;   
        SUBWF   HOU1,0   ;   .
        SKPZ             ;   ,
        GOTO    ITOGB    ;  .
        MOVFW   SUMUL    ;  .
        BCF     STATUS,2
        SUBWF   MIN1,0   ;   ,
        BZ      WUXODU   ; .
        RETURN
FITOG
        MOVFW   FIKH     ;  
        SUBWF   HOU1,0   ;   .
        SKPZ             ;   ,
        GOTO    ITOGB    ;  .
        MOVFW   FIKM     ;
        BCF     STATUS,2
        SUBWF   MIN1,0   ;
        BZ      WUXODU   ; .
        RETURN
ITOGB
        MOVFW   SUMBH    ;  
        SUBWF   HOU1,0   ;  .
        SKPZ             ;
        RETURN
        MOVFW   SUMBL    ;
        BCF     STATUS,2
        SUBWF   MIN1,0   ;
        BZ      WUXODB   ; .
        RETURN
WUXODU
        BCF     PORTB,3  ; 
        BSF     PORTB,4  ;  .
        BCF     FLAG,1   ;
        RETURN
WUXODB
        BSF     PORTB,3  ; 
        BCF     PORTB,4  ;  .
        BSF     FLAG,1   ;
        RETURN
     END
;====================================================================
