; 
;  ,
; 8 , 32  /
; .
;   .
;    .
; ., .
; saes@mail.ru
;
;  = UPRAT.ASM
; : 08-04-03.
;   : MPLAB IDE, : 5.61.00.
;
            #INCLUDE P16F84A.INC
            __CONFIG 3FF1H
;============================================
;    4,096 .
;     16,  
;  TMR0 (256), ,  4     250,
;    1  (416256250=4096000).
;============================================
;  .
;============================================
INDF     EQU  00H  ;    FSR.
TIMER0   EQU  01H  ;TMR0.
OPTIONR  EQU  81H  ;OPTION (RP0=1).
PC       EQU  02H  ; .
STATUS   EQU  03H  ;  .
FSR      EQU  04H  ;  .
PORTA    EQU  05H  ;  /.
PORTB    EQU  06H  ;  /.
TRISA    EQU  85H  ;   .
TRISB    EQU  86H  ;   .
EEDATA   EQU  08H  ; .
EEADR    EQU  09H  ; .
EECON1   EQU  88H  ; -
EECON2   EQU  89H  ;.
INTCON   EQU  0BH  ;  .
;============================================
;   .
;============================================
SC0        EQU  0CH   ;  .
SC1        EQU  0DH   ;
SC2        EQU  0EH   ;
SC3        EQU  0FH   ;
SC4        EQU  10H   ;
SC5        EQU  11H   ; .
COUE       EQU  12H   ;    .
SMC        EQU  13H   ; 4 .
CAT        EQU  14H   ;  .
;============================================
;     FLAG.
;============================================
FLAG       EQU  15H   
;
;     0->  .
;     1->  -.
;     2-> 1 .
;     3->  2 .
;     4->  .
;     5->     .
;     6->    .
;     7->  .
;=====================================
;   .
;=====================================
SECL       EQU  016H  ; .  
SECH       EQU  017H  ; .
MINL       EQU  018H  ; .
MINH       EQU  019H  ; .
HOUL       EQU  020H  ; .
HOUH       EQU  021H  ; .
;==================================
; : , .
;==================================
VUX         EQU  023H  ;   .
VUXU        EQU  024H  ;  .
BUDHEX      EQU  025H  ;   .
ANOD        EQU  026H  ;.
SEG         EQU  027H  ;,  .(2-10 ).
PRB         EQU  028H  ;    ""   .
W_TEMP      EQU  029H  ;  W  .
STATUS_TEMP EQU  02AH  ;  STATUS  .
BUHL        EQU  02BH  ;  .
BUHH        EQU  02CH  ;  .
TEMP        EQU  02DH  ;  /  .
FSR_TEMP    EQU  02EH  ;  FSR.
BUMHX       EQU  02FH  ;     .
BUHHX       EQU  030H  ;     .
BUM         EQU  031H  ;    (+).
BUH         EQU  032H  ;    (+).
BUML        EQU  033H  ;  .
BUMH        EQU  034H  ;  .
ACOU        EQU  035H  ;  .
SC0A        EQU  036H  ;    .
SC1A        EQU  037H  ;    .
;======================
; 1. .   
;======================
        ORG 0
           GOTO INIT 
        ORG 4
           GOTO CONST
;=====================
; 2. .
;=====================
INIT
 BSF   STATUS,RP0       ;   1.
 MOVLW B'10000011'      ;  , =16 ...011,
 MOVWF OPTION_REG^80H   ;  .
 MOVLW B'10100000'      ;  =   .
 MOVWF INTCON           ;
 MOVLW B'00011000'      ; RA0-RA2- , RA3,RA4-.
 MOVWF TRISA^80H
 MOVLW B'00000000'      ; RB0-RB7- .
 MOVWF TRISB^80H
 BCF   STATUS,RP0       ;   0.
 CLRF  PORTB            ; . 
 CLRF  FLAG             ;  
; CLRF  FLAG1
 CLRF  TMR0             ;   
 CLRF  SC1
 CLRF  SC2
 CLRF  SC3
 CLRF  SC4
 CLRF  SC5
 CLRF  SECL
 CLRF  SECH
 CLRF  MINL
 CLRF  MINH
 CLRF  HOUL
 CLRF  HOUH
 CLRF  BUML
 CLRF  BUMH
 CLRF  BUHL
 CLRF  BUHH
 CLRF  SMC
 CLRF  VUX
 CLRF  VUXU
 CLRF  CAT
 CLRF  SC0A
 CLRF  SC1A
 MOVLW .9
 MOVWF SC0
 GOTO  ZIKL         ;  .
;==========================================
; 3.  / .
;==========================================
PCUX
        MOVFW   VUX      ;  
        ADDWF   PC,1     ;    .
        GOTO    RB0      ;
        GOTO    RB1      ;
        GOTO    RB2      ;
        GOTO    RB3      ;
        GOTO    RB4      ;
        GOTO    RB5      ;
        GOTO    RB6      ;
        GOTO    RB7      ;
;================================
; 4.   .
;================================
ZAPBIN
        MOVFW   SC1          ;  
        ADDWF   PC,1         ;    .
        RETLW   B'00000000'  ;0.   =  .
        RETLW   B'00001010'  ;10
        RETLW   B'00010100'  ;20
        RETLW   B'00011110'  ;30
        RETLW   B'00101000'  ;40
        RETLW   B'00110010'  ;50
        RETLW   B'00111100'  ;60
ZAPIS
        MOVLW   .4           ;   ,
        SUBWF   SC1,0        ;       3.
        BTFSC   STATUS,0     ;   ,
        RETURN               ; .
        MOVLW   .2           ;   ,
        SUBWF   CAT,0        ;    
        BTFSS   STATUS,0     ;    .
        RETURN               ; .
        CALL    ZAPBIN       ;  
        ADDWF   SC0,0        ;    
        MOVWF   BUDHEX       ;   .
ZAPOO
        MOVLW   .32          ;  
        SUBWF   BUDHEX,0     ; 
        BTFSC   STATUS,0     ;   32,
        GOTO    ZABOR        ; .
ZAPVMH
        MOVFW   BUMH         ;   
        MOVWF   BUMHX        ;   , 
        MOVFW   BUHH         ;   
        MOVWF   BUHHX        ;.
ZAPVUX
        MOVFW   VUXU         ;   
        MOVWF   TEMP         ;  .
        RRF     TEMP,1       ;  ,
        BTFSS   STATUS,0     ;   
        BCF     BUMHX,3      ; ,
        BTFSC   STATUS,0     ;   
        BSF     BUMHX,3      ;  1   0.
        RRF     TEMP,1       ;    ,
        BTFSS   STATUS,0     ;   
        BCF     BUHHX,2      ; ,
        BTFSC   STATUS,0     ;   
        BSF     BUHHX,2      ;.
        RRF     TEMP,1       ; 
        BTFSS   STATUS,0     ;   
        BCF     BUHHX,3      ;  
        BTFSC   STATUS,0     ;
        BSF     BUHHX,3      ;.
ZAPISO
        SWAPF   BUMHX,0      ;   
        IORWF   BUML,0       ; 
        MOVWF   BUM          ;    .
        SWAPF   BUHHX,0      ;   
        IORWF   BUHL,0       ; 
        MOVWF   BUH          ;    .
ZAPISM
        BTFSC   ACOU,0       ;   
        GOTO    ZAPISH       ;   .
        MOVFW   BUDHEX       ;  
        MOVWF   EEADR        ;   .
        MOVFW   BUM          ; 
        MOVWF   EEDATA       ;  .
        GOTO    ZAPISE       ; .
ZAPISH
        MOVFW   BUDHEX       ;  
        ADDLW   .32          ;  32 .
        MOVWF   EEADR        ;
        MOVFW   BUH          ; 
        MOVWF   EEDATA       ;  .
ZAPISE
        BCF     INTCON,GIE   ; .
        BSF     STATUS,RP0   ; 1.
        BSF     EECON1^80H,WREN ; .
        MOVLW   55H          ; 
        MOVWF   EECON2^80H   ;/
        MOVLW   0AAH         ;/
        MOVWF   EECON2^80H   ;/
        BSF     EECON1^80H,WR ;    .
ZAPIZ
        BTFSS   EECON1^80H,4 ;   
        GOTO    ZAPIZ        ;  .
        BCF     INTCON,6     ;     .
        BCF     EECON1^80H,4 ;
        BCF     EECON1^80H,WREN ; .
        BCF     STATUS,RP0   ; 0.
        INCF    ACOU,1       ;+1    .
        MOVLW   .2           ; 
        SUBWF   ACOU,0       ;    1.
        BZ      EECNOO       ; ,   .
        GOTO    ZAPISM       ;       .
ZABOR
        CLRF    SC0          ;  
        CLRF    SC1          ;  .
        CLRF    BUDHEX       ;  .
        RETURN               ;
EECNOO
        CLRF    ACOU         ;    
        MOVLW   .1           ;  
        MOVWF   CAT          ;  ,   .
        RETURN               ;.
;======================================
; 5.    .
;======================================
KEY
         BTFSC   PORTA,3     ;    ,
         GOTO    KEYC        ;  .
         BTFSC   PORTA,4     ;   ,
         GOTO    KEYU        ;  .
KEYP
         BTFSS   FLAG,0      ;  1,  ,
         RETURN              ; .
         BTFSC   PORTB,7     ;   ,
         GOTO    ZAPIS       ;  .
         RETURN              ; .
KEYC
         BTFSC   PORTA,4     ;   ,
         GOTO    KEYF        ;   .
         BTFSC   PORTA,3     ;    () ,
         GOTO    CATK        ;  .
         RETURN              ; .
KEYU
         BTFSC   PORTA,3     ;    () ,
         GOTO    KEYF        ;   .
         BTFSC   PORTA,4     ;   ,
         GOTO    UST         ;  .
         RETURN              ; .
KEYF
         BCF     FLAG,3      ;    2 .
         BTFSC   FLAG,0      ;  
         GOTO    KEYFO       ; .
         BSF     FLAG,0      ;  .
         MOVFW   PORTB       ;  
         MOVWF   PRB         ;  .
         BSF     STATUS,RP0  ;   1.
         MOVLW   B'10000000' ;RB0-RB6- , RB7-.
         MOVWF   TRISB^80H   ;   .
         BCF     STATUS,RP0  ;   0.
         GOTO    KEYP        ;   .
KEYFO
         BCF     FLAG,0      ;  .
         BSF     STATUS,RP0  ;   1.
         CLRF    TRISB^80H   ;RB0-RB7- ,   .
         BCF     STATUS,RP0  ;   0.
         MOVFW   PRB         ;  
         MOVWF   PORTB       ;,   .
         RETURN              ;.
;======================================
; 6.    ().
;======================================
CATK
        BTFSS   FLAG,2    ;    1 .
        RETURN            ;
        INCF    CAT,1     ;+1    .
        BCF     FLAG,2    ;    .
        MOVFW   CAT       ; 
        SUBLW   .6        ; 5 ,
        BTFSC   STATUS,2
        CLRF    CAT       ; .
        MOVLW   .2        ;  .
        SUBWF   CAT,0     ;   
        SKPC              ;  ,
        GOTO    UST       ; .
        BSF     FLAG,5    ;  .
        RETURN
;============================
; 7.   .
;============================
ATTU
        BTFSC   FLAG,1    ;  ,
        GOTO    ATUC      ;  .
        MOVLW   .9        ; 9   ,
        SUBWF   SC0,0     ;
        BZ      HATU      ;   .
        MOVLW   .8        ; 8   ,
        SUBWF   SC0,0     ;
        BZ      ATOO      ;     .
ATUC
        MOVLW   .1        ;  .
        SUBWF   CAT,0     ;    ,
        SKPNZ             ;
        GOTO    BIN       ;     .
        SKPNC             ;
        GOTO    BUST      ;    ,   .
        RETURN            ;
;=============================
; 8.    .
;=============================
ATOO
        CALL    HATU      ; .
        BTFSS   PORTB,7   ;   .
        RETURN            ;.
        MOVLW   .9        ;.
        SUBWF   MINL,0    ;   9,
        BTFSC   STATUS,2  ; 
        CALL    HL        ; .
        CLRF    SECL      ;   
        CLRF    SECH      ;  
        CLRF    MINL      ;.
        CLRF    MINH      ;
        GOTO    HATU      ;  .
;==================================
; 9.   .
;==================================
UST
        BTFSC   PORTA,3   ;    ,
        RETURN            ;.
        BCF     FLAG,3    ;  2 .
        MOVFW   CAT       ;  
        ADDWF   PC,1      ;  .
        GOTO    UST0      ;0
        GOTO    UST1      ;1
        GOTO    UST2      ;2
        GOTO    UST3      ;3
        GOTO    UST4      ;4
        GOTO    UST5      ;5
;==========================================================
UST0
        BSF     FLAG,5    ;  .
        BTFSC   FLAG,1    ;    ,
        CALL    USTAV     ;  .
        BCF     FLAG,1    ;   .
        BTFSS   PORTA,4   ;    ,
        RETURN            ;.
        INCF    SC0,1     ;   .
        MOVLW   .10       ;   9.
        SUBWF   SC0,0     ;
        BTFSC   STATUS,0  ;() = 1,  10  .
        CLRF    SC0       ; ,   9.
        MOVLW   .8        ;    8,
        SUBWF   SC0,0     ;
        BNC     USTV      ;     .
        GOTO    HATU      ; 8  ,     .
USTAV
        MOVFW   VUXU      ;     
        MOVWF   SC0       ;  .
        CLRF    SC1       ;  .
        RETURN
USTV
        MOVFW   SC0       ;  
        MOVWF   VUXU      ;    .
        CLRF    SC1       ;  .
        RETURN
;========================================================
UST1
        BCF     FLAG,5    ;  .
        BTFSS   FLAG,1    ;    ,
        CALL    USTA      ;  .
        BSF     FLAG,1    ;   .
        BTFSS   PORTA,4   ;    ,
        RETURN            ;.
        MOVFW   SC1       ; 
        ADDLW   -3H       ; 3,
        BZ      UST10     ; .
        MOVFW   SC0       ;   9,
        ADDLW   -9H       ;
        BZ      USTO1     ; .
        INCF    SC0,1     ;  .
        GOTO    USTAL     ; .
UST10
        MOVFW   SC0       ;      31.
        ADDLW   -1H       ;  =1,
        BZ      USTOO     ; .
        INCF    SC0,1     ;  .
        GOTO    USTAL     ; .
USTA
        MOVFW   SC0A      ;  
        MOVWF   SC0       ; 
        MOVFW   SC1A      ; .
        MOVWF   SC1
        RETURN
USTAL
        MOVFW   SC0       ;  
        MOVWF   SC0A      ; 
        MOVFW   SC1       ; .
        MOVWF   SC1A
        RETURN
USTOO
        CLRF    SC0       ; .
        CLRF    SC1       ; .
        GOTO    USTAL     ; .
USTO1
        CLRF    SC0       ; .
        INCF    SC1,1     ; .
        GOTO    USTAL     ; .
;=====================================================
UST2
        INCF    SC2,1     ;   9.
        MOVLW   .10       ;
        SUBWF   SC2,0     ;
        BTFSC   STATUS,0  ;
        CLRF    SC2       ;
        GOTO    UST6      ;  .
UST3
        INCF    SC3,1     ;   5.
        MOVLW   .6        ;
        SUBWF   SC3,0     ;
        BTFSC   STATUS,0  ;
        CLRF    SC3       ;
        GOTO    UST6      ;  .
UST4
        INCF    SC4,1     ;   9.
        MOVLW   .10       ;
        SUBWF   SC4,0     ;
        BTFSC   STATUS,0  ;
        CLRF    SC4       ;
        GOTO    UST6      ;  .
UST5
        INCF    SC5,1     ;   2.
        MOVLW   .3        ;
        SUBWF   SC5,0     ;
        BTFSC   STATUS,0  ;
        CLRF    SC5       ;
        GOTO    UST6      ;  .
;=================================
; 10.    .
;=================================
UST6
        BTFSC   FLAG,1    ;   ,
        GOTO    BUST      ;   .
        BTFSS   FLAG,1    ;    ,
        GOTO    HUST      ;   .
        RETURN
;==================================================
; 11.     .
;==================================================
BUST
        BCF     FLAG,5    ;  .
        MOVFW   SC2       ;   
        MOVWF   BUML      ;  .
        MOVFW   SC3       ;
        MOVWF   BUMH      ;
        MOVFW   SC4       ;
        MOVWF   BUHL      ;
        MOVFW   SC5       ;
        MOVWF   BUHH      ;
        RETURN
HUST
        MOVFW   SC2       ;   
        MOVWF   MINL      ;  .
        MOVFW   SC3       ;
        MOVWF   MINH      ;
        MOVFW   SC4       ;
        MOVWF   HOUL      ;
        MOVFW   SC5       ;
        MOVWF   HOUH      ;
        RETURN
;=======================================
; 12.     .
;=======================================
HATU
        BTFSC   PORTA,3   ;    ,
        RETURN            ;.
        BSF     FLAG,5    ;  0  1 .
        MOVFW   MINL      ;   
        MOVWF   SC2       ;  .
        MOVFW   MINH      ;
        MOVWF   SC3       ;
        MOVFW   HOUL      ;
        MOVWF   SC4       ;
        MOVFW   HOUH      ;
        MOVWF   SC5       ;
        RETURN            ;
BIN
        BSF     FLAG,1
        CALL    USTA      ;   1 .
        BCF     FLAG,5    ;  .
        CALL    ZAPBIN    ;  
        ADDWF   SC0,0     ;   
        MOVWF   BUDHEX    ;.
        MOVWF   COUE      ;    .
BINHB
        CALL    AKTETE    ;  
        MOVFW   EEDATA    ;  .
        MOVWF   BUML      ;   
        MOVLW   B'00001111';
        ANDWF   BUML,1    ;
        MOVFW   EEDATA    ;
        MOVWF   BUMHX     ;   .
;
        MOVWF   TEMP      ;       
        RLF     TEMP,1    ;  .
        BTFSS   STATUS,0  ;    
        BCF     VUX,0     ;    
        BTFSC   STATUS,0  ;    
        BSF     VUX,0     ; 0,  1.
        SWAPF   BUMHX,1   ; 3  
        MOVLW   B'00000111'; 
        ANDWF   BUMHX,0   ;  
        MOVWF   BUMH      ; .
;
        MOVLW   .32       ;   31 ,
        ADDWF   COUE,1    ;  32 .
        CALL    AKTETE    ;  .
        MOVFW   EEDATA    ;   
        MOVWF   BUHL      ;
        MOVLW   B'00001111';
        ANDWF   BUHL,1    ;
        MOVFW   EEDATA    ;
        MOVWF   BUHHX     ;   .
;
        MOVWF   TEMP      ;  
        RLF     TEMP,1    ; 
        BTFSS   STATUS,0  ;   
        BCF     VUX,2     ;  .
        BTFSC   STATUS,0  ;
        BSF     VUX,2     ;
        RLF     TEMP,1    ;  
        BTFSS   STATUS,0  ; 
        BCF     VUX,1     ;   
        BTFSC   STATUS,0  ;  .
        BSF     VUX,1     ;
        SWAPF   BUHHX,1   ;   
        MOVLW   B'00000011'; 
        ANDWF   BUHHX,0   ;  
        MOVWF   BUHH      ;   .
        MOVLW   .32       ; 
        SUBWF   COUE,1    ;    .
        BTFSS   FLAG,0    ;   ,
        RETURN            ; .
;
        MOVFW   BUML      ;   
        MOVWF   SC2       ;  .
        MOVFW   BUMH      ;  
        MOVWF   SC3       ;  .
        MOVFW   BUHL      ;  
        MOVWF   SC4       ;  .
        MOVFW   BUHH      ;
        MOVWF   SC5       ;
        RETURN
;=======================================================
; 13. .     - .
;=======================================================
ZIKL
        BTFSC   FLAG,3    ;   
        CALL    KEY       ; .
        BCF     FLAG,7    ;  .
        CLRF    ANOD      ;  .
ZS0
        BSF     INTCON,7  ; .
        BTFSC   FLAG,5    ;   ,
        GOTO    ZS00      ;  .
        BTFSC   FLAG,3    ;,   2 ,
        MOVFW   VUXU      ;  .
        BTFSS   FLAG,3    ;  2 ,
ZS00
        MOVFW   SC0       ;    
        CALL    INDZIKL   ;   .
ZS01
        BTFSS   INTCON,7  ; .
        GOTO    ZS1       ;      .
        GOTO    ZS01      ;  .
ZS1
        BSF     INTCON,7  ; .
        BTFSC   FLAG,5    ;   ,
        GOTO    ZS10      ;.
        BTFSS   FLAG,3    ;  2 ,
        MOVFW   SC1       ;    ,
        BTFSC   FLAG,3    ;  2 ,
ZS10
        MOVLW   .0        ;   .
        CALL    INDZIKL   ;  .
ZS12
        BTFSS   INTCON,7  ; .
        GOTO    ZS2       ;      .
        GOTO    ZS12      ;  .
ZS2
        BSF     INTCON,7  ; .
        MOVFW   SC2       ;    
        CALL    INDZIKL   ;   .
ZS23
        BTFSS   INTCON,7  ; .
        GOTO    ZS3       ;      .
        GOTO    ZS23      ;  .
ZS3
        BSF     INTCON,7  ;     .
        MOVFW   SC3       ;
        CALL    INDZIKL   ;
        CALL    ATTU      ;  .
ZS34
        BTFSS   INTCON,7  ;
        GOTO    ZS4       ;
        GOTO    ZS34      ;
ZS4
        BSF     INTCON,7  ;
        MOVFW   SC4       ;
        CALL    INDZIKL   ;

ZS45
        BTFSS   INTCON,7  ;
        GOTO    ZS5       ;
        GOTO    ZS45      ;
ZS5
        BSF     INTCON,7  ;
        MOVFW   SC5       ;
        CALL    INDZIKL   ;
ZS50
        BTFSS   INTCON,7  ;
        GOTO    ZIKL      ;
        GOTO    ZS50      ;
INDZIKL
        BTFSS   FLAG,0    ;   ,
        GOTO    INDVUX    ;  .
        MOVWF   SEG       ;     .
        BTFSC   FLAG,5    ;  ,
        GOTO    INDZ      ;  .
        BTFSC   FLAG,3    ;  2 ,
        GOTO    INDZO     ;  
INDZ
        MOVFW   ANOD      ;  .
        SUBWF   CAT,0     ;   .
        SKPNZ             ;  ,
        BSF     SEG,4     ;   .
        SKPZ              ;
INDZO
        BCF     SEG,4     ;  .
        MOVFW   SEG       ;  
        MOVWF   PORTB     ;    B.
        MOVFW   ANOD      ;  
        MOVWF   PORTA     ;  .
        INCF    ANOD,1    ;+1   .
        RETURN            ;   .
;========================================================
; 14.  .
;========================================================
INDVUX
        BSF     INTCON,7  ; .
        BTFSC   FLAG,3    ;   
        CALL    KEY       ; .
        BSF     FLAG,7    ;   .
        BTFSC   FLAG,0    ;   ,
        GOTO    ZIKL      ;  .
        CALL    BUDC      ;    .
        BTFSS   FLAG,6    ;  ,
        GOTO    INDVUX    ;  .
        BTFSC   FLAG,4    ;   ,
        GOTO    INDVUX    ;  .
        BSF     FLAG,4    ;   .
        GOTO    PCUX      ;,   .
RB0
        BTFSC   PORTB,0   ;    . 1,
        GOTO    RB00      ; . 0.
        BSF     PORTB,0   ;  . 1.
        GOTO    INDVUX    ;   .
RB00
        BCF     PORTB,0   ; . 0.
        GOTO    INDVUX    ;   .
RB1
        BTFSC   PORTB,1   ; , 
        GOTO    RB10      ;, 
        BSF     PORTB,1   ;  .
        GOTO    INDVUX    ;
RB10
        BCF     PORTB,1   ;
        GOTO    INDVUX    ;
RB2
        BTFSC   PORTB,2   ;
        GOTO    RB20      ;
        BSF     PORTB,2   ;
        GOTO    INDVUX    ;
RB20
        BCF     PORTB,2   ;
        GOTO    INDVUX    ;
RB3
        BTFSC   PORTB,3   ;
        GOTO    RB30      ;
        BSF     PORTB,3   ;
        GOTO    INDVUX
RB30
        BCF     PORTB,3   ;
        GOTO    INDVUX    ;
RB4
        BTFSC   PORTB,4   ;
        GOTO    RB40      ;
        BSF     PORTB,4   ;
        GOTO    INDVUX    ;
RB40
        BCF     PORTB,4   ;
        GOTO    INDVUX    ;
RB5
        BTFSC   PORTB,5   ;
        GOTO    RB50      ;
        BSF     PORTB,5   ;
        GOTO    INDVUX    ;
RB50
        BCF     PORTB,5   ;
        GOTO    INDVUX    ;
RB6
        BTFSC   PORTB,6   ;
        GOTO    RB60      ;
        BSF     PORTB,6   ;
        GOTO    INDVUX    ;
RB60
        BCF     PORTB,6   ;
        GOTO    INDVUX    ;
RB7
        BTFSC   PORTB,7   ;
        GOTO    RB70      ;
        BSF     PORTB,7   ;
        GOTO    INDVUX    ;
RB70
        BCF     PORTB,7   ;
        GOTO    INDVUX    ;
;============================================
; 15.     .
;============================================
BUDC
        BTFSC   FLAG,6   ; ?
        RETURN           ;.
        BTFSC   FLAG,0   ; ?
        RETURN           ;.
        CLRF    COUE     ;      .
;=====================================================
;   ,    .
;=====================================================
BUDOO
        CALL    BINHB    ;      .
        MOVLW   .0
        BCF     STATUS,2
        SUBWF   BUML,0   ;   
        BTFSS   STATUS,2 ;   ,
        GOTO    BUDM     ;     .
        MOVLW   .0
        BCF     STATUS,2
        SUBWF   BUMH,0
        BTFSS   STATUS,2
        GOTO    BUDM     
        MOVLW   .0
        BCF     STATUS,2
        SUBWF   BUHL,0
        BTFSS   STATUS,2
        GOTO    BUDM     
        MOVLW   .0
        BCF     STATUS,2 ;  
        SUBWF   BUHH,0   ; ,
        BTFSC   STATUS,2 ;  
        GOTO    BUDM1    ;   .
;=======================================
;    .
;=======================================
BUDM
        MOVFW   BUML     ;  
        SUBWF   MINL,0   ; .
        SKPZ             ;  ,
        GOTO    BUDM1    ;  .
        MOVFW   BUMH     ;   .
        SUBWF   MINH,0   ;
        SKPZ             ;
        GOTO    BUDM1    ; .
;
        MOVFW   BUHL     ;  
        SUBWF   HOUL,0   ; .
        SKPZ             ;  ,
        GOTO    BUDM1    ;  .
        MOVFW   BUHH     ;   .
        SUBWF   HOUH,0   ;
        SKPNZ            ;    ,
        BSF     FLAG,6   ;      .
        BTFSC   STATUS,2 ;    
        BCF     FLAG,4   ;   ,
        BTFSC   STATUS,2 ;   .
        RETURN
BUDM1
        BCF     STATUS,0 ;
        INCF    COUE,1   ;    .
        MOVLW   .32      ;  
        SUBWF   COUE,0   ;    31.
        BTFSC   STATUS,0 ;  32,
        RETURN           ; .
        GOTO    BUDOO    ;     .
;=========================
; 16.   .
;=========================
AKTETE
        MOVFW   COUE       ;   
        MOVWF   EEADR      ;.
        BSF     STATUS,RP0 ; 1.
        BSF  EECON1^80H,RD ;.
        BCF     STATUS,RP0 ; 0.
        MOVLW   .255       ;   ,
        SUBWF   EEDATA,0   ; -0.
        BTFSC   STATUS,Z   ;
        CLRF    EEDATA     ;, .. 255 .
        RETURN             ;
;===================================================================
; 17.       .
;===================================================================
CONST
        MOVWF  W_TEMP      ;   W 
        MOVFW  STATUS      ;STATUS,
        MOVWF  STATUS_TEMP ;
        MOVFW  FSR         ;FSR.
        MOVWF  FSR_TEMP    ;
        CALL   S1          ; 1   .
RECONST                    ;  .
        BCF    INTCON,2    ;  (T0IF)   ( ).
        MOVFW  STATUS_TEMP ; :
        MOVWF  STATUS      ;STATUS,
        MOVFW  FSR_TEMP    ;
        MOVWF  FSR         ;FSR,
        MOVFW  W_TEMP      ;W.
        BTFSS  FLAG,7      ;  ,
        RETURN             ;      .
        RETFIE             ;    .
;=========================================
; 18.  --.
;=========================================
S1
        INCF    SMC,1      ;  250.
        MOVFW   SMC        ;
        ADDLW   -0F4H      ;250=0FAH. 244=F4 -  4.0 .
        BZ      SLF        ;  ,  .
        RETURN
SLF
        CLRF    SMC        ;  .
        BSF     FLAG,2     ;  1 S.
        BTFSS   SECL,0     ;
        BSF     FLAG,3     ;  2 .
        BTFSC   SECL,0     ;
        BCF     FLAG,3     ;  2 .
        MOVLW   .9         ;  9 ,
        SUBWF   SECL,0     ;
        BC      SH         ;    .
        INCF    SECL,1     ;  .
        RETURN
SH
        CLRF    SECL       ; .
        BCF     STATUS,2   ;   .
        MOVFW   SECH       ;  
        ADDLW   -5H        ; 5,
        BZ      ML         ;  .
        INCF    SECH,1     ;   .
        RETURN
ML
        CLRF    SECH       ;  .
        BCF     FLAG,6     ;   ( ).
        BCF     STATUS,2   ;   .
        MOVFW   MINL       ;  
        ADDLW   -9H        ; 9,
        BZ      MH         ;  .
        INCF    MINL,1     ;  .
        RETURN
MH
        CLRF    MINL       ;  .
        BCF     STATUS,2   ;   .
        MOVFW   MINH       ;  
        ADDLW   -5H        ; 5,
        BZ      HL         ;  .
        INCF    MINH,1     ;   .
        RETURN
HL
        CLRF    MINH       ;  .
        BCF     STATUS,2   ;   .
        MOVFW   HOUH       ;  
        ADDLW   -2H        ; 2,
        BZ      HL4        ;  .
        MOVFW   HOUL       ;    9,
        ADDLW   -9H        ;
        BZ      HH         ;  .
        INCF    HOUL,1     ;   .
        RETURN
HL4
        BCF     STATUS,2   ;   .
        MOVFW   HOUL       ;  
        ADDLW   -3H        ; 3,
        BZ      HH         ; .
        INCF    HOUL,1     ;  .
        RETURN
HH
        CLRF    HOUL       ;  .
        BCF     STATUS,2   ;   .
        MOVFW   HOUH       ;  
        ADDLW   -2H        ; ,
        BZ      DL         ; .
        INCF    HOUH,1     ;   .
        RETURN
DL
        CLRF    HOUH       ;  .
        RETURN
;=================================================
         END
==================================================

