; 
;    ,  
;    .
;   .
;    .
; ., .
; saes@mail.ru
;
;  = CHASU.ASM
;  : 08-07-02.
;   : MPLAB IDE, : 5.61.00.
;
            #include p16f84a.inc
            __CONFIG 3FF0H
;_______________________________________________
;     32768 .
;     32,  
;  TMR0 (256)  ,  4 ,
;     1  (432256=32768).
;_________________________________________________
;  .
;__________________________________________________
INDF     EQU  00H  ;    FSR
TIMER0   EQU  01H  ;TMR0
OPTIONR  EQU  01H  ;OPTION (RP0=1)
PC       EQU  02H  ; 
STATUS   EQU  03H  ; 
FSR      EQU  04H  ;  
PORTA    EQU  05H  ;  /
PORTB    EQU  06H  ;  /
INTCON   EQU  0BH  ;  
;__________________________________________
;   .
;__________________________________________
SEC1        EQU  0CH   ;  
MIN1        EQU  0DH   ;  
HOU1        EQU  0EH   ;  
;_________________________________________
;     FLAG.
;_________________________________________
FLAG        EQU  0FH   
;
;     0->  .
;     1->   30 .  0-0-0 --.
;     2->        .
;
;     4->      .
;     5->   
;________________________________________________
;   .
;________________________________________________
S_LOW       EQU  010H  ;    
S_HIGH      EQU  011H  ;   
M_LOW       EQU  012H  ;  
M_HIGH      EQU  013H  ;  
H_LOW       EQU  014H  ;  
H_HIGH      EQU  015H  ;  
COUI        EQU  016H  ;  
;
; : , , , .
;
DAY1        EQU  017H  ;  
ATT         EQU  018H  ; ()  ()
GAU         EQU  019H  ;  30 
ALA1M       EQU  01BH  ; 1, 
ALA2M       EQU  01CH  ;2
ALA3M       EQU  01DH  ;3
ANOD        EQU  01EH  ;,  (0-5)
SEGD        EQU  01FH  ;,  .(2-10 )
CAT         EQU  020H  ;  
COR         EQU  023H  ;  
W_TEMP      EQU  024H  ;   W  
STATUS_TEMP EQU  025H  ;   STATUS  
DSMH        EQU  026H  ;   .
LSMH        EQU  027H  ;   
HSMH        EQU  028H  ;   .
FSR_TEMP    EQU  029H  ;  FSR
CORNEG      EQU  02AH  ; , -0
NEGCOR      EQU  02BH  ;   
ALA1H       EQU  02DH  ; 1, 
ALA2H       EQU  02EH  ;2
ALA3H       EQU  02FH  ;3
ALAUM       EQU  030H  ;   .
ALAUH       EQU  031H  ;   .
GACHH       EQU  032H  ;  
GACHM       EQU  033H  ;  
;___________________________________________________________________
;    
;____________________________________________________________________
        ORG 0
           GOTO INIT
        ORG 4
           GOTO COUNT
;____________________________________________________________________
; 
;______________________________________________________________________
INIT
 BSF   STATUS,RP0       ;   1.
 MOVLW B'00000100'      ;  , =32 ...100,
 MOVWF OPTION_REG^80H   ;  .
 MOVLW B'10100000'      ;  =   
 MOVWF INTCON           ;
 MOVLW B'00011000'      ; RA0-RA2- , RA3,RA4-
 MOVWF TRISA^80H
 MOVLW B'10000000'      ; RB0-RB6- , RB7-
 MOVWF TRISB^80H
 BCF   STATUS,RP0       ;   0.
 BCF   PORTB,6          ;  
 BCF   PORTB,5          ; EXE
 CLRF  CORNEG           ;   , 
 CLRF  FLAG             ;  
 CLRF  TMR0             ;   
 CLRF  SEC1
 CLRF  MIN1
 CLRF  HOU1
 CLRF  S_LOW
 CLRF  S_HIGH
 CLRF  M_LOW
 CLRF  M_HIGH
 CLRF  H_LOW
 CLRF  H_HIGH
 CLRF  HSMH
 CLRF  LSMH
 CLRF  ATT
 CLRF  GAU
 CLRF  COR
 CLRF  COUI
 CLRF  ALA1M
 CLRF  ALA1H
 CLRF  ALA2M
 CLRF  ALA2H
 CLRF  ALA3M
 CLRF  ALA3H
 CLRF  GACHH
 CLRF  GACHM
 MOVLW .1           ; 
 MOVWF CAT          ; 
 MOVWF DAY1         ;  
 
;_______________________________________________________________
; 1.    .
;________________________________________________________________
KEY
         BTFSS   FLAG,4      ;  ,
         GOTO    KEYF        ; ,   .
KEYO
         BTFSC   PORTB,7     ;    ?
         GOTO    ATTK        ;.
         BTFSC   FLAG,1      ;  ,
         GOTO    KEYC        ;  30 ,
         GOTO    CATK        ;    .
KEYF
         MOVFW   GACHH       ;    
         SUBWF   GACHM,0     ;   .
         BZ      KEYO        ;   , .
         BSF     FLAG,4      ;   .
         GOTO    KEYO        ;    . 
KEYC
         INCF    GAU,1       ;  
         MOVLW   .30         ;30 
         SUBWF   GAU,0       ; .
         BTFSC   STATUS,Z    ;   0, 
         CALL    CORN        ;   .

;__________________________________________________________________
; 2.    ( ).
;____________________________________________________________________
CATK
         CALL    S1          ;  :  .
         BTFSS   PORTA,3     ;    ,
         GOTO    CATKU       ;  ,
         INCF    CAT,1       ; +1    .
         MOVFW   CAT         ;6  ,     .
         SUBLW   .7          ;  6,
         BZ      CATK0       ;  .
         GOTO    ATTGO       ; .
;
;      .
;
CATKU
         MOVFW   CAT         ;  
         ADDWF   PC,1        ;:
         GOTO    ATTIN       ;
         GOTO    ATTB        ;,
         GOTO    ATTUM       ; ,
         GOTO    ATTUM       ; ,
         GOTO    ATTUH       ; ,
         GOTO    ATTUH       ; ,
         GOTO    ATTB        ;.
CATK0
        CLRF   CAT           ;.
        GOTO   ATTGO         ; .
;_____________________________________________________________________
; 3.   .
;____________________________________________________________________
ATTK                       ;     ,
        CALL   S1          ;      1 .
        MOVLW   .10        ;  "" 
        MOVWF   S_HIGH     ;    .
        INCF    ATT,F      ;  .
        MOVFW   ATT        ;   (ATT) 
        MOVWF   S_LOW      ;   .
        SUBLW   .8         ;   7  (0-7).
        BNZ     ATTGO      ;   , .
        CLRF    ATT        ;  
        CLRF    S_LOW      ;    .
        GOTO    ATTGO      ; .
;_______________________________
; 4.   = .
;_______________________________
ATTUM
        MOVFW   ATT       ; ?   =2,3
        ADDWF   PC,1      ;   .
        GOTO    MIN1M     ; .
        GOTO    ALAKB1M   ;  1 .
        GOTO    ALAKB2M   ;  2 .
        GOTO    ALAKB3M   ;  3 .
        GOTO    GACHK     ;   .
        GOTO    ATTK5     ;:   .
        GOTO    HID       ;:    .
        GOTO    ATTK7     ;    .
ATTUH
        MOVFW   ATT       ; ? =4,5
        ADDWF   PC,1      ;   .
        GOTO    HOU1H     ; .
        GOTO    ALAKB1H   ;  1 .
        GOTO    ALAKB2H   ;  2 .
        GOTO    ALAKB3H   ;  3 .
        GOTO    GACHN     ;   .
        GOTO    ATTK5     ;:   .
        GOTO    HID       ;:    .
        GOTO    ATNEG     ;  .
ATTB
        MOVFW   ATT       ; ? =1,6
        ADDWF   PC,1      ;   .
        GOTO    ATTGO     ;, .
        GOTO    FREK1     ;:  1 .
        GOTO    FREK2     ;:  2 .
        GOTO    FREK3     ;:  3 .
        GOTO    GACHIN    ;   (-).
        GOTO    ATTK5     ;:   .
        GOTO    HID       ;:    .
        GOTO    ATTIK     ; .
ATTIN
        MOVFW   ATT       ; ? =0
        ADDWF   PC,1      ;   .
        GOTO    ATTOO     ; .
        GOTO    FRIN1     ; 1 .
        GOTO    FRIN2     ; 2 .
        GOTO    FRIN3     ; 3 .
        GOTO    DAY1D     ;  .
        GOTO    ATTK5     ;:   .
        GOTO    HID       ;:    .
        GOTO    ATTIK     ; .
;____________________________________
; 5.   .
;___________________________________
ATTOO
        BTFSS   PORTA,4    ;   .
        GOTO    ATTGO      ;.        
        CLRF    SEC1       ;,    
        CLRF    MIN1       ;   
        CALL    HIN        ; .
        GOTO    ATTGO      ; .
;___________________________________
; 6.     .
;__________________________________
MIN1M
        BTFSS   PORTA,4    ;   .
        GOTO    ATTGO      ;.
        MOVLW   .10        ;.
        MOVWF   S_HIGH     ;  
        MOVFW   ATT        ; 
        MOVWF   S_LOW      ;  .
        CALL    M1M        ;+1   .
        CALL    HIH        ;  .
        GOTO    ATTGO      ; .
HOU1H
        BTFSS   PORTA,4    ;  .
        GOTO    ATTGO      ;
        MOVLW   .10        ;
        MOVWF   S_HIGH     ;
        MOVFW   ATT        ;
        MOVWF   S_LOW      ;
        CALL    H1H        ;+1   .
        CALL    HIN        ;  .
        GOTO    ATTGO      ; .
DAY1D
        BTFSS   PORTA,4    ;  .
        GOTO    ATTGO      ;
        MOVLW   .10        ;
        MOVWF   S_HIGH     ;
        MOVFW   ATT        ;
        MOVWF   S_LOW      ;
        CALL    D1         ;+1   .
        CALL    HIN        ;  
        CALL    HIH        ; .
        GOTO    ATTGO      ; .
;___________________________________
; 7.     .
;___________________________________
FRIN1
        MOVLW   .10         ;  :
        MOVWF   S_HIGH      ;""    
        MOVFW   ATT         ;  
        MOVWF   S_LOW       ;  
        MOVFW   ALA1M       ; 1 .
        CALL    M1U         ; .
        MOVFW   ALA1H
        CALL    H1U         ; .
        GOTO    ATTGO       ; .
FRIN2
        MOVLW   .10         ;   .
        MOVWF   S_HIGH      ;
        MOVFW   ATT         ;
        MOVWF   S_LOW       ;
        MOVFW   ALA2M       ; 2 .
        CALL    M1U         ; .
        MOVFW   ALA2H
        CALL    H1U         ; .
        GOTO    ATTGO       ; .
FRIN3
        MOVLW   .10         ;   .
        MOVWF   S_HIGH      ;
        MOVFW   ATT         ;
        MOVWF   S_LOW       ;
        MOVFW   ALA3M       ; 3 .
        CALL    M1U         ; .
        MOVFW   ALA3H
        CALL    H1U         ; .
        GOTO    ATTGO       ; .
HIN
        MOVFW   MIN1         ;
        CALL    M1U          ; .
        RETURN
HIH
        MOVFW   HOU1         ;
        CALL    H1U          ; .
        RETURN
HID                          ;      .
        MOVFW   DAY1         ; 
        MOVWF   S_HIGH       ;   .
        MOVLW   .10          ;
        MOVWF   S_LOW        ;  - "".
        CALL    HIN          ;  
        CALL    HIH          ; .
        GOTO    ATTGO        ; .

ATTK5                        ;:   .
        CALL    S1U          ; .  
        CALL    HIN          ;  
        CALL    HIH          ; .
        GOTO    ATTGO        ; .

GACHIN                      ;  .
        MOVLW   .10         ; 
        MOVWF   S_HIGH      ;
        MOVFW   ATT         ;  .
        MOVWF   S_LOW       ;
        MOVFW   GACHH       ; 
        CALL    H1U         ;   .
        MOVFW   GACHM       ; 
        CALL    M1U         ;   .
        GOTO    ATTGO       ; .
;____________________________________
; 8.   =2,3    .
;__________________________________
ALAKUM                        ;.    .
        MOVFW   ATT           ; 
        MOVWF   S_LOW         ;    .
        MOVLW   .10           ;  
        MOVWF   S_HIGH        ; "".
        MOVFW   ALAUM         ;   . 
        ADDLW  -3BH           ;-59
        BZ      RUM           ;  0,   - ,
        INCF    ALAUM,1       ; .
MUR     MOVFW   ALAUM         ;
        CALL    M1U           ;.
        RETURN                ;
RUM     CLRF    ALAUM         ;.
        GOTO    MUR           ;
;______________________________
ALAKB1M
      BTFSS     PORTA,4       ;    .
      GOTO      ATTGO         ;   ,  .
      MOVFW     ALA1M         ;  1   
      MOVWF     ALAUM         ;  .
      CALL      ALAKUM        ;+1   .
      MOVFW     ALAUM         ;   
      MOVWF     ALA1M         ;   1 . 
      GOTO      FRIN1         ; .
ALAKB2M
      BTFSS     PORTA,4       ;    .
      GOTO      ATTGO         ;   ,  .
      MOVFW     ALA2M         ;  2   
      MOVWF     ALAUM         ;  .
      CALL      ALAKUM        ;+1   .
      MOVFW     ALAUM         ;   
      MOVWF     ALA2M         ;   2 .
      GOTO      FRIN2         ; .
ALAKB3M
      BTFSS     PORTA,4       ;    .
      GOTO      ATTGO         ;   ,  .
      MOVFW     ALA3M         ;  3   
      MOVWF     ALAUM         ;  .
      CALL      ALAKUM        ;+1   .
      MOVFW     ALAUM         ;   
      MOVWF     ALA3M         ;   3 . 
      GOTO      FRIN3         ; .
;
;    .
;
GACHK
      BTFSS     PORTA,4       ;    . 
      GOTO      ATTGO         ;   ,  .
      MOVFW     GACHM         ;    
      MOVWF     ALAUH         ;    ..
      CALL      ALAKUH        ;+1   .
      MOVFW     ALAUH         ;    .
      MOVWF     GACHM         ;   .
      GOTO      GACHIN        ;    .
      
;________________________________
; 9.   =4,5    .
;________________________________

ALAKUH                        ;.    .
        MOVFW   ATT           ; 
        MOVWF   S_LOW         ;    .
        MOVLW   .10           ;  
        MOVWF   S_HIGH        ; "".
        MOVFW   ALAUH         ;    . .
        ADDLW   -17H          ;- 23 
        BZ      RUH           ;  0,  ,   .
        INCF    ALAUH,1       ; 1  .
HUR     MOVFW   ALAUH         ;
        CALL    H1U           ;.
        RETURN                ;
RUH     CLRF    ALAUH         ;.
        GOTO    HUR           ;
;_______________________________
ALAKB1H
      BTFSS     PORTA,4       ;   .
      GOTO      ATTGO         ;   ,  .
      MOVFW     ALA1H         ;  1   
      MOVWF     ALAUH         ;  .
      CALL      ALAKUH        ;+1   .
      MOVFW     ALAUH         ;   
      MOVWF     ALA1H         ;   1 .
      GOTO      FRIN1         ; .
ALAKB2H
      BTFSS     PORTA,4       ;   .
      GOTO      ATTGO         ;   ,  .
      MOVFW     ALA2H         ;  2   
      MOVWF     ALAUH         ;  .
      CALL      ALAKUH        ;+1   .
      MOVFW     ALAUH         ;   
      MOVWF     ALA2H         ;   2 .
      GOTO      FRIN2         ; .
ALAKB3H
      BTFSS     PORTA,4       ;   .
      GOTO      ATTGO         ;   ,  
      MOVFW     ALA3H         ;  3   
      MOVWF     ALAUH         ;  .
      CALL      ALAKUH        ;+1   .
      MOVFW     ALAUH         ;   
      MOVWF     ALA3H         ;   3 . 
      GOTO      FRIN3         ; .
;
;    .
;
GACHN
      BTFSS     PORTA,4       ;    .
      GOTO      ATTGO         ;   ,  .
      MOVFW     GACHH         ;    
      MOVWF     ALAUH         ;    ..
      CALL      ALAKUH        ;+1   .
      MOVFW     ALAUH         ;    .
      MOVWF     GACHH         ;   .
      GOTO      GACHIN        ; .
;_________________________________
; 10. ,   .
;_________________________________
ATTK7                         ;   . 
      BTFSS     PORTA,4       ;   .
      GOTO      ATTGO         ;   ,  .
      MOVFW     ATT           ;
      MOVWF     S_LOW         ;
      MOVLW     .10           ;
      MOVWF     S_HIGH        ;
      INCF      COR,1         ;+1   .
      MOVLW     .29           ;    28 .
      SUBWF     COR,0         ; ,  .
      BZ        ATT0          ; , .

ATTIK                         ;    .
      MOVFW     ATT           ;
      MOVWF     S_LOW         ;
      MOVLW     .10           ;""
      MOVWF     H_HIGH        ;  5  ( )
      MOVWF     S_HIGH        ;   .
      MOVFW     CORNEG        ;  
      MOVWF     H_LOW         ;   .
      MOVFW     COR           ;  
      CALL      M1U           ;   .
      GOTO      ATTGO         ; .

ATNEG                         ;  .
      BTFSS     PORTA,4       ;   .
      GOTO      ATTGO         ;   ,  .
      MOVFW     ATT           ;   .
      MOVWF     S_LOW         ;
      MOVLW     .10           ;
      MOVWF     S_HIGH        ;
      BTFSC     CORNEG,0      ;  = 0, ,
      GOTO      ATNEG1        ;     .
      BSF       CORNEG,0      ; : 1=  .
      GOTO      ATTIK         ;.
ATNEG1
      BCF       CORNEG,0      ;0=  .
      GOTO      ATTIK         ;. 
ATT0
      CLRF      COR           ;.
      GOTO      ATTIK         ;.     
;_________________________________
; 11.  .
;_________________________________
ATTGO
        BTFSC   INTCON,2     ;     ,
        GOTO    RETCONT      ; ,   .
        GOTO    COUZIKL1     ;   .
;_______________________________________________________________
; 12. .    .
;__________________________________________________________________

GACHZIKL
         MOVLW  B'00011111'  ; 1   .
         MOVWF  PORTB        ;
         MOVWF  PORTA        ; 1    5142  .
         BTFSS  PORTA,4      ;    ,
         GOTO   COUZIKL1     ;  ,
         BTFSS  FLAG,5       ;    .
         GOTO   COUZIKL1     ;   ,   .
         BSF    INTCON,7     ;   .
         GOTO   GACHZIKL     ;       .
;_______________________________________________________________________________
; 13. .     -    .
;________________________________________________________________________________ 

COUZIKL0                   ;    -  .
        BTFSS   PORTA,4    ;    ,
        GOTO    COUZIKL1   ;  .
        BTFSC   FLAG,5     ;   ,
        GOTO    GACHZIKL   ; .
COUZIKL1
        CLRF    ANOD       ;  .
        MOVLW   010H       ;    
        MOVWF   SEGD       ;     .
        GOTO    COUZ       ;   .
ZIKL
        INCF    ANOD,1     ;+1    ().
        MOVLW   B'00000110' ;  6.
        SUBWF   ANOD,0     ;      5.
        BZ      COUZIKL0   ;  6,  
COUZ
        INCF    COUI,1     ;+1    .
        MOVLW   .100       ;  .100    .
        SUBWF   COUI,0     ;.
        BZ      COUZ1      ;  0,    .

        MOVFW   ANOD       ;     
        SUBWF   CAT,0      ; .
        BNZ     COUZIKL2   ;,   .
        GOTO    COUZ3      ;    .
COUZ1
        CLRF    COUI       ;   .
        BTFSC   FLAG,2     ;,  0.
        GOTO    COUZ2      ;   .
        BSF     FLAG,2     ;    1.
        GOTO    COUZ3      ;  .
COUZ2
        BCF     FLAG,2     ;    0
COUZ3
        BCF     STATUS,0   ;.
        BTFSC   FLAG,2     ;    0, .
        BSF     STATUS,0   ;   1,   0    1.
        BTFSC   FLAG,0     ;   =0, .
        GOTO    INDAL      ; 
        GOTO    INDC       ; .
COUZIKL2  
        BCF     STATUS,0   ; 
        GOTO    INDC       ;  .

INDAL                      ;  .
        BSF     PORTB,5    ;    1
        BTFSS   SEC1,0     ;   1,  
                           ;(    ).
        GOTO    INDC       ;     .
        BCF     PORTB,5    ;  0  .
        BSF     PORTB,0    ;  .
        GOTO    INDAL      ;  1 .
INDC
        MOVFW   SEGD       ;   
        MOVWF   FSR        ;   .
        RLF     INDF,0     ; ,    
        MOVWF   PORTB      ;   TRISB 
        MOVFW   ANOD       ;  
        MOVWF   PORTA      ;  .
        BTFSC   FLAG,0     ;   = 1,
        BSF     PORTB,6    ;    RB6 (EXE).
        INCF    SEGD,F     ;+1  . .
        BSF     INTCON,7   ;   .
        GOTO    ZIKL       ;       .
;____________________________________________________________________
; 14.     .
;____________________________________________________________________
FREK1
        MOVLW   .10        ; 
        MOVWF   S_HIGH     ;
        MOVFW   ATT        ; .
        MOVWF   S_LOW      ;
        BCF     FLAG,0     ;   (  = 1).
        MOVFW   ALA1H      ;   1 ,
        SUBWF   HOU1,0     ;    .
        BZ      FREK1M     ; ,   ,
        GOTO    ATTGO      ;  .
FREK1M
        MOVFW   ALA1M      ;  1 .
        SUBWF   MIN1,0     ;   .
        BZ      ALARM      ; ,  ,
        GOTO    ATTGO      ;  .               

FREK2
        MOVLW   .10        ; 
        MOVWF   S_HIGH     ;
        MOVFW   ATT        ; .
        MOVWF   S_LOW      ;
        BCF     FLAG,0     ;   (  = 1).
        MOVFW   ALA2H      ;   2 .
        SUBWF   HOU1,0     ;    .
        BZ      FREK2M     ; ,   ,
        GOTO    ATTGO      ;  .

FREK2M
        MOVFW   ALA2M      ;  2 .
        SUBWF   MIN1,0     ;   .
        BZ      ALARM      ; ,  ,
        GOTO    ATTGO      ;  .

FREK3
        MOVLW   .10        ; 
        MOVWF   S_HIGH     ;
        MOVFW   ATT        ; .
        MOVWF   S_LOW      ;
        BCF     FLAG,0     ;   (  = 1).
        MOVFW   ALA3H      ;   3 .
        SUBWF   HOU1,0     ;    .
        BZ      FREK3M     ; ,   ,
        GOTO    ATTGO      ;  .

FREK3M
        MOVFW   ALA3M      ;  3 .
        SUBWF   MIN1,0     ;   .
        BZ      ALARM      ; ,  ,
        GOTO    ATTGO      ;  . 

;____________________________________________________________________
; 15.  .
;__________________________________________________________________
ALARM
        BTFSS   PORTA,4  ;     .
        GOTO    ATTGO    ; .
        BSF     FLAG,0   ;    = 1.
        GOTO    ATTGO    ;   .
;____________________________________________________________________
; 16. .     2-10  (2-_-2-10).
;____________________________________________________________________
BINDECH
        MOVLW   .10      ;10 >W.
BDH
        BSF     STATUS,0 ;  ""  STATUS.
        SUBWF   DSMH,1   ;   10 > DSMH.
        BNC     BINDECL  ;    .
        INCF    HSMH,1   ; 1   .
        GOTO    BDH      ;.                
BINDECL
        MOVF    DSMH,0   ;   
        ADDLW   .10      ;10+W >W.               
        MOVWF   LSMH     ;    .
        RETURN           ;
;_________________________________________________________________________________
; 17.       .
;________________________________________________________________________________-
COUNT
        MOVWF  W_TEMP      ;   W 
        MOVFW  STATUS      ;STATUS,
        MOVWF  STATUS_TEMP ;
        MOVFW  FSR         ;FSR.
        MOVWF  FSR_TEMP    ;
        BSF    PORTB,0     ;   .
        GOTO   KEY         ;  .

RETCONT                    ;  .
        BCF    INTCON,2    ;  (T0IF)   ( ).
        MOVFW  STATUS_TEMP ; :
        MOVWF  STATUS      ;STATUS,
        MOVFW  FSR_TEMP    ;
        MOVWF  FSR         ;FSR,
        MOVFW  W_TEMP      ;W.
        RETFIE             ;  .
;______________________________________________________________
; 18.     ---.
;______________________________________________________________
S1    
        MOVFW SEC1          ;    . .
        ADDLW  -3BH         ;   59.
        BZ      M1          ;  0,   ,   M1,
        INCF  SEC1,F        ;  1   .
        RETURN              ;

;  2_2-10     .

S1U                         
        MOVFW   SEC1        ;SEC1 >W.
        MOVWF  DSMH         ;W >DSMH.
        CALL   BINDECH      ;  . .
        MOVFW  LSMH         ;LSMH >W .
        MOVWF  S_LOW        ;W > S_LOW     .
        MOVFW  HSMH         ;HSMH >W .
        MOVWF  S_HIGH       ;W > S_HIGH      .
        CLRF   HSMH         ; . . ..
        CLRF   LSMH         ; . . ..
        RETURN              ;

; .

M1
        CLRF   SEC1         ;   .
        CLRF   S_LOW        ;  . 
        CLRF   S_HIGH       ;   .

; +1   .

M1M     MOVFW  MIN1         ;   . .
        ADDLW  -3BH         ;-59.
        BZ     H1           ;  0,  ,   H1.
        INCF   MIN1,F       ; 1  .
        MOVFW  MIN1         ;MIN1 >W.

;  2_2-10     .

M1U
        MOVWF  DSMH         ;W >DSMH.
        CALL   BINDECH      ;  . .
        MOVFW  LSMH         ;LSMH >W .
        MOVWF  M_LOW        ;W > M_LOW     .
        MOVFW  HSMH         ;HSMH >W .
        MOVWF  M_HIGH       ;W > M_HIGH      .
        CLRF   HSMH         ; . . ..
        CLRF   LSMH         ; . . ..
        RETURN              ;

; .

H1
        CLRF   MIN1         ;   .
        CLRF   M_LOW        ;   .
        CLRF   M_HIGH       ;   .

; +1   .

H1H     MOVFW  HOU1         ;   . .
        ADDLW  -17H         ;- 23. 
        BZ     H10          ;  0,  ,   H10.
        INCF   HOU1,F       ; 1  .
        BTFSC  FLAG,5       ;   ,
        GOTO   H1FK         ;,     .
        MOVFW  HOU1         ;  .
        SUBWF  GACHH,0      ;  ,
        BZ     H1F          ;   ,
        GOTO   H1H1         ;   .
H1FK
        MOVFW  HOU1         ;    
        SUBWF  GACHM,0      ;  .
        BZ     H1FOO        ;  ,   ,
        GOTO   H1H1         ;   .        
H1FOO
        BCF    FLAG,5       ;  
        BCF    FLAG,4       ;
        GOTO   H1H1         ;   .
        
H1F
        BSF    FLAG,5       ;   .

H1H1
        MOVFW  HOU1         ;HOU >W.

;  2_2-10     .

H1U
        MOVWF  DSMH         ;W >DSMH.
        CALL   BINDECH      ;  ..
        MOVFW  LSMH         ;LSMH >W .
        MOVWF  H_LOW        ;W > H_LOW     .
        MOVFW  HSMH         ;HSMH >W .
        MOVWF  H_HIGH       ;W > H_HIGH      .
        CLRF   HSMH         ; . . ..
        CLRF   LSMH         ; . . ..
        RETURN              ;
H10
        CLRF   HOU1         ;  .
        CLRF   H_LOW        ;  .
        CLRF   H_HIGH       ;  .
        BSF    FLAG,1       ;   30 .

; +1    .

D1
        INCF   DAY1,F       ;+1   .
DIN
        MOVFW  DAY1         ; .
D0
        MOVWF  S_HIGH       ; 2 .
        SUBLW  B'00001000'  ;   7?
        BZ     DAY          ; ,    1,   - .
        RETURN              ;
DAY
        MOVLW  01H          ;  1
        MOVWF  DAY1         ;  (0-  ).
        CALL   D0           ; .
        GOTO   ATTGO
;______________________________________________
; 19.    .
;______________________________________________
CORN
        BTFSS  CORNEG,0     ;,    (=1),
        GOTO   CORN1        ;    .
        MOVFW  COR          ;   .
        MOVWF  NEGCOR       ;   .
        NEGF   NEGCOR,0     ;    
        ADDWF  SEC1,1       ; .
        BCF    FLAG,1       ;  30 .
        CLRF   GAU          ;  30 .
        CALL   S1U          ;  .
        GOTO   ATTGO
CORN1
        MOVFW  COR          ;  
        ADDWF  SEC1,1       ; .
        CALL   S1U          ;  .
        BCF    FLAG,1       ;  30 .
        GOTO   ATTGO

    END
