;
;   11 ,
;  .
; 
;   .
;   .
; ., .
; saes@mail.ru
;
;  = OXPANAPM.ASM
; : 12-04-03.
;   : MPLAB IDE, : 5.61.00.
;
            #include p16f84a.inc
            __CONFIG 3FF0H
;======================================
;    32768 .
; RB0 - .
; RA4 -   .
; RB1-RB7 -  .
;======================================
;  .
;================
INDF     EQU  00H  ;    FSR.
TIMER0   EQU  01H  ;TMR0.
OPTIONR  EQU  81H  ;OPTION (RP0=1).
PC       EQU  02H  ; .
STATUS   EQU  03H  ;  .
FSR      EQU  04H  ;  .
PORTA    EQU  05H  ;  /.
PORTB    EQU  06H  ;  /.
TRISA    EQU  85H  ;   .
TRISB    EQU  86H  ;   .
INTCON   EQU  0BH  ;  .
;=================================
;   .
;=================================
SCN      EQU  0CH  ; .
SMC      EQU  0DH  ; .
SIN      EQU  0EH  ; .
;====================
;  .
;====================
W_TEMP      EQU  0FH  ;   W  .
STATUS_TEMP EQU  10H  ;   STATUS  .
FSR_TEMP    EQU  11H  ;  FSR.
;=========================================
;    FLAG.
;=========================================
FLAG     EQU  12H
;
;  0->   .
;  1->   .
;==================
; 1. .
;==================
        ORG 0
           GOTO INIT 
        ORG 4
           GOTO CONST
;==================
; 2. .
;==================
INIT
 BSF   STATUS,RP0       ;   1.
 MOVLW B'01000001'      ;  , =4 ...1.
 MOVWF OPTION_REG^80H   ;   .
 MOVLW B'10110000'      ;  =    R0.
 MOVWF INTCON           ;
 MOVLW B'00000000'      ; -  .
 MOVWF TRISA^80H
 MOVLW B'00000001'      ; RB1-RB7- , RB0-.
 MOVWF TRISB^80H
 BCF   STATUS,RP0       ;   0. 
 CLRF  TMR0             ;   
 CLRF  SCN
 CLRF  SMC
 CLRF  SIN
 CLRF  PORTB
 CLRF  FLAG
 GOTO  IND         ;  .
;========================================
; 3.     .
;========================================
SEGDATA                      ;  7, 6, 5, 4, 3, 2, 1, 0.
         ADDWF   PCL,F       ;  G, F, E, D, C, B, A, IN.
;        :               
         RETLW   B'00000000' ;   B'1111111'   . 
         RETLW   B'00001100' ;   B'1111001'  1 
         RETLW   B'10110110' ;   B'0100100'  2 
         RETLW   B'10011110' ;   B'0110000'  3 
         RETLW   B'11001100' ;   B'0011001'  4 
         RETLW   B'11011010' ;   B'0010010'  5 
         RETLW   B'11111010' ;   B'0000010'  6 
         RETLW   B'00001110' ;   B'1111000'  7 
         RETLW   B'11111110' ;   B'0000000'  8 
         RETLW   B'11011110' ;   B'0010000'  9
         RETLW   B'00010000' ;   B'1110111'  10
         RETLW   B'10000000' ;   B'0111111'  11 
;==============================================
; 4. . .
;============================================== 
IND
        MOVFW   SIN      ;   .
        CALL    SEGDATA  ;  .
        MOVWF   PORTB    ;    "B"   .
        GOTO    IND      ;.
;====================================
; 5.    .
;====================================
SEC
        BTFSS  PORTB,0   ;   .
        RETURN           ;  1,34 . .
        CLRF   SMC       ;   
        CLRF   TMR0      ;  .
        BTFSS  FLAG,0
        RETURN
        INCF   SCN,1     ;    .
        MOVLW  .20       ;  20  ,
        SUBWF  SCN,0     ;
        SKPNC
        BCF    PORTA,4   ; .
        RETURN
;====================================
; 6.    .
;====================================
SES
        MOVFW  SCN       ;   
        MOVWF  SIN       ;  .
        MOVLW  .12       ;  12  ,
        SUBWF  SIN,0     ;
        SKPNC
        CLRF   SIN       ;.
        MOVLW  .20       ;  20  ,
        SUBWF  SCN,0     ;
        SKPNC
        BCF    PORTA,4   ; .
        CLRF   SCN       ;.
        RETURN
;==================================================================
; 7.       .
;===================================================================
CONST
        MOVWF  W_TEMP      ;   W 
        MOVFW  STATUS      ;STATUS,
        MOVWF  STATUS_TEMP ;
        MOVFW  FSR         ;FSR.
        MOVWF  FSR_TEMP    ;
        BTFSS  INTCON,1
        GOTO   S01         ; 1  .
        CALL   SEC         ;    .
RECONST                    ;  .
        BCF    INTCON,2    ;    .
        BCF    INTCON,1    ;     R0.
        MOVFW  STATUS_TEMP ; :
        MOVWF  STATUS      ;STATUS,
        MOVFW  FSR_TEMP    ;
        MOVWF  FSR         ;FSR,
        MOVFW  W_TEMP      ;W.
      ;  CLRF    TMR0
        RETFIE             ;  .
;========================
; 8.  .
;========================
S01
        INCF    SMC,1      ;   8,   1 .
        MOVFW   SMC        ;
        ADDLW   -05H       ;=5.  
        SKPNZ              ; 
        CALL    SES        ; .
        MOVFW   SMC        ;
        ADDLW   -07H       ;=7.   
        SKPNZ              ;
        BCF     FLAG,0     ;  .
        SKPNZ              ;  
        BSF     PORTA,4    ; .
        MOVFW   SMC        ;   9,    1 .
        ADDLW   -09H       ;=9. 
        SKPNZ              ;  
        BCF     PORTA,4    ; .
        SKPNZ 
        BSF     FLAG,0     ; .
        SKPNZ 
        CLRF    SMC        ;
        GOTO    RECONST
        MOVFW   SMC        ;
        ADDLW   -0AH       ;=11.
        SKPNZ
        CLRF    SMC        ;  .
        GOTO    RECONST
;=============================================
        END
==============================================

