;
;     "REGISTRATOR"
;
;    , , .
;   .
;     .
; , ,
; saes@mail.ru.

            #INCLUDE P16F84A.INC

            __CONFIG 3FF0
; 11111111110000
; 0,1- , 00- 32-200 .
; 2- WDTE, 0- .
; 3- PWRTE, 0- .
; 4-13  . 1-  .
;_________________________________________________
;  .
;__________________________________________________
INDF     EQU  00H  ;    FSR.
TIMER0   EQU  01H  ;TMR0.
OPTIONR  EQU  01H  ;OPTION (RP0=1).
PC       EQU  02H  ; .
STATUS   EQU  03H  ;
FSR      EQU  04H  ;  .
PORTA    EQU  05H  ;
PORTB    EQU  06H  ;
INTCON   EQU  0BH  ;
;
DAY1        EQU  0CH   ; .
MON         EQU  0DH   ;.
HOU1        EQU  0EH   ; .
MIN1        EQU  0FH   ; .
SEC1        EQU  010H  ; .
CAUK        EQU  011H  ; .
M_LOW       EQU  012H  ;  .
M_HIGH      EQU  013H  ;  .
H_LOW       EQU  014H  ;  .
H_HIGH      EQU  015H  ;  .
ATT         EQU  018H  ; () .
CAU         EQU  019H  ;    10 .
ACOU        EQU  01AH  ;      .
KATOD       EQU  01BH  ;= ,   ( ).
COUI        EQU  01CH  ;  .
;_____________________________________
;    FLAG.
;___________________________________
FLAG        EQU  01DH
; 0-   ,
; 1-   ,
; 2-  , 
; 3-  , 
; 4-   ,
; 5-  ,
; 7-   .

ANOD        EQU  01EH  ;,  .
SEGD        EQU  01FH  ;   .
CAT         EQU  020H  ;  .
COU10S      EQU  021H  ;  .   .
COU10M      EQU  022H  ;    .
ATTZ        EQU  023H  ;   .
W_TEMP      EQU  024H  ;   W  .
STATUS_TEMP EQU  025H  ;   STATUS  .
DSMH        EQU  026H  ;   .
LSMH        EQU  027H  ;   .
HSMH        EQU  028H  ;   .
FSR_TEMP    EQU  029H  ;  FSR.
COUEE       EQU  02AH  ; .
MIN10       EQU  02BH  ;  .
DMHM        EQU  02CH  ;  .
CAUCOU      EQU  02DH  ;  .
ABCDE       EQU  02EH  ;    .
EEDATAD     EQU  030H  ;  .
EEDATAM     EQU  031H  ;  .
EEDATAH     EQU  032H  ;  .
EEDAMIN     EQU  033H  ;  .


;___________________________________________________________________
; .   
;____________________________________________________________________
           ORG 0
   
        GOTO INIT 
;
           ORG 4

        BTFSC  INTCON,RBIF   ;0?
        GOTO   ZAPISI        ;
        BTFSC  INTCON,2      ;
        GOTO   COUNT         ;
;____________________________________________________________________
; .
;______________________________________________________________________
INIT
 BSF   STATUS,RP0       ; 1.
 MOVLW B'00000100'      ;  , =32 ...100.
 MOVWF OPTION_REG^80H   ;
 MOVLW B'10101000'      ;  =   ,
 MOVWF INTCON           ;  PORTB.
 MOVLW B'00000000'      ;RA0-RA4- .
 MOVWF TRISA^80H
 MOVLW B'10000000'      ;RB0-RB6- , RB7-.
 MOVWF TRISB^80H
 BCF   STATUS,RP0       ; 0.
 CLRF  ACOU             ;   .
 CLRF  TMR0
 CLRF  SEC1
 CLRF  MIN1
 CLRF  HOU1
 CLRF  M_LOW
 CLRF  M_HIGH
 CLRF  H_LOW
 CLRF  H_HIGH
 CLRF  HSMH
 CLRF  LSMH
 CLRF  DMHM
 CLRF  COUEE
 CLRF  ATT
 CLRF  CAUK
 CLRF  CAUCOU
 CLRF  MIN10
 CLRF  CAT
 CLRF  FLAG
 MOVLW .1
 MOVWF MON          ;=1.
 MOVWF DAY1         ;=1.
 MOVWF COU10S       ;   =1.
 MOVWF COU10M       ;  ==1.
 MOVWF CAU          ;  1   1 .

;_______________________________________________________________
; 1.    .
;________________________________________________________________
KEY                          ;  2   .
         COMF    PORTB,W     ;   .
         XORLW   B'00000110' ;.
         BTFSC   STATUS,Z    ;  1,
         BSF     FLAG,1      ;  .
         COMF    PORTB,W     ;     .
         XORLW   B'10000110' ;.
         BTFSC   STATUS,Z    ;  0,
         BSF     FLAG,1      ;,    .
         BTFSC   FLAG,1      ;    ?
         GOTO    AKT         ; , .
         BTFSS   PORTB,1     ;    ?
         GOTO    ATTK        ;.
         GOTO    CATK        ;.

;__________________________________________________________________
; 2.    ( ).
;____________________________________________________________________
CATK
         CALL    S1          ;+1  .
         BTFSC   PORTB,2     ;0?
         GOTO    CATKU       ;.
         INCF    CAT,1       ;, +1   .
         MOVFW   CAT         ;
         SUBLW   .5          ;  4,
         BZ      CATK0       ;  .
         GOTO    ATTGO       ; .
CATKU
         MOVFW   CAT         ;  
         ADDWF   PC,1        ;:
         GOTO    ATTIN       ;,
         GOTO    ATTUM       ; ,
         GOTO    ATTB        ;, 
         GOTO    ATTUH       ; ,
         GOTO    ATTIN       ;.
CATK0
        CLRF   CAT           ;.
        GOTO   ATTGO         ; .
;_____________________________________________________________________
; 3.   .
;____________________________________________________________________
ATTK                       ;     .
        CALL    S1         ;
        INCF    ATT,F      ;  .
        MOVFW   ATT        ;
        SUBLW   .4         ;   3  (0-3).
        BNZ     ATTGO      ;    ,
        CLRF    ATT        ;  .
        GOTO    ATTGO      ; .

;________________________________________________________
; 4.     .
;________________________________________________________
AKTEE
        MOVLW   .10         ;  H --.
        MOVWF   H_LOW       ;
        MOVWF   H_HIGH      ;
        MOVFW   COUEE       ;     
        CALL    M1U         ;  .
        GOTO    ATTGO       ;
AKTCO
        MOVLW   .10         ;   --.
        MOVWF   M_LOW       ;
        MOVWF   M_HIGH      ;
        MOVFW   ACOU        ;    
        CALL    H1U         ;  .
        GOTO    ATTGO       ;
AKTDM
        MOVFW   EEDATAD     ;
        CALL    H1U         ;  .
        MOVFW   EEDATAM     ;
        CALL    M1U         ;  .
        GOTO    ATTGO       ;
AKTHM
        MOVFW   EEDATAH     ;
        CALL    H1U         ;.
        MOVFW   EEDAMIN     ;
        CALL    M1U         ;.
        GOTO    ATTGO       ;


ATTDATA
        MOVFW   ATT         ;
        ADDWF   PCL,F       ;
        GOTO    AKTCO       ;  .
        GOTO    AKTDM       ; .
        GOTO    AKTHM       ; .
        GOTO    AKTEE       ;  .

ZAPDATA
        MOVFW   ATT         ;   
        ADDWF   PCL,F       ; .
        RETLW   B'00100010' ;0, ,  000,0
        RETLW   B'01000100' ;1, ,  00,00
        RETLW   B'00000000' ;2,  0000
        RETLW   B'00010001' ;3, ,  0000,


;_______________________________
; 5.   = .
;_______________________________
ATTUM
        MOVFW   ATT       ; ?   =1.
        ADDWF   PC,1      ;   .
        GOTO    MIN1M     ; .
        GOTO    MON1M     ; .
        GOTO    HIN       ;:  .
        GOTO    ECUS      ;    (10 ).
ATTUH
        MOVFW   ATT       ; ? =3.
        ADDWF   PC,1      ;   .
        GOTO    HOU1H     ; .
        GOTO    DAY1D     ; .
        GOTO    HIN       ;:  .
        GOTO    ECUM      ;    (10 ).
ATTB
        MOVFW   ATT       ; ? =2.
        ADDWF   PC,1      ;   .
        GOTO    ATTOO     ; .
        GOTO    DEYIN     ;   .
        GOTO    HIN       ;:  .
        GOTO    EEFF      ;  , .
ATTIN
        MOVFW   ATT       ; ? =0,4.
        ADDWF   PC,1      ;   .
        GOTO    DEYIN     ;   .
        GOTO    OCAU1     ;    10 .
        GOTO    HIN       ;:  .
        GOTO    OCAUI     ;  =1. (15)
;____________________________________________________________________
; 6.    .
;____________________________________________________________________
DEYIN
        MOVFW   DAY1       ; 
        CALL    H1U        ;  .
        MOVFW   MON        ;-
        CALL    M1U        ;  .
        GOTO    ATTGO

DAYMON
        MOVFW  MON          ;   .
        ADDWF  PCL,F        ;
        NOP                 ;0
        RETLW  .31          ;1-
        RETLW  .28          ;2-
        RETLW  .31          ;3-
        RETLW  .30          ;4-
        RETLW  .31          ;5-
        RETLW  .30          ;6-
        RETLW  .31          ;7-
        RETLW  .31          ;8-
        RETLW  .30          ;9-
        RETLW  .31          ;10-
        RETLW  .30          ;11-
        RETLW  .31          ;12-
;___________________________________________________
; 7.     .
;___________________________________________________
SEGDATA                     ;RB7, 6, 5, 4, 3, 2, 1, 0
        ADDWF   PCL,F       ;EXE, A, B, C, D, E, F, G
        RETLW   B'11111110' ;0
        RETLW   B'10110000' ;1
        RETLW   B'11101101' ;2
        RETLW   B'11111001' ;3
        RETLW   B'10110011' ;4
        RETLW   B'11011011' ;5
        RETLW   B'11011111' ;6
        RETLW   B'11110000' ;7
        RETLW   B'11111111' ;8
        RETLW   B'11111011' ;9
        RETLW   B'10000001' ;-
;____________________________________
; 8.    .
;___________________________________
ATTOO
        BTFSC   PORTA,4    ;   .
        GOTO    ATTGO      ;.
        CLRF    SEC1       ;.
        CLRF    MIN1       ;
        GOTO    HIN        ; .
;____________________________________________
; 9.        . 
;__________________________________________
EEFF
        BTFSC   PORTA,4    ;   .
        GOTO    AKTEE      ;
        MOVLW   .4         ;+4
        ADDWF   COUEE,1    ;
        MOVLW   .64        ;  63 (3F).
        SUBWF   COUEE,0    ;
        BZ      EEFFO      ; .
        GOTO    AKTEE      ;
EEFFO
        ;MOVLW   .4         ;  
        ;MOVWF   COUEE      ; .
        CLRF    COUEE      ;
        GOTO    AKTEE      ; .
;___________________________________
; 10.  .
;__________________________________
MIN1M
        BTFSC   PORTA,4    ;   .
        GOTO    ATTGO      ;.
        CALL    M1M        ;+1   .
        MOVFW   HOU1       ;MIN1 >W.
        CALL    H1U        ;  .
        GOTO    ATTGO
HOU1H
        BTFSC   PORTA,4    ; .
        GOTO    ATTGO      ;
        CALL    H1H        ;+1   .
        MOVFW   MIN1       ;MIN1 >W.
        CALL    M1U        ;  .
        GOTO    ATTGO
;__________________________________________
DAY1D
        BTFSC   PORTA,4    ; .
        GOTO    DAY1DI     ;
        CALL    D1H        ;+1   .
DAY1DI
        MOVFW   DAY1       ;   
        CALL    H1U        ;.
        MOVLW   .10        ;
        MOVWF   M_HIGH     ;   .
        MOVWF   M_LOW      ;
        GOTO    ATTGO
;___________________________________________
MON1M
        BTFSC   PORTA,4    ; .
        GOTO    MON1MI     ;
        CALL    MO1H       ;+1   .
MON1MI
        MOVFW   MON        ;   
        CALL    M1U        ;.
        MOVLW   .10        ;
        MOVWF   H_HIGH     ;   .
        MOVWF   H_LOW      ;
        GOTO    ATTGO
;_____________________________________________________________________
; 11.      .
;__________________________________________________________________
AKT
        CALL    S1         ;+1  .
        BCF     STATUS,Z   ;  .
        BTFSS   PORTB,1    ;  ,
        GOTO    EEAKT      ;   .
        BTFSC   PORTA,4    ;   ?
        GOTO    ATTGO      ; ,  .
        BTFSC   FLAG,7     ; ?
        GOTO    AKT2       ;.
        CLRF    ACOU       ;, .
        BSF     FLAG,7     ;  .

AKT2
        CALL    AKTETE     ;  .
        MOVWF   EEDATAD    ;   .
        INCF    ACOU,1     ;1
        CALL    AKTETE     ;  .
        MOVWF   EEDATAM    ;   .
        INCF    ACOU,1     ;2
        CALL    AKTETE     ;  .
        MOVWF   EEDATAH    ;   .
        INCF    ACOU,1     ;3
        CALL    AKTETE     ;  .
        MOVWF   EEDAMIN    ;   .

        INCF    ACOU,1     ;+1
        MOVFW   COUEE      ;   ./////////////
        ADDLW   .4         ;+4.
        SUBWF   ACOU,0     ;   .
        BZ      AKT4       ;  ,  ,
        GOTO    EEAKT1     ;   .
AKT4
        BCF     FLAG,1     ;  .
        CLRF    ACOU       ;.
        BCF     FLAG,7     ;
        GOTO    ATTGO      ;.

AKTETE
        MOVFW   ACOU       ; .
        MOVWF   EEADR      ;
        BSF     STATUS,RP0 ; 1.
        BSF  EECON1^80H,RD ;.
        BCF     STATUS,RP0 ; 0.
        MOVLW   .255       ;   ,
        SUBWF   EEDATA,0   ; -0.
        BTFSC   STATUS,Z   ;
        GOTO    AKTETEO    ;
        MOVFW   EEDATA     ;
        RETURN
AKTETEO
        MOVLW   .0         ;-0.
        RETURN    
EEAKT

        INCF    ATT,F      ;  .
        MOVFW   ATT        ;
        SUBLW   .4         ;   3  (0-3).
        SKPNZ              ;,   ,
        CALL    AKTO       ;  .
EEAKT1
        MOVFW   ATT        ;
        CALL    ZAPDATA    ;    .
        MOVWF   ATTZ       ; .
        GOTO    ATTDATA    ;     .

AKTO
        CLRF    ATT         ;.
        RETURN
;_______________________________________________________
; 12.         .
;______________________________________________________
ECUS
        BTFSC   PORTA,4    ;  .
        GOTO    ECUSIN     ;
        DECF    COU10S,1   ;-1.
        TSTF    COU10S     ;0?
        BZ      ECUSO      ;,  .
ECUSIN
        MOVFW   COU10S     ;
        CALL    M1U        ;   .
        MOVLW   .10        ;-
        MOVWF   H_HIGH     ;   .
        MOVWF   H_LOW      ;
        GOTO    ATTGO      
ECUSO
        MOVLW   .20        ; 20 ( ,  ).
        MOVWF   COU10S     ;
        GOTO    ECUSIN     ; .
ECUM
        BTFSC   PORTA,4    ;  .
        GOTO    ECUMIN     ;
        DECF    COU10M,1   ;-1
        TSTF    COU10M     ;0?
        BZ      ECUMO      ;,  .
ECUMIN
        MOVFW   COU10M     ;
        CALL    H1U        ;   .
        MOVLW   .10        ;
        MOVWF   M_HIGH     ;   .
        MOVWF   M_LOW      ;
        GOTO    ATTGO      
ECUMO
        MOVLW   .20        ; 20 ( ,  ).
        MOVWF   COU10M     ;
        GOTO    ECUMIN     ; .
;___________________________________
; 13.       .
;___________________________________

HIN
        MOVFW   MIN1         ;   .
        CALL    M1U          ; .
        MOVFW   HOU1         ;
        CALL    H1U          ; .
        GOTO    ATTGO        ;

;____________________________________
; 14.  .
;__________________________________
EEIN
        BTFSS   FLAG,1      ; =1? .
        GOTO    COUZIKL0    ; .
        BSF     STATUS,C    ;  1.
        MOVLW   B'11101110' ;  .
        MOVWF   ANOD        ;
        MOVLW   012H        ;    .
        MOVWF   SEGD        ;   .

EEIN1
        BCF     FLAG,5     ;0
        COMF    ANOD,0     ;  ,
        XORWF   ATTZ,0     ;
        BNZ      EEIN3     ;  .
        BSF     FLAG,5     ;1

EEIN3
        MOVFW   SEGD       ;     
        MOVWF   FSR        ;   .
        MOVFW   INDF       ; 2-10 .
        CALL    SEGDATA    ;    
        MOVWF   PORTB      ;  .
        MOVFW   ANOD       ; 
        MOVWF   PORTA      ;  .
        BTFSC   FLAG,5     ;  =1,
        BSF     PORTA,4    ; .
        BTFSS   FLAG,5     ;  =0,
        BCF     PORTA,4    ; .
EEIN4
        INCF    SEGD,F     ;+1    .
        MOVLW   B'01110111' ;   ,
        XORWF   ANOD,0     ;    ""  1
        BTFSC   STATUS,Z   ; 0, ,
        GOTO    EEIN       ;  .
        BSF     STATUS,C   ;  1.
        RLF     ANOD,1     ; .
        GOTO    EEIN1      ;

;_________________________________
; 15.    10 ,   .
;_________________________________ 
OCAU1

        BTFSC   PORTA,4      ;   ,
        GOTO    OCAUI        ;  .
        INCF    CAU,1        ;+1
        MOVLW   .21          ; 20  10  (!).
        SUBWF   CAU,0        ;  0, 
        BZ      OCAUO        ;  .
        GOTO    OCAUI        ;  .

OCAUO
        MOVLW   .1           ; 1.
        MOVWF   CAU          ;

OCAUI
        CLRF    H_HIGH       ;
        CLRF    H_LOW        ;0   .
        MOVFW   CAU          ;   .
        CALL    M1U          ;
        GOTO    ATTGO        ;
;____________________________________
; 16.  .
;_________________________________
ATTGO
        BTFSC   INTCON,2     ;  ,   .
        GOTO    RETCONT      ;  .
        GOTO    COUZIKL0     ; .
;_______________________________________________________________________________
; 17. .    0-7 ; 0-3.
;________________________________________________________________________________ 

COUZIKL0
        BSF     STATUS,C    ;  1.
        MOVLW   B'11101110' ;  .
        MOVWF   ANOD        ;
        
        BTFSC   FLAG,1      ;0? .
        GOTO    EEIN        ;,   .
        BSF     INTCON,7    ;
        CLRF    KATOD       ;  2-10.
        MOVLW   012H        ;    
        MOVWF   SEGD        ;   .
        GOTO    COUZ
ZIKL
        INCF    KATOD,1     ;+1   .
        MOVLW   B'00000100' ;  4.
        SUBWF   KATOD,0     ;  .
        BZ      COUZIKL0    ;  0, .
COUZ
        INCF    COUI,1     ;+1    .
        MOVLW   .40        ;40-   
        SUBWF   COUI,0     ; .
        BNZ     COUZ3      ;   0, .
        GOTO    COUZ1      ;,   .

COUZ1
        CLRF    COUI       ;  .
        BTFSC   FLAG,2     ;,  0,
        GOTO    COUZ2      ;
        BSF     FLAG,2     ;
        GOTO    COUZ3      ;
COUZ2
        BCF     FLAG,2     ;    0.

COUZ3
        BTFSS   FLAG,2     ;,  1.
        GOTO    INDCO      ;
        MOVFW   KATOD      ;     
        SUBWF   CAT,0      ; .
        BNZ     INDCO      ;   .
INDCG
        MOVLW   B'1111'    ;   
        MOVWF   PORTA      ;   
        GOTO    INDC1      ; ( ).
INDCO

        MOVFW   KATOD      ;  ,
        SUBWF   ATT,0      ;\
        BNZ     GDATA      ;INDC       ;   .
        BSF     FLAG,5     ; .

GDATA

        MOVFW   SEGD       ;     
        MOVWF   FSR        ;   .
        MOVFW   INDF       ; 2-10 .
        CALL    SEGDATA    ;    
        MOVWF   PORTB      ;  .
        MOVFW   ANOD       ;
        MOVWF   PORTA      ;
        BTFSC   FLAG,5     ;  =1,
        BSF     PORTA,4    ; .
        BTFSS   FLAG,5     ;  =0,
        BCF     PORTA,4    ; .
INDC1
        BCF     FLAG,5     ;
        INCF    SEGD,F     ;+1    .
        MOVLW   B'01110111' ;   ,
        XORWF   ANOD,0     ;    ""  1.
        BTFSC   STATUS,Z   ; 0, .
        GOTO    INDO       ;
        BSF     STATUS,C   ;  1.
INDO
        RLF     ANOD,1     ; .
        BTFSC   FLAG,0     ;   ,
        GOTO    INDCF      ;   .
        GOTO    ZIKL       ;  .
;_____________________________________
; 18.   .
;______________________________________
INDCF
        BSF     INTCON,5   ; .
        BSF     STATUS,RP0 ; 1.
        MOVLW   B'00000000' ;  , 7   0  .
        MOVWF   TRISB^80H  ;
        BCF     STATUS,RP0 ; 0.
        BSF     PORTB,7    ;0
        BCF     INTCON,5   ; .
INDCFN 
        BCF     PORTB,7    ;0 
        MOVLW   .255       ;255      (0,8 ).
INDCFNN
        BCF     PORTB,7    ;0 
        ADDLW   -1H
        NOP
        NOP
        NOP
        NOP
        NOP
        NOP
        NOP
        NOP
        NOP
        NOP
        NOP
        NOP
        NOP
        NOP
        NOP
        NOP
        NOP
        NOP
        NOP
        NOP
        NOP
        NOP
        NOP
        BZ      INDCFO     ;  
        GOTO    INDCFNN    ;
INDCFO
        BSF     PORTB,7    ; ,     .
        BCF     FLAG,0     ;0
        NOP
        NOP
        BSF     STATUS,RP0   ; 1.
        MOVLW   B'10000000'  ;
        MOVWF   TRISB^80H    ;  .
        BCF     STATUS,RP0   ; 0.
        BCF     INTCON,0     ;
        BSF     INTCON,5     ;
        GOTO    COUZIKL0     ; .
;____________________________________________________________________
; 19.        .
;__________________________________________________________________
ZAPISI
        MOVWF  W_TEMP       ;   W 
        MOVFW  STATUS       ;STATUS,
        MOVWF  STATUS_TEMP  ;
        MOVFW  FSR          ;FSR.
        MOVWF  FSR_TEMP     ;
        BTFSC  PORTB,7      ;0?
        GOTO   RECONST      ;
        GOTO   KEYC         ;
RECONST                     ; 
        MOVFW  STATUS_TEMP  ;
        MOVWF  STATUS       ; W  STATUS,
        MOVFW  FSR_TEMP     ;FSR.
        MOVWF  FSR          ;
        MOVFW  W_TEMP       ;
        BCF    INTCON,6     ;     .
        BCF    INTCON,0     ;    .
        BSF    INTCON,7     ;  .
        RETFIE              ;  .
;_________________________________________________________________
; 20.   .
;__________________________________________________________________
KEYC
        MOVLW   .50         ;200 
KEYC1
        ADDLW   -1H         ;24 MS-   
        BTFSS   STATUS,Z    ;.
        GOTO    KEYC1       ;

        BTFSC   PORTB,7     ;  ?
        GOTO    RECONST     ;.

        BTFSC   FLAG,3      ;   1?
        GOTO    RECONST     ;.

        BTFSC   FLAG,0       ;  ?
        GOTO    RECONST      ;.

        BSF     FLAG,4       ;.  10 .
        INCF    CAUK,1       ;+1   .
        BCF     STATUS,Z     ;
        MOVFW   CAUK         ;  
        SUBWF   CAU,0        ; .
        BZ      ZAPIS        ;=0
        GOTO    RECONST      ;
ZAPIS
        CLRF    CAUK         ;  .
        CLRF    ACOU         ;
        BSF     FLAG,0       ; .
        BSF     FLAG,3       ;1

ZAPISO
        MOVLW   0CH          ;    EEDATA.
        MOVWF   ABCDE        ;, , , .

ZAPISE
        MOVFW   ABCDE        ;  
        MOVWF   FSR          ; 
        MOVFW   INDF         ;
        MOVWF   DMHM         ; .
        MOVFW   COUEE        ; .
        MOVWF   EEADR        ;
        MOVFW   DMHM         ;
        MOVWF   EEDATA       ;
        BCF     INTCON,GIE   ; .
        BSF     STATUS,RP0   ; 1.
        BSF     EECON1^80H,WREN ; .2
        MOVLW   55H          ; 
        MOVWF   EECON2^80H   ;/
        MOVLW   0AAH         ;/
        MOVWF   EECON2^80H   ;/
        BSF     EECON1^80H,WR ;    .1
ZAPIZ
        BTFSS   EECON1^80H,4 ;   
        GOTO    ZAPIZ        ;  .
        BCF     INTCON,6     ;     .
        BCF     EECON1^80H,4 ;
        BCF     EECON1^80H,WREN ; .2
        BCF     STATUS,RP0   ; 0.

        INCF    COUEE,1      ;+1   .
        MOVFW   COUEE        ;
        SUBLW   .64          ;
        BZ      EECNOO       ;
        INCF    ACOU,1       ;+1   .
        MOVLW   .4           ;0-3.
        SUBWF   ACOU,0       ;
        BZ      EECNOOO      ;
        INCF    ABCDE,1      ;+1   .
        GOTO    ZAPISE       ;    .

EECNOO
        CLRF    COUEE        ;  .
EECNOOO
        CLRF    ACOU         ;
        GOTO    RECONST      ; .
;____________________________________________________________________
; 21. .  2-_-2-10.
;____________________________________________________________________
BINDECH                  ;    2-10 .
        MOVLW   .10      ;10 >W.
BDH
        BSF     STATUS,0 ;  ""  STATUS.
        SUBWF   DSMH,1   ;   10 > DSMH.
        BNC     BINDECL  ;    .
        INCF    HSMH,1   ; 1   .
        GOTO    BDH      ;.                
BINDECL
        MOVF    DSMH,0   ;   
        ADDLW   .10      ;10+W >W.               
        MOVWF   LSMH     ;    .
        RETURN           ;
;_________________________________________________________________________________
; 22.       .
;________________________________________________________________________________-
COUNT
        MOVWF  W_TEMP       ;   W 
        MOVFW  STATUS       ;STATUS,
        MOVWF  STATUS_TEMP  ;
        MOVFW  FSR          ;FSR.
        MOVWF  FSR_TEMP     ;
        MOVLW  B'11111111'  ;    .
        MOVWF  PORTA        ;   .
        MOVWF  PORTB        ;
        BSF     STATUS,RP0  ; 1.
        MOVLW  B'00010000'  ;RA4     .
        MOVWF  TRISA^80H    ;
        MOVLW   B'10000110' ;     (1, 2, 7).
        MOVWF   TRISB^80H   ;
        BCF     STATUS,RP0  ; 0.
        GOTO   KEY          ;
RETCONT                     ;  
        BSF     STATUS,RP0  ;1 .
        MOVLW   B'10000000' ; , 7- .
        MOVWF   TRISB^80H   ;
        MOVLW  B'00000000'  ; .
        MOVWF  TRISA^80H    ;
        BCF    EECON1^80H,4     ;
        BCF     STATUS,RP0  ; 0.
        BCF    INTCON,6     ;
        BCF    INTCON,2     ;  (T0IF)   ( ).
        MOVFW STATUS_TEMP   ;  
        MOVWF STATUS        ; W  STATUS,
        MOVFW FSR_TEMP      ;FSR.
        MOVWF   FSR         ;
        MOVFW W_TEMP        ;
        RETFIE              ;  .

;______________________________________________________________
; 23.     --, -.
;______________________________________________________________
S1
        BTFSS  FLAG,4       ; 10  ?
        GOTO   S1S          ;.
        INCF   CAUCOU,1     ;, +1.
        MOVFW  CAUCOU       ;
        SUBWF   COU10S,0    ; 10  ?
        BZ      S1INT       ;.
        GOTO    S1S         ;.
S1INT
        CLRF    CAUCOU      ;.
        CLRF    CAUK        ;
        BCF     FLAG,4      ;  10 .
S1S
        MOVFW SEC1          ;  . .
        ADDLW  -3BH         ;   59.
        BZ      M1          ;  0,   ,   M1.
        INCF  SEC1,F        ; 1  .
        RETURN              ;
M1
        CLRF   SEC1         ;   .
        BTFSS  FLAG,3       ; ?
        GOTO   M1M          ;, .
        INCF   MIN10,1      ;+1   10 .
        MOVFW  MIN10        ; .
        SUBWF  COU10M,0     ;
        BZ     M10          ;10 . ?  ,
        GOTO   M1M          ;  .
M10
        CLRF   MIN10        ;
        BSF    FLAG,0       ;     . .
        BCF    FLAG,3       ;  .     
M1M
        MOVFW  MIN1         ;   . .
        ADDLW  -3BH         ;-59.
        BZ     H1           ;  0,  ,   H1.
        INCF   MIN1,F       ; 1  .
        MOVFW  MIN1         ;MIN1 >W.
M1U
        MOVWF  DSMH         ;W >DSMH.
        CALL   BINDECH      ;  .
        MOVFW  LSMH         ;LSMH >W .
        MOVWF  M_LOW        ;W > M_LOW     .
        MOVFW  HSMH         ;HSMH >W .
        MOVWF  M_HIGH       ;W > M_HIGH      .
        CLRF   HSMH         ; . . .
        CLRF   LSMH         ;
        RETURN              ;
H1
        CLRF   MIN1         ;   .
        CLRF   M_LOW        ;  .
        CLRF   M_HIGH       ;  .
H1H
        MOVFW  HOU1         ;   . .
        ADDLW  -17H         ;- 23. 
        BZ     H10          ;  0,  ,   H10.
        INCF   HOU1,F       ; 1  .
        MOVFW  HOU1         ;HOU >W.
H1U
        MOVWF  DSMH         ;W >DSMH.
        CALL   BINDECH      ;  .
        MOVFW  LSMH         ;LSMH >W .
        MOVWF  H_LOW        ;W > H_LOW     .
        MOVFW  HSMH         ;HSMH >W .
        MOVWF  H_HIGH       ;W > H_HIGH      .
        CLRF   HSMH         ; . . .
        CLRF   LSMH         ;
        RETURN              ;
H10
        CLRF   HOU1         ;  .
        CLRF   H_LOW        ;  .
        CLRF   H_HIGH       ;  .

D1H
        CALL   DAYMON       ;   ?
        SUBWF  DAY1,0       ;  ?
        BZ     DO1          ;.  .
        INCF   DAY1,F       ;. +1  .
        RETURN

DO1
        MOVLW  01H          ;  1
        MOVWF  DAY1         ; (0-  ).

MO1H
        INCF   MON,F        ;+1  
        MOVFW  MON          ;
        ADDLW  -0DH         ; 12 ?
        BZ     MOO          ;.
        RETURN

MOO
        MOVLW  01H          ; 1  (0-).
        MOVWF  MON          ;
        RETURN
;__________________________________________________
        END
