;
;  .     15 .
; 8      .
; 
;   .
;   .
; ., .
; saes@mail.ru
;
;  = SETSIK.ASM
; : 05-02-03.
;   : MPLAB IDE, : 5.61.00.
;
            #include p16f84a.inc
            __CONFIG 3FF2H
;======================================
;    4,0 .
;======================================
;  .
;================
INDF     EQU  00H  ;    FSR.
TIMER0   EQU  01H  ;TMR0.
OPTIONR  EQU  81H  ;OPTION (RP0=1).
PC       EQU  02H  ; .
STATUS   EQU  03H  ;  .
FSR      EQU  04H  ;  .
PORTA    EQU  05H  ;  /.
PORTB    EQU  06H  ;  /.
TRISA    EQU  85H  ;   .
TRISB    EQU  86H  ;   .
INTCON   EQU  0BH  ;  .
;=================================
;   .
;=================================
SC0      EQU  0CH  ;  .
SC1      EQU  0DH  ;
SC2      EQU  0EH  ;
SC3      EQU  0FH  ;
SC4      EQU  10H  ;
SC5      EQU  11H  ;
SC6      EQU  12H  ;
SC7      EQU  13H  ; .
CAT      EQU  14H  ;   ().
ANOD     EQU  15H  ;,  (0-7).
SEG      EQU  16H  ;.
COUI     EQU  025H ;  .
;============================================
;     FLAG.
;============================================
FLAG       EQU  17H   
;
;     0->  .
;     1->   1 .
;     2->   .
;     3-> .
;     4->   .
;     5->   .
;
;==================================
;   .
;==================================
SECL      EQU  18H  ; .  
UC0       EQU  19H  ;.
UC1       EQU  1AH  ;.
UC2       EQU  1BH  ;.
UC3       EQU  1CH  ;.
UC4       EQU  1DH  ; .
UC5       EQU  1EH  ; .
UC6       EQU  1FH  ;.
UC7       EQU  020H ; .
;====================
;  .
;====================
W_TEMP      EQU  021H  ;   W  .
STATUS_TEMP EQU  022H  ;   STATUS  .
FSR_TEMP    EQU  023H  ;  FSR.
COU3        EQU  024H  ;   .
;=========
; 1. .
;=========
        ORG 0
           GOTO INIT 
        ORG 4
           GOTO CONST
;==================
; 2. .
;==================
INIT
 BSF   STATUS,RP0       ;   1.
 MOVLW B'00000000'      ;  .
 MOVWF OPTION_REG^80H   ;
 MOVLW B'10010000'      ;  =    , 0.
 MOVWF INTCON           ;
 MOVLW B'00001000'      ;RA0, RA1, RA2, RA4 -  , RA3 -  .
 MOVWF TRISA^80H
 MOVLW B'00000001'      ; RB1-RB7- , RB0-.
 MOVWF TRISB^80H
 BCF   STATUS,RP0       ;   0. 
 CLRF  FLAG             ;  
 CLRF  TMR0             ;   
 CLRF  SC0
 CLRF  SC1
 CLRF  SC2
 CLRF  SC3
 CLRF  SC4
 CLRF  SC5
 CLRF  SC6
 CLRF  SC7
 CLRF  UC0
 CLRF  UC1
 CLRF  UC2
 CLRF  UC3
 CLRF  UC4
 CLRF  UC5
 CLRF  UC6
 CLRF  UC7
 CLRF  SEG
 CLRF  SECL
 CLRF  CAT
 GOTO  ZIKL         ;  .
;=============
; 3. .
;=============
KZO
         CLRF  SC0      ;  .
         CLRF  SC1
         CLRF  SC2
         CLRF  SC3
         CLRF  SC4
         CLRF  SC5
         CLRF  SC6
         CLRF  SC7
         BCF   FLAG,3   ;   .
         BCF   FLAG,1   ;   .
         BCF   FLAG,0   ; .
         BTFSC FLAG,2   ;   
         RETURN         ;  .
         CLRF  UC0      ;  .
         CLRF  UC1
         CLRF  UC2
         CLRF  UC3
         CLRF  UC4
         CLRF  UC5
         CLRF  UC6
         CLRF  UC7
         RETURN
;======================================
; 4.   .
;======================================
CATK
         BTFSS   FLAG,1    ;    1 .
         RETURN            ;
         BCF     FLAG,2    ;  .
         BCF     FLAG,1    ;    .
         MOVFW   CAT       ;9  = 0.
         SUBLW   .8
         BZ      CATK0     ;  .
         INCF    CAT,1     ;+1    .
         RETURN            ;
CATK0
        CLRF   CAT         ;.
        BCF    INTCON,7    ;    .
        BCF    FLAG,2      ;  8 .
        BCF    FLAG,3      ; .
        GOTO   UST8        ; .
;=================================
; 5.    .
;=================================
UST
        BTFSS   FLAG,1    ;    1 .
        RETURN   
        BCF     FLAG,1    ;  .
        MOVFW   CAT       ;   
        ADDWF   PC,1      ;  .
        GOTO    UST0      ;0
        GOTO    UST1      ;1
        GOTO    UST2      ;2
        GOTO    UST3      ;3
        GOTO    UST4      ;4
        GOTO    UST5      ;5
        GOTO    UST6      ;6
        GOTO    UST7      ;7
        RETURN
UST0
        INCF    UC0,1     ;   9.
        MOVLW   .10       ;
        SUBWF   UC0,0     ;
        BTFSC   STATUS,0  ;() = 1,  10  .
        CLRF    UC0       ;
        GOTO    UST8      ;
UST1
        INCF    UC1,1     ;   9.
        MOVLW   .10       ;
        SUBWF   UC1,0     ;
        BTFSC   STATUS,0  ;
        CLRF    UC1       ;
        GOTO    UST8      ;
UST2
        INCF    UC2,1     ;   9.
        MOVLW   .10       ;
        SUBWF   UC2,0     ;
        BTFSC   STATUS,0  ;
        CLRF    UC2       ;
        GOTO    UST8      ;
UST3
        INCF    UC3,1     ;   9.
        MOVLW   .10       ;
        SUBWF   UC3,0     ;
        BTFSC   STATUS,0  ;
        CLRF    UC3       ;
        GOTO    UST8      ;
UST4
        INCF    UC4,1     ;   9.
        MOVLW   .10       ;
        SUBWF   UC4,0     ;
        BTFSC   STATUS,0  ;
        CLRF    UC4       ;
        GOTO    UST8      ;
UST5
        INCF    UC5,1     ;   9.
        MOVLW   .10       ;
        SUBWF   UC5,0     ;
        BTFSC   STATUS,0  ;
        CLRF    UC5       ;
        GOTO    UST8      ;
UST6
        INCF    UC6,1     ;   9.
        MOVLW   .10       ;
        SUBWF   UC6,0     ;
        BTFSC   STATUS,0  ;
        CLRF    UC6       ;
        GOTO    UST8      ;
UST7
        INCF    UC7,1     ;   9.
        MOVLW   .10       ;
        SUBWF   UC7,0     ;
        BTFSC   STATUS,0  ;
        CLRF    UC7       ;
        GOTO    UST8      ;
;============================================================
; 6.      .
;============================================================
UST8
        MOVFW   UC0
        MOVWF   SC0
        MOVFW   UC1
        MOVWF   SC1
        MOVFW   UC2
        MOVWF   SC2
        MOVFW   UC3
        MOVWF   SC3
        MOVFW   UC4
        MOVWF   SC4
        MOVFW   UC5
        MOVWF   SC5
        MOVFW   UC6
        MOVWF   SC6
        MOVFW   UC7
        MOVWF   SC7
        RETURN
;================================
; 7.   .
;================================
COMP
        TSTF    SC0   ;   ,
        SKPZ          ;   .
        GOTO    COM
        TSTF    SC1
        SKPZ
        GOTO    COM
        TSTF    SC2
        SKPZ
        GOTO    COM
        TSTF    SC3
        SKPZ
        GOTO    COM
        TSTF    SC4
        SKPZ
        GOTO    COM
        TSTF    SC5
        SKPZ
        GOTO    COM
        TSTF    SC6
        SKPZ
        GOTO    COM
        TSTF    SC7
        SKPZ
        GOTO    COM
        RETURN
COM
        BSF     FLAG,3   ;  ,   .
        MOVFW   SC0      ;   
        SUBWF   UC0,0    ;   .
        SKPZ             ;  ,
        RETURN           ;    .
        MOVFW   SC1
        SUBWF   UC1,0
        SKPZ
        RETURN
        MOVFW   SC2
        SUBWF   UC2,0
        SKPZ
        RETURN
        MOVFW   SC3
        SUBWF   UC3,0
        SKPZ
        RETURN
        MOVFW   SC4
        SUBWF   UC4,0
        SKPZ
        RETURN
        MOVFW   SC5
        SUBWF   UC5,0
        SKPZ
        RETURN
        MOVFW   SC6
        SUBWF   UC6,0
        SKPZ
        RETURN
        MOVFW   SC7
        SUBWF   UC7,0
        SKPZ
        RETURN
        BSF     FLAG,0   ;   ,   .
        RETURN
;========================================
; 8.     .
;========================================
SEGDATA                      ;  7, 6, 5, 4, 3, 2, 1, 0.
         ADDWF   PCL,F       ;  G, F, E, D, C, B, A,IN.
;        :               
         RETLW   B'01111111' ;   B'1000000'  0 
         RETLW   B'00001101' ;   B'1111001'  1 
         RETLW   B'10110111' ;   B'0100100'  2 
         RETLW   B'10011111' ;   B'0110000'  3 
         RETLW   B'11001101' ;   B'0011001'  4 
         RETLW   B'11011011' ;   B'0010010'  5 
         RETLW   B'11111011' ;   B'0000010'  6 
         RETLW   B'00001111' ;   B'1111000'  7 
         RETLW   B'11111111' ;   B'0000000'  8 
         RETLW   B'11011111' ;   B'0010000'  9 
;===================
; 9. . .
;=================== 
ZIKL
        CLRF    ANOD      ;  .  
ZS0
        MOVFW   SC0       ;    
        CALL    INDZIKL   ;   .
        BTFSC   FLAG,2    ;   ,
        CALL    COMP      ;  .
        CALL    MC4       ; 3 .
ZS1
        MOVFW   SC1       ;    .
        CALL    INDZIKL   ;
        BSF     STATUS,5  ; .
        MOVLW   B'00000110';   RB1, RB2,
        MOVWF   TRISB^80H
        BCF     STATUS,5
        BTFSC   FLAG,3    ;  ,
        GOTO    ZOOS      ;.
        BTFSS   PORTB,1   ;    ,
        CALL    CATK      ;   .
        BTFSS   PORTB,2   ;   ,
        CALL    UST       ;  .
        BTFSS   PORTB,1   ;    ,
        GOTO    ZOOS      ;  .
        MOVFW   CAT       ;8  ,     .
        SUBLW   .8        ;  8,
        SKPNZ             ;  ,
        BSF     FLAG,2    ;  "  ".
        SKPNZ             ;  ,
        BSF     INTCON,7  ; .
ZOOS
        BTFSS   PORTA,3   ;   ,
        CALL    KZO       ;  .
        BSF     STATUS,5  ;
        MOVLW   B'00000001';  RB0.
        MOVWF   TRISB^80H
        BCF     STATUS,5
        CALL    MC4       ; 3 .
ZS2
        MOVFW   SC2       ;    
        CALL    INDZIKL   ;   .
        CALL    MC4       ; 3 .
ZS3
        MOVFW   SC3       ;
        CALL    INDZIKL   ;
        CALL    MC4
ZS4
        MOVFW   SC4       ;
        CALL    INDZIKL   ;
        CALL    MC4
ZS5
        MOVFW   SC5       ;
        CALL    INDZIKL   ;
        CALL    MC4
ZS6
        MOVFW   SC6       ;
        CALL    INDZIKL   ;
        CALL    MC4
ZS7
        MOVFW   SC7       ;
        CALL    INDZIKL   ;
        CALL    MC4
        GOTO    ZIKL      ; .
INDZIKL
        CALL    SEGDATA   ;  .
        MOVWF   SEG       ;     .
        MOVFW   ANOD      ;     
        SUBWF   CAT,0     ; .
        BNZ     COUZ2     ;,   .
        INCF    COUI,1    ; , +1    .
        MOVLW   .10       ;  .5    .
        SUBWF   COUI,0    ;.
        SKPZ              ;  0,    .
        GOTO    COUZ      ;   ,   .
COUZ1
        CLRF    COUI      ;   .
        BTFSC   FLAG,4    ;,  0.
        BCF     FLAG,4    ;    .
        BTFSS   FLAG,4    ; , .
        BSF     FLAG,4    ;     1.
        BTFSC   FLAG,4    ; ,
        BSF     FLAG,5    ;   .
        GOTO    COUZ      ;  .
COUZ2
        BCF     FLAG,5    ;     0.
COUZ
        BTFSC   FLAG,0    ;   = 1,
        BCF     ANOD,4    ;   .
        BTFSS   FLAG,0    ;   = 0,
        BSF     ANOD,4    ;   ( ).
        MOVFW   ANOD      ;  
        MOVWF   PORTA     ;  .
        BTFSS   FLAG,5    ;    ,
        MOVFW   SEG       ;,    .
        BTFSC   FLAG,5    ;    ,
        CLRF    PORTB     ; ,     .
        BTFSS   FLAG,5    ;    ,
        MOVWF   PORTB     ;    B   .
        BCF     ANOD,4    ;  ,   .
        INCF    ANOD,1    ;+1   .
        RETURN
MC4
        MOVLW   .250      ;   3 .
        MOVWF   COU3
MC2
        DECF    COU3,1    ; 1  .
        NOP
        NOP
        NOP
        NOP
        NOP
        NOP
        NOP
        SKPZ             ;  ,    .
        GOTO    MC2      ;   .
;==========================
; 10.  .
;==========================
SEC
        BTFSC  FLAG,3   ;    .
        RETURN
        INCF   SECL,1   ;+1     (256).
        TSTF   SECL     ;   .
        SKPNZ           ;  ,
        BSF    FLAG,1   ;  .
        RETURN
;==================================================================
; 11.       .
;===================================================================
CONST
        MOVWF  W_TEMP      ;   W 
        MOVFW  STATUS      ;STATUS,
        MOVWF  STATUS_TEMP ;
        MOVFW  FSR         ;FSR.
        MOVWF  FSR_TEMP    ;
        GOTO   S01         ; 1  .
RECONST                    ;  .
        BCF    INTCON,1    ;     0.
        MOVFW  STATUS_TEMP ; :
        MOVWF  STATUS      ;STATUS,
        MOVFW  FSR_TEMP    ;
        MOVWF  FSR         ;FSR,
        MOVFW  W_TEMP      ;W.
        RETFIE             ;  .
;=================
; 12. .
;=================
S01
        BTFSS  FLAG,2    ;   ( ).
        GOTO   RECONST
        MOVLW  .9        ;  9,
        SUBWF  SC0,0
        BC     S10       ;   .
        INCF   SC0,1     ;  .
        GOTO   RECONST
S10
        CLRF   SC0
        MOVLW  .9        ;  9,
        SUBWF  SC1,0
        BC     S100      ;   .
        INCF   SC1,1     ;  .
        GOTO   RECONST
S100
        CLRF   SC1
        MOVLW  .9        ;  9,
        SUBWF  SC2,0
        BC     S103      ;   .
        INCF   SC2,1     ;  .
        GOTO   RECONST
S103
        CLRF   SC2
        MOVLW  .9        ;  9,
        SUBWF  SC3,0
        BC     S104      ;    .
        INCF   SC3,1     ;  .
        GOTO   RECONST
S104
        CLRF   SC3
        MOVLW  .9        ;  9,
        SUBWF  SC4,0
        BC     S105      ;    .
        INCF   SC4,1     ;  .
        GOTO   RECONST
S105
        CLRF   SC4
        MOVLW  .9        ;  9,
        SUBWF  SC5,0
        BC     S106      ;  .
        INCF   SC5,1     ;  .
        GOTO   RECONST
S106
        CLRF   SC5
        MOVLW  .9        ;  9,
        SUBWF  SC6,0
        BC     S107      ;  .
        INCF   SC6,1     ;  .
        GOTO   RECONST
S107
        CLRF   SC6
        MOVLW  .9        ;  9,
        SUBWF  SC7,0
        BC     S108      ;  .
        INCF   SC7,1     ;  .
        GOTO   RECONST
S108
        CLRF   SC7       ;  .
        GOTO   RECONST
;=============================================
        END
;==============================================

