;
; 
; 
; -- .
; 
;   .
;    .
; ., .
; saes@mail.ru
;
;  = SHAHMATU.ASM
;  : 15-08-02.
;   : MPLAB IDE, : 5.61.00.
;
            #INCLUDE P16F84A.INC

          __CONFIG 3FF0H
;_______________________________________________
;     32768 .
;     32,  
;  TMR0 (256)  ,  4 ,
;     1  (432256=32768).
;_________________________________________________
;   .
;__________________________________________________
INDF     EQU  00H  ;    FSR.
TIMER0   EQU  01H  ;TMR0.
OPTIONR  EQU  81H  ;OPTION (RP0=1).
PC       EQU  02H  ; .
STATUS   EQU  03H  ;  .
FSR      EQU  04H  ;  .
PORTA    EQU  05H  ;  /.
PORTB    EQU  06H  ;  /.
TRISA    EQU  85H  ;   .
TRISB    EQU  86H  ;   .
EEDATA   EQU  08H  ; .
EEADR    EQU  09H  ; .
EECON1   EQU  88H  ; -.
EECON2   EQU  89H  ;.
INTCON   EQU  0BH  ;  .
;________________________________________________
;   .
;________________________________________________
M_LOW       EQU  010H  ;  .
M_HIGH      EQU  011H  ;  .
H_LOW       EQU  012H  ;  .
H_HIGH      EQU  013H  ;  .
SLO1        EQU  014H  ;  1 .
SHI1        EQU  015H  ;  1 .
MLO1        EQU  016H  ;  1 .
MHI1        EQU  017H  ;  1 .
SLO         EQU  018H  ;  2 .
SHI         EQU  019H  ;  2 .
MLO         EQU  01AH  ;  2 .
MHI         EQU  01BH  ;  2 .
;_______________________________________
;    .
;_______________________________________
KATOD       EQU  01CH  ;,  (0-7).
ATT         EQU  01DH  ; ()  ().
COUF        EQU  01EH  ; .
SEGD        EQU  01FH  ;.
CAT         EQU  020H  ;  .
COUI        EQU  021H  ;  .
;_________________________________________________
;  ,  .
;__________________________________________________
COUEE       EQU  022H  ;  .
ACOU        EQU  023H  ;  . 
;__________________________________________
; ,      .
;___________________________________________
W_TEMP      EQU  024H  ;   W  .
STATUS_TEMP EQU  025H  ;   STATUS  .
FSR_TEMP    EQU  029H  ;  FSR.
DSMH        EQU  026H  ;   .
LSMH        EQU  027H  ;   .
HSMH        EQU  028H  ;   .
SECUM       EQU  029H  ;   .
MINUM       EQU  02AH  ;   .
;__________________________________________
;    .
;__________________________________________
SEC1        EQU  02BH  ;   .
MIN1        EQU  02CH  ;   .
HOU1        EQU  02DH  ;   .
SECM        EQU  02EH  ; 1 .
SECM1       EQU  02FH  ; 2 .
MINM        EQU  030H  ; 1 .
MINM1       EQU  031H  ; 2 .
;_________________________________________
;     FLAG.
;_________________________________________
FLAG        EQU  032H   
;
;     0->  .
;     1->   .
;     2->     .
;     3-> : -.
;     4-> .
;     5-> -.
;     6->  .
;___________________________________________
;   .
;___________________________________________
ALAM        EQU  033H  ; .
ALAH        EQU  034H  ; .
;___________________________________________________________________
;    
;____________________________________________________________________
        ORG 0
           GOTO INIT
       ORG 4
          GOTO COUNT
;____________________________________________________________________
; 
;______________________________________________________________________
INIT
  BSF   STATUS,RP0       ;   1.
  MOVLW B'00000100'      ;  , =32 ...100,
  MOVWF OPTION_REG^80H   ;  .
  MOVLW B'10100000'      ;  =   .
  MOVWF INTCON           ;
  MOVLW B'00000000'      ; RA0-RA4  .
  MOVWF TRISA^80H
  MOVLW B'10001111'      ; RB0-RB3, RB7  , RB4-RB6-
  MOVWF TRISB^80H
  BCF   STATUS,RP0       ;   0.
  CLRF  FLAG             ;  
  CLRF  TMR0             ;   
  CLRF  SEC1
  CLRF  MIN1
  CLRF  HOU1
  CLRF  SECM
  CLRF  MINM
  CLRF  SECM1
  CLRF  MINM1
  CLRF  M_LOW
  CLRF  M_HIGH
  CLRF  H_LOW
  CLRF  H_HIGH
  CLRF  SLO
  CLRF  SHI
  CLRF  MLO
  CLRF  MHI
  CLRF  SLO1
  CLRF  SHI1
  CLRF  MLO1
  CLRF  MHI1
  CLRF  HSMH
  CLRF  LSMH
  CLRF  ATT
  CLRF  COUI
  CLRF  COUF
  CLRF  ACOU
  CLRF  COUEE
  CLRF  ALAM
  CLRF  ALAH
  MOVLW .1           ; 
  MOVWF CAT          ; .
;_______________________________________________________________
; 1.       .
;________________________________________________________________
KEY
          BTFSS   PORTB,0     ;-.
          CALL    KEYC        ; -  .
          BTFSC   FLAG,5      ;-.
          GOTO    KEYSH       ;   .
KEYF
          BTFSS   PORTB,1     ;  ,
          GOTO    ATTK        ;  .
          GOTO    CATK        ;    .
KEYSH
          CALL    S1          ;  .
          GOTO    SHARL       ;  .
KEYC
          INCF    COUF,1      ;  .
          BTFSC   COUF,0      ;  
          BSF     FLAG,5      ;  .
          BTFSS   COUF,0      ;  
          BCF     FLAG,5      ;  .
          BCF     FLAG,0      ;  .
          BCF     FLAG,6      ;  .
          RETURN              ;
;_________________________________________________
; 2.    ( ).
;_________________________________________________
CATK
          CALL    S1          ;  :  .
          BTFSC   PORTB,2     ;    ,
          GOTO    ATTKU       ;  ,
          INCF    CAT,1       ; +1    .
          MOVFW   CAT         ;8  ,     .
          SUBLW   .9          ;  9,
          BZ      CATK0       ;  .
          GOTO    ATTGO       ; .
;
;      .
;
ATTKU
          MOVFW   ATT         ;  
          ADDWF   PC,1        ;:
          GOTO    CATUH       ;-.
          GOTO    CATSH       ;,
          GOTO    CATB        ; .
          GOTO    CATAL       ;,
CATK0
         CLRF   CAT           ;.
         GOTO   ATTGO         ; .
;___________________________________________________
; 3.     .
;___________________________________________________
SEGDATA                      ;RB7, 6, 5, 4, 3, 2, 1, 0.
         ADDWF   PCL,F       ;     G, F, E, D, C, B, A.
         RETLW   B'10111111' ; 0
         RETLW   B'10000110' ; 1
         RETLW   B'11011011' ; 2
         RETLW   B'11001111' ; 3
         RETLW   B'11100110' ; 4
         RETLW   B'11101101' ; 5
         RETLW   B'11111101' ; 6
         RETLW   B'10000111' ; 7
         RETLW   B'11111111' ; 8
         RETLW   B'11101111' ; 9
         RETLW   B'10001000' ;_ 10  .
         RETLW   B'11001000' ;11    .
         RETLW   B'11001001' ;12 ,    .
;_______________________________
; 4.   = .
;_______________________________
CATUH
         MOVFW   CAT       ; ? ATT=0
         ADDWF   PC,1      ;   C.
         GOTO    ATTOO     ; .
         GOTO    MIN1M     ;  .
         GOTO    ACOUOO    ;  .
         GOTO    HOU1H     ; .
         GOTO    COUEEOO   ;  .
         GOTO    ATTGO     ; .
         GOTO    ATTGO     ; .
         GOTO    ATTGO     ; .
         GOTO    ATTGO     ; .
CATSH
         MOVFW   CAT       ; ? T=1
         ADDWF   PC,1      ;   C.
         GOTO    SHUR      ;   .
         GOTO    SHUL      ;   .
         GOTO    COUEEU    ;    
         GOTO    ZAPISE    ;  .
         GOTO    COUUI     ;    .
         GOTO    AKT       ; .
         GOTO    SHURLIN   ; , .
         GOTO    SHURL     ;  , .
         GOTO    SH_H      ; .
CATB
         MOVFW   CAT       ; ?   T=2
         ADDWF   PC,1      ;   C.
         GOTO    ATTK5     ;: .
         GOTO    ATTK5     ;: .
         GOTO    ATTK5     ;: .
         GOTO    ATTK5     ;: .
         GOTO    ATTK5     ;: . 
         GOTO    ATTK5     ;: .
         GOTO    ATTK5     ;: .
         GOTO    ATTK5     ;: .
         GOTO    ATTK5     ;: .
CATAL
         MOVFW   CAT       ; ? T=3
         ADDWF   PC,1      ;   C.
         GOTO    SHOO      ; .
         GOTO    ALOM      ;    .
         GOTO    ALOIN     ; .
         GOTO    ALOH      ;    .
         GOTO    OMON      ;   .
         GOTO    ATTGO     ; .
         GOTO    ATTGO     ; .
         GOTO    ATTGO     ; .
         GOTO    ATTGO     ; .
;___________________________
; 5.   .
;___________________________
ATTK                       ;     ,
         CALL    S1        ;      1 .
         INCF    ATT,F     ;  .
         MOVFW   ATT       ;
         SUBLW   .4        ;   4  (0-3).
         BNZ     ATTGO     ;   , .
         CLRF    ATT       ;  .
         GOTO    ATTGO     ; .
;_______________
; 6. .
;_______________
ACOUOO
         BTFSC   PORTB,3    ;   ?
         GOTO    COUUIN     ; -  .
         CLRF    ACOU       ;  .
         GOTO    COUUIN     ; .
COUEEOO
         BCF     FLAG,0     ;  .
         BTFSC   PORTB,3    ;   ?
         GOTO    CO_IN      ; -  .
         CLRF    COUEE      ;  .
         GOTO    CO_IN      ; .
SHOO
         BTFSC   PORTB,3    ;   ?
         GOTO    ATTGO      ; .
         CLRF    SECM       ;
         CLRF    SECM1      ;/
         CLRF    MINM       ;/
         CLRF    MINM1      ; .
         GOTO    SHURLIN    ; .
ATTOO
         BTFSC   PORTB,3    ;   .
         GOTO    ATTK5      ;.        
         CLRF    SEC1       ;,    
         CLRF    MIN1       ;   
         CALL    HIN        ; .
         GOTO    ATTGO      ; .
;______________________________________
; 7.    .
;______________________________________
ALOM
         BTFSC   PORTB,3    ;   .
         GOTO    ALOIN      ; .
         INCF    ALAM,1     ;+1   .
         MOVLW   .60        ;  59.
         SUBWF   ALAM,0     ;
         BTFSC   STATUS,2   ;
         CALL    ALOOM      ;  .
         MOVFW   ALAM       ;
         CALL    M1U        ;   .
         GOTO    ATTGO      ; .
ALOH
         BCF     STATUS,2   ;  .
         BTFSC   PORTB,3    ;   .
         GOTO    ALOIN      ; .
         INCF    ALAH,1     ;+1   .
         MOVLW   .24        ;  23.
         SUBWF   ALAH,0     ;
         BTFSC   STATUS,2   ;
         CALL    ALOOH      ;  .
         MOVFW   ALAH       ;
         CALL    H1U        ;   .
         GOTO    ATTGO      ; .
ALOOM
         CLRF    ALAM       ;  .
         RETURN             ;
ALOOH
         CLRF    ALAH       ;  .
         RETURN             ;
;_____________________________
OMON
         MOVFW  HOU1        ;   
         SUBWF  ALAH,0      ;   .
         BZ     AMON        ;  ,   .
         GOTO   ATTK5       ;      .
AMON
         MOVFW  MIN1        ;    
         SUBWF  ALAM,0      ;   .
         BZ     MONA        ;  ,    .
         BCF    FLAG,0      ;   .
         GOTO   ATTK5       ;     .
MONA
         BSF    FLAG,0      ;  .
         GOTO   ATTK5       ;    .
;____________________________
ALOIN
         MOVFW  ALAM        ; 
         CALL   M1U         ; 
         MOVFW  ALAH        ;  .
         CALL   H1U         ;
         GOTO   ATTGO       ;
;___________________________________
; 8.  .
;__________________________________
MIN1M
         BTFSC   PORTB,3    ;   .
         GOTO    ATTGO      ;.
         CALL    M1M        ;+1   .
         CALL    HIH        ;  .
         GOTO    ATTGO      ; .
HOU1H
         BTFSC   PORTB,3    ;  .
         GOTO    ATTGO      ;
         CALL    H1H        ;+1   .
         CALL    HIN        ;  .
         GOTO    ATTGO      ; .
 
;___________________________________
; 9.     .
;___________________________________
HIN
         MOVFW   MIN1         ;
         CALL    M1U          ; .
         RETURN
HIH
         MOVFW   HOU1         ;
         CALL    H1U          ; .
         RETURN
 
ATTK5                         ;   .
         BCF     FLAG,3       ;   
         BCF     FLAG,6       ;  .
         CALL    HIN          ;  
         CALL    HIH          ; .
         GOTO    ATTGO        ; .

;_________________________________
; 10. : -.
;_________________________________
SH_H
       BTFSC   PORTB,3      ;   .
       GOTO    ATTGO        ; .
       BCF     FLAG,6       ;  
       BTFSS   FLAG,3       ;  ,
       GOTO    SH_H1        ;  .
       BCF     FLAG,3       ; ,  .
       GOTO    ATTK5        ;  .
SH_H1
       BSF     FLAG,3       ; .
       GOTO    SHARIN       ;  .
;________________________________
; 11.  .
;_________________________________
ATTGO
        BTFSC   INTCON,2     ;     ,
        GOTO    RETCONT      ; ,   .
        GOTO    COUZIKL0     ;   .
;_________________________________
; 12.  .
;________________________________
SHURL
        BTFSC    PORTB,3     ;   ,
        GOTO     SHURLIN     ;  .
        INCF     MINM1,1     ;+1    .
        MOVLW    .130        ; 129 .
        SUBWF    MINM1,0     ;
        BZ       SHURLO      ; .
SHURLIN
        MOVFW    MINM1       ;  
        MOVWF    MINM        ;   .
        MOVWF    DSMH        ;
        CALL     BINDECH     ;  2-10 
        MOVFW    LSMH        ;
        MOVWF    MLO         ;   
        MOVWF    MLO1        ;.
        MOVFW    HSMH        ;
        MOVWF    MHI         ;
        MOVWF    MHI1        ;
        CLRF     SLO         ;  ,
        CLRF     SHI         ; .
        CLRF     SLO1        ;
        CLRF     SHI1        ;
        CLRF     SECM        ;
        CLRF     SECM1       ;
        CLRF     LSMH        ;
        CLRF     HSMH        ;
        BSF      FLAG,6      ; .
        GOTO     ATTGO       ;
SHURLO
        CLRF     MINM1       ; 
        CLRF     MINM        ;  .
        GOTO     SHURLIN     ; .

;   .

SHUR
        BTFSC    PORTB,3     ;   ,
        GOTO     SHURIN      ;  .
        INCF     MINM1,1     ;+1
        MOVLW    .130        ;
        SUBWF    MINM1,0     ;
        BZ       SHURO       ; .
SHURIN
        MOVFW    MINM1       ;  
        MOVWF    DSMH        ;
        CALL     BINDECH     ;  2-10 .
        MOVFW    LSMH        ;
        MOVWF    SLO1        ;  
        MOVFW    HSMH        ;
        MOVWF    SHI1        ;  .
        MOVLW    .10         ;- 
        MOVWF    MLO1        ; 
        MOVWF    MHI1        ;.
        CLRF     SECM        ;
        CLRF     LSMH        ;
        CLRF     HSMH        ;
        BSF      FLAG,6      ; .
        GOTO     ATTGO       ;
SHURO
        CLRF     MINM1       ;   .
        GOTO     SHURIN      ; .

;   .

SHUL
        BTFSC    PORTB,3     ;
        GOTO     SHULIN      ;  .
        INCF     MINM,1      ;
        MOVLW    .130        ;
        SUBWF    MINM,0      ;
        BZ       SHULO       ;
SHULIN
        MOVFW    MINM        ;
        MOVWF    DSMH        ;
        CALL     BINDECH     ;
        MOVFW    LSMH        ;
        MOVWF    MLO         ;
        MOVFW    HSMH        ;
        MOVWF    MHI         ;
        MOVLW    .10         ;-
        MOVWF    SHI         ;
        MOVWF    SLO         ;
        CLRF     SECM1       ;
        CLRF     LSMH        ;
        CLRF     HSMH        ;
        BSF      FLAG,6      ;
        GOTO     ATTGO       ;
SHULO
        CLRF     MINM        ;
        GOTO     SHULIN      ;
;_____________________________
; 13.    .
;_____________________________
SHARL
        BTFSS    FLAG,5     ; ""  ,
        GOTO     SHARIN     ;  .
        BTFSS    PORTB,7    ;     (=0),
        GOTO     SHAR       ;   .
        BTFSC    PORTB,7    ;     
        GOTO     SHAL       ;   .
SHAR
        DECF     SECM1,1    ;-1     .
        MOVLW    .255       ;   0,   =255.
        SUBWF    SECM1,0    ;
        BZ       SHARM      ;  .
        GOTO     SHARIN     ; .
SHARM
        BCF      STATUS,2   ;
        TSTF     MINM1      ;   0,
        BZ       ALARMR     ;   .
        MOVLW    .59        ;   =59
        MOVWF    SECM1      ;
        DECF     MINM1,1    ;  1  .
        MOVLW    .255       ;   0,   =255.
        SUBWF    MINM1,0    ;
        BZ       SHARMO     ;  .
        GOTO     SHARIN     ; .
SHARMO
        CLRF     MINM1      ;  .
        GOTO     SHARIN     ;   .
        
SHAL
        DECF     SECM,1     ;  
        MOVLW    .255       ; .
        SUBWF    SECM,0     ;
        BZ       SHALM      ;
        GOTO     SHALIN     ;
SHALM
        BCF      STATUS,2   ;
        TSTF     MINM       ;
        BZ       ALARML     ;
        MOVLW    .59        ;
        MOVWF    SECM       ;
        DECF     MINM,1     ;
        MOVLW    .255       ;
        SUBWF    MINM,0     ;
        BZ       SHALMO     ;
        GOTO     SHALIN     ;
SHALMO
        CLRF     MINM       ;
        GOTO     SHALIN     ;
SHARIN
        MOVFW    SECM1      ;  .
        MOVWF    DSMH       ;
        CALL     BINDECH    ; .
        MOVFW    LSMH       ;
        MOVWF    SLO1       ;    .
        MOVFW    HSMH       ;
        MOVWF    SHI1       ;    .
        CLRF     LSMH       ;
        CLRF     HSMH       ;
        MOVFW    MINM1      ;  .
        MOVWF    DSMH       ;
        CALL     BINDECH    ;
        MOVFW    LSMH       ;
        MOVWF    MLO1       ;
        MOVFW    HSMH       ;
        MOVWF    MHI1       ;
        CLRF     LSMH       ;
        CLRF     HSMH       ;
        BSF      FLAG,6     ; .
        BTFSS    FLAG,5     ;  ,
        GOTO     SHALIN     ;  .
        GOTO     ATTGO      ;
SHALIN
        MOVFW    SECM       ;  .
        MOVWF    DSMH       ;
        CALL     BINDECH    ; .
        MOVFW    LSMH       ;
        MOVWF    SLO        ;    .
        MOVFW    HSMH       ;
        MOVWF    SHI        ;    .
        CLRF     LSMH       ;
        CLRF     HSMH       ;
        MOVFW    MINM       ;  .
        MOVWF    DSMH       ;
        CALL     BINDECH    ;
        MOVFW    LSMH       ;
        MOVWF    MLO        ;
        MOVFW    HSMH       ;
        MOVWF    MHI        ;
        CLRF     LSMH       ;
        CLRF     HSMH       ;
        BSF      FLAG,6     ; .
        GOTO     ATTGO      ;

;_____________________________________
; 14.    .
;_____________________________________
SZIKL

         BSF     INTCON,7   ;  ,  .
         BTFSC   FLAG,5     ;  ,
         GOTO    SZIKLO     ;   
         BTFSS   FLAG,3     ;  ,
         GOTO    COUZIKL0   ;   .
SZIKLO
         CLRF    KATOD      ;  2-10.
         MOVLW   014H       ;   
         MOVWF   SEGD       ; .
SDATA
         BTFSC   FLAG,0     ;  ,
         BCF     KATOD,4    ;    .
         BTFSS   FLAG,0     ;  ,
         BSF     KATOD,4    ;    .
         MOVFW   SEGD       ;     
         MOVWF   FSR        ;   .
         MOVFW   INDF       ; 2-10 .
         CALL    SEGDATA    ;    
         MOVWF   PORTB      ;  .
         MOVFW   KATOD      ;  
         MOVWF   PORTA      ;  .
         BCF     KATOD,4    ;   ,    
                            ;   .
         BTFSS   FLAG,5     ;  ,
         BSF     PORTA,3    ;  .
         BTFSC   FLAG,5     ; -
         BCF     PORTA,3    ;  .
         INCF    SEGD,F     ;+1    .
         INCF    KATOD,1    ;+1   .
         MOVLW   .8         ;  8-.
         SUBWF   KATOD,0    ;  .
         BC      SZIKL      ;  0, .
         GOTO    SDATA      ;  . 

;________________________________________________________________________________ 
; 15. .    0-7 ; 0-3.
;________________________________________________________________________________ 
COUZIKL0
         BTFSC   FLAG,5     ;   ,
         GOTO    SZIKL      ;   .
         BTFSC   FLAG,3     ;  ,
         GOTO    SZIKL      ;   .
         BTFSC   FLAG,6     ;  ,
         GOTO    ZIKL       ;      ( ).
CO_O
         MOVLW   010H       ;    
         MOVWF   SEGD       ;   .
         GOTO    ZIKL1      ;
ZIKL
         MOVLW   014H       ;    
         MOVWF   SEGD       ;   .
ZIKL1
         BSF     INTCON,7   ;   .
         CLRF    KATOD      ;  2-10.
COUZ
         MOVFW   KATOD      ;     
         SUBWF   CAT,0      ; .
         BNZ     COUZ1      ;   .
         INCF    COUI,1     ;+1    .
         MOVLW   .5         ;5-   
         SUBWF   COUI,0     ; .
         BNC     COUZ1      ;   0,   .
         MOVLW   .10        ;0-5 - 
         SUBWF   COUI,0     ;5-10 - 
         BNZ     COUZ2      ;   3 .
         CLRF    COUI       ;  .
         GOTO    COUZ1      ;
COUZ2
         BSF     FLAG,2     ; .
         GOTO    INDCO      ;
COUZ1
         BCF     FLAG,2     ;    0.
INDCO 
         MOVFW   KATOD      ;  ,
         SUBWF   ATT,0      ;\
         BNZ     GDATA      ;   .
         BSF     FLAG,4     ; .
 
GDATA 
         BTFSC   FLAG,0     ;   ,
         BCF     KATOD,4    ;  (.).
         BTFSS   FLAG,0     ;   ,
         BSF     KATOD,4    ;  (.).
         MOVFW   SEGD       ;     
         MOVWF   FSR        ;   .
         MOVFW   INDF       ; 2-10 .
         CALL    SEGDATA    ;    
         BTFSC   FLAG,2     ;  ,
         MOVLW   B'10000000'; .
         MOVWF   PORTB      ;  .
         MOVFW   KATOD      ;  .
         MOVWF   PORTA      ;  
         BTFSC   FLAG,4     ;  =1,
         BSF     PORTA,3    ; .
         BTFSS   FLAG,4     ;  =0,
         BCF     PORTA,3    ; .
         BCF     FLAG,4     ;  .
         BCF     KATOD,4    ;   ,    
                            ;   .
         INCF    SEGD,F     ;+1    .
         INCF    KATOD,1    ;+1   .
         BTFSC   FLAG,6     ;   ,
         GOTO    INDU       ;  .
         BTFSC   FLAG,5     ;    ,
         GOTO    INDU       ;   .
         BTFSS   FLAG,3     ;    
         GOTO    INDH       ; 4  .
INDU
         MOVLW   .8         ;  8-.
         SUBWF   KATOD,0    ;  .
         BC      COUZIKL0   ;  0, ,
         GOTO    COUZ       ;  .
INDH
         MOVLW   .4         ;
         SUBWF   KATOD,0    ;  .
         BZ      COUZIKL0   ;  0, ,
         GOTO    COUZ       ;  .
;_______________________
; 15.  .
;______________________

ALARMR

         BTFSS   FLAG,5   ;  .
         GOTO    ATTGO    ; .
         BSF     FLAG,0   ;    = 1.
         CLRF    SECM1    ;,   
         CLRF    MINM1    ;  255.
         GOTO    SHARIN   ;   .
ALARML

         BTFSS   FLAG,5   ;  .
         GOTO    ATTGO    ; .
         BSF     FLAG,0   ;    = 1.
         CLRF    SECM     ;,   
         CLRF    MINM     ;  255.
         GOTO    SHALIN   ;   .
;____________________________________________________________________
; 17. .     2-10  (2-_-2-10).
;____________________________________________________________________
BINDECH
         MOVLW   .10      ;10 >W.
BDH
         BSF     STATUS,0 ;  ""  STATUS.
         SUBWF   DSMH,1   ;   10 > DSMH.
         BNC     BINDECL  ;    .
         INCF    HSMH,1   ; 1   .
         GOTO    BDH      ;.                
BINDECL
         MOVF    DSMH,0   ;   
         ADDLW   .10      ;10+W >W.               
         MOVWF   LSMH     ;    .
         RETURN           ;
;_________________________________________________________________________________
; 18.       .
;________________________________________________________________________________-
COUNT
         MOVWF  W_TEMP      ;   W 
         MOVFW  STATUS      ;STATUS,
         MOVWF  STATUS_TEMP ;
         MOVFW  FSR         ;FSR.
         MOVWF  FSR_TEMP    ;
         MOVLW  B'00000000' ; 
         MOVWF  PORTB       ;  .
         BSF    STATUS,5    ;
         MOVLW  B'10001111' ;  RB0-RB3
         MOVWF  TRISB^80H   ;   .
         BCF    STATUS,5    ;
         GOTO   KEY         ;  .
 
RETCONT                     ;  .
         BSF    STATUS,5    ;
         MOVLW  B'10000000' ;  .
         MOVWF  TRISB^80H   ;
         BCF    STATUS,5    ;
         BCF    INTCON,2    ;  (T0IF)   ( ).
         MOVFW  STATUS_TEMP ; :
         MOVWF  STATUS      ;STATUS,
         MOVFW  FSR_TEMP    ;
         MOVWF  FSR         ;FSR,
         MOVFW  W_TEMP      ;W.
         RETFIE             ;  .
;______________________
; 19.   .
;______________________
ZAPISE
         BSF     FLAG,6       ; .
         BTFSC   PORTB,3      ;   ?
         GOTO    ATTGO        ;.
         MOVFW   COUEE        ;  
         MOVWF   EEADR        ;  .
         MOVFW   MINM1        ;  .
         MOVWF   EEDATA       ;.
         BCF     INTCON,GIE   ; .
         BSF     STATUS,RP0   ; 1.
         BSF     EECON1^80H,WREN ; .
         MOVLW   55H          ; 
         MOVWF   EECON2^80H   ;/
         MOVLW   0AAH         ;/
         MOVWF   EECON2^80H   ;/
         BSF     EECON1^80H,WR ;    .
ZAPIZ
         BTFSS   EECON1^80H,4 ;    
         GOTO    ZAPIZ        ;  .
         BCF     INTCON,6     ;     .
         BCF     EECON1^80H,4 ;
         BCF     EECON1^80H,WREN ; .2
         BCF     STATUS,RP0   ; 0.
         GOTO    SHURIN       ; .
;_________________________________________
; 20.   .
;_________________________________________
COUEEU
         BTFSC   PORTB,3    ;    ,
         GOTO    CO_IN      ;  .
         INCF    COUEE,1    ;+1    .
         MOVFW   COUEE      ;
         SUBLW   .64        ;  63.
         BZ      EECNOO     ;  .
         GOTO    CO_IN      ;  .
 
EECNOO
         CLRF    COUEE      ;   .
CO_IN
         BSF     FLAG,6     ; .
         MOVFW   COUEE      ;
         CALL    M1U        ;     
         MOVFW   M_LOW      ;
         MOVWF   SLO        ; .
         MOVFW   M_HIGH     ;
         MOVWF   SHI        ;
         MOVLW   .10        ;    
         MOVWF   MLO        ; .
         MOVWF   MHI        ;
         GOTO    ATTGO      ; .
;_________________________________
; 21.   .
;_________________________________
COUUI
         BTFSC   PORTB,3    ;    ,
         GOTO    COUUIN     ;  .
         INCF    ACOU,1     ;+1    .
         MOVLW   .64        ;  63.
         SUBWF   ACOU,0     ; .
         BZ      COUUIO     ;  .
         GOTO    COUUIN     ;   .
COUUIO
         CLRF    ACOU       ;.
COUUIN
         BSF     FLAG,6     ; .
         MOVFW   ACOU       ;
         CALL    H1U        ;  
         MOVFW   H_LOW      ;  
         MOVWF   SLO1       ; .
         MOVFW   H_HIGH     ;
         MOVWF   SHI1       ;
         MOVLW   .10        ;    
         MOVWF   MLO1       ; .
         MOVWF   MHI1       ;
         GOTO    ATTGO      ; .
;___________________
; 22.  .
;___________________
AKT 
         BTFSC   PORTB,3    ;   ?
         GOTO    ATTGO      ; ,  .
AKTETE
         MOVFW   ACOU       ; .
         MOVWF   EEADR      ;
         BSF     STATUS,RP0 ; 1.
         BSF  EECON1^80H,RD ;.
         BCF     STATUS,RP0 ; 0.
         MOVLW   .255       ;   ,
         SUBWF   EEDATA,0   ; -0.
         BTFSC   STATUS,Z   ;
         GOTO    AKTETEO    ;
         MOVFW   EEDATA     ;
AKTEOO
         MOVWF   MINM1      ;   .
         MOVWF   MINM       ;
         GOTO    SHULIN     ;
AKTETEO
         MOVLW   .0         ;-0.
         GOTO    AKTEOO     ;    
;______________________________________________________________
; 23.     ---.
;______________________________________________________________
S1    
         MOVFW SEC1         ;    . .
         ADDLW  -3BH        ;   59.
         BZ      M1         ;  0,   ,   M1,
         INCF  SEC1,F       ;  1   .
         RETURN             ;

; .
M1
         CLRF   SEC1        ;   .
; +1   .
M1M
         MOVFW  MIN1        ;   . .
         ADDLW  -3BH        ;-59.
         BZ     H1          ;  0,  ,   H1.
         INCF   MIN1,F      ; 1  .
         MOVFW  MIN1        ;MIN1 >W.
 
;  2_2-10     .
M1U
         MOVWF  DSMH        ;W >DSMH.
         CALL   BINDECH     ;  . .
         MOVFW  LSMH        ;LSMH >W .
         MOVWF  M_LOW       ;W > M_LOW     .
         MOVFW  HSMH        ;HSMH >W .
         MOVWF  M_HIGH      ;W > M_HIGH      .
         CLRF   HSMH        ; . . ..
         CLRF   LSMH        ; . . ..
         RETURN             ;
 
; .
H1
         CLRF   MIN1        ;   .
         CLRF   M_LOW       ;   .
         CLRF   M_HIGH      ;   .
 
; +1   .
H1H
         MOVFW  HOU1        ;   . .
         ADDLW  -17H        ;- 23. 
         BZ     H10         ;  0,  ,   H10.
         INCF   HOU1,F      ; 1  .
         MOVFW  HOU1        ;HOU >W.

;  2_2-10     .
H1U
         MOVWF  DSMH        ;W >DSMH.
         CALL   BINDECH     ;  ..
         MOVFW  LSMH        ;LSMH >W .
         MOVWF  H_LOW       ;W > H_LOW     .
         MOVFW  HSMH        ;HSMH >W .
         MOVWF  H_HIGH      ;W > H_HIGH      .
         CLRF   HSMH        ; . . ..
         CLRF   LSMH        ; . . ..
         RETURN             ;
H10
         CLRF   HOU1        ;  .
         CLRF   H_LOW       ;  .
         CLRF   H_HIGH      ;  .
         GOTO   ATTGO


          END

