; 
;  -    32- ,
; 4  ,
;      ..
;    .
;   .
;    .
; ., .
; saes@mail.ru
;
;  = SHOOL.ASM
; : 28-04-03.
;   : MPLAB IDE, : 5.61.00.
;
            #include p16f84a.inc
            __CONFIG 3FF1H
;=====================================================
;    4,096 .
;     16,  
;  TMR0 (256), ,  4     250,
;    1  (416256250=4096000).
;=====================================================
;  .
;=====================================================
INDF     EQU  00H  ;    FSR.
TIMER0   EQU  01H  ;TMR0.
OPTIONR  EQU  81H  ;OPTION (RP0=1).
PC       EQU  02H  ; .
STATUS   EQU  03H  ;  .
FSR      EQU  04H  ;  .
PORTA    EQU  05H  ;  /.
PORTB    EQU  06H  ;  /.
TRISA    EQU  85H  ;   .
TRISB    EQU  86H  ;   .
EEDATA   EQU  08H  ; .
EEADR    EQU  09H  ; .
EECON1   EQU  88H  ; -
EECON2   EQU  89H  ;.
INTCON   EQU  0BH  ;  .
;=============================================
;   .
;=============================================
SC0        EQU  0CH   ;  .
SC1        EQU  0DH   ;
SC2        EQU  0EH   ;
SC3        EQU  0FH   ;
SC4        EQU  10H   ;
SC5        EQU  11H   ; .
COUE       EQU  12H   ;    .
SMC        EQU  13H   ; 4 .
CAT        EQU  14H   ; .
;============================================
;     FLAG.
;============================================
FLAG       EQU  15H   
;
;     0->  .
;     1->  .  0-0-0 --.
;     2->  .
;     3->   .
;     4->  .
;     5-> .
;     6->  .
;     7->   .
;==========================================
;   .
;==========================================
SECL       EQU  020H  ; .  
SECH       EQU  021H  ;  .
MINL       EQU  022H  ; .
MINH       EQU  023H  ; .
HOUL       EQU  024H  ; .
HOUH       EQU  025H  ; .
DAY1       EQU  026H  ;  .
;=============================================
;     FLAG1.
;=============================================
FLAG1      EQU  027H  ;
;
;     0->  .
;     1->  .
;     2->  .
;     3->    .
;     4->   .
;     5->   .
;     6->  1 .
;     7->  5 .
;=============================================
;     FLAG2.
;=============================================
FLAG2       EQU  030H  ;
;
;     0->     1  ().
;     1->  .
;     2->    ,  6,7 .
;     3-> .... 7 .
;     4-> .... .
;     5->  .
;     6->   .
;     7->  .
;=============================================
;     FLAG3.
;=============================================
FLAG3       EQU  032H  ;
; 
;     0->   .
;     1-> .
;     2->    .
;     3->    .
;     4->    .
;     5-> .
;     6-> .
;     7-> .
;======================================================
; : , , , .
;======================================================
ZVONS       EQU  028H  ;  .
COBAHU      EQU  029H  ;  .
ZVONNEP     EQU  02AH  ;   .
BUDHEX      EQU  01DH  ;   .
ANOD        EQU  02EH  ;,  (0-5).
SEG         EQU  02FH  ;,  .(2-10 ).
COR         EQU  033H  ;  .
W_TEMP      EQU  034H  ;   W  .
STATUS_TEMP EQU  035H  ;   STATUS  .
BUHL        EQU  036H  ;  .
BUHH        EQU  037H  ;  .
COBA        EQU  038H  ;  .
FSR_TEMP    EQU  039H  ;  FSR.
CORNEG      EQU  03AH  ; , -0.
NEGCOR      EQU  03BH  ;   .
BUM         EQU  03CH  ;  .
BUD0        EQU  03DH  ;  .
BUD1        EQU  03EH  ;  .
BUH         EQU  03FH  ;  .
BUML        EQU  040H  ;  .
BUMH        EQU  041H  ;  .
ACOU        EQU  047H  ;  .
SB2         EQU  048H  ;.    .
SB3         EQU  049H  ;
SB4         EQU  04AH  ;
SB5         EQU  04BH  ;.    .
;================================================================
; 1. .   
;================================================================
        ORG 0
           GOTO INIT 

        ORG 4
           GOTO CONST
;=====================
; 2. .
;=====================
INIT
 BSF   STATUS,RP0       ;   1.
 MOVLW B'00000011'      ;  , =16 ...011,
 MOVWF OPTION_REG^80H   ;  .
 MOVLW B'10100000'      ;  =   .
 MOVWF INTCON           ;
 MOVLW B'00011000'      ; RA0-RA2- , RA3,RA4-.
 MOVWF TRISA^80H
 MOVLW B'10000000'      ; RB0-RB6- , RB7-.
 MOVWF TRISB^80H
 BCF   STATUS,RP0       ;   0.
 BCF   PORTB,6          ;  .
 CLRF  CORNEG           ;   , 
 CLRF  FLAG             ;  
 CLRF  FLAG1
 CLRF  FLAG2
 CLRF  FLAG3
 CLRF  TMR0             ;   
 CLRF  SC0
 CLRF  SC1
 CLRF  SC2
 CLRF  SC3
 CLRF  SC4
 CLRF  SC5
 CLRF  SECL
 CLRF  SECH
 CLRF  MINL
 CLRF  MINH
 CLRF  HOUL
 CLRF  HOUH
 CLRF  BUML
 CLRF  BUMH
 CLRF  BUHL
 CLRF  BUHH
 CLRF  COR
 CLRF  SMC
 CLRF  ZVONS
 CLRF  ZVONNEP
 CLRF  COBAHU
 MOVLW .1           ; 
 MOVWF CAT          ;
 MOVWF DAY1         ;  .
 MOVWF MINL
 GOTO  ZIKL         ;  .
;=======================================
; 3.    .
;=======================================
KEY
         BTFSC   FLAG3,0     ;    ,
         GOTO    KEYO        ;   .
         BTFSC   PORTB,7     ;   ,
         GOTO    KEYZ        ;  .
KEYO
         BTFSC   PORTA,3     ;    () ,
         CALL    CATK        ;   .
         BTFSC   FLAG3,0     ;   ,
         GOTO    KEY1        ; .
         BTFSC   PORTA,4     ;   ,
         CALL    UST         ;  .
KEY1
         BTFSC   FLAG,1      ;  ,
         GOTO    KEYC        ;  5 ,
         RETURN
KEYC
         MOVLW   .5          ;5 
         SUBWF   SC0,0       ;   0, 
         BZ      CORN        ;   .
         RETURN
KEYZ
         BTFSC   FLAG,6      ; 
         GOTO    KEYZO       ; .
         BTFSC   FLAG1,0     ;  ,
         RETURN              ; .
         BTFSC   FLAG1,4     ;  
         RETURN              ; .
KEYZO
         BCF     FLAG,6      ;   .
         GOTO    ZAPIS       ; .
;===================================
; 4.   .
;===================================
ZAPBIN
        MOVFW   SC1          ;  
        ADDWF   PC,1         ;    .
        RETLW   B'00000000'  ;0
        RETLW   B'00001010'  ;10
        RETLW   B'00010100'  ;20
        RETLW   B'00011110'  ;30
        RETLW   B'00101000'  ;40
        RETLW   B'00110010'  ;50
        RETLW   B'00111100'  ;60
ZAPIS
        MOVLW   .4           ;   
        SUBWF   SC1,0        ;  3   .
        BTFSC   STATUS,0     ;
        RETURN               ;
        BTFSC   FLAG2,6      ;     ,
        GOTO    SCOO         ; .
        CALL    ZAPBIN       ;  
        ADDWF   SC0,0        ;   
        MOVWF   BUDHEX       ;.
ZAPOO
        MOVLW   .32          ;  
        SUBWF   BUDHEX,0     ; 
        BTFSC   STATUS,0     ;   32,
        GOTO    ZABOR        ; .
        BTFSC   FLAG2,6      ;   ,
        GOTO    ZAPISM       ;  .
        BTFSC   FLAG,6       ;  ,
        RETURN               ;.
ZAPISO
        SWAPF   BUMH,0       ;   
        IORWF   BUML,0       ; 
        MOVWF   BUM          ;    .
        SWAPF   BUHH,0       ;   
        IORWF   BUHL,0       ; 
        MOVWF   BUH          ;    .
ZAPISM
        BTFSC   ACOU,0       ;   
        GOTO    ZAPISH       ;   .
        MOVFW   BUDHEX       ;
        MOVWF   EEADR        ;
        MOVFW   BUM          ;  .
        MOVWF   EEDATA       ;
        GOTO    ZAPISE       ;
ZAPISH
        MOVFW   BUDHEX       ;  
        ADDLW   .32          ;  32 .
        MOVWF   EEADR        ;
        MOVFW   BUH          ;
        MOVWF   EEDATA       ;
ZAPISE
        BCF     INTCON,GIE   ; .
        BSF     STATUS,RP0   ; 1.
        BSF     EECON1^80H,WREN ; .2
        MOVLW   55H          ; 
        MOVWF   EECON2^80H   ;/
        MOVLW   0AAH         ;/
        MOVWF   EECON2^80H   ;/
        BSF     EECON1^80H,WR ;    .
ZAPIZ
        BTFSS   EECON1^80H,4 ;   
        GOTO    ZAPIZ        ;  .
        BCF     INTCON,6     ;     .
        BCF     EECON1^80H,4 ;
        BCF     EECON1^80H,WREN ; .
        BCF     STATUS,RP0   ; 0.
        INCF    ACOU,1       ;+1   .
        MOVLW   .2           ;0-1.
        SUBWF   ACOU,0       ;
        BZ      EECNOO       ;
        GOTO    ZAPISM       ;    .
ZABOR
        BCF     FLAG2,6      ; 
        CLRF    SC0          ;   .
        CLRF    SC1          ;
        RETURN               ;
EECNOO
        CLRF    ACOU         ;    
        CLRF    CAT          ;     .
        BTFSS   FLAG2,6      ;    ,
        RETURN               ; .
SC31
        INCF    BUDHEX,1     ; 
        GOTO    ZAPOO        ;    .
SCOO
        CLRF    BUM          ;  
        CLRF    BUH          ; .
        GOTO    ZAPOO        ; .
;=======================================
; 5.    ().
;=======================================
CATK
         BTFSS   FLAG,2    ;    1 .
         RETURN            ;
         INCF    CAT,1     ;+1    .
         BCF     FLAG,2    ;    .
         MOVFW   CAT       ;6  ,     .
         SUBLW   .7        ;  6,
         BZ      CATK0     ;  .
         RETURN            ;
CATK0
        CLRF   CAT         ;.
        BCF    FLAG3,0     ;  6 .
        RETURN
;==============================
; 6.   .
;==============================
ATTU
        MOVLW   .6        ;   
        SUBWF   CAT,0     ;,
        BZ      ATTUH     ;   .
        MOVLW   .4        ; 4   ,
        SUBWF   SC1,0     ;
        BZ      ATTU4     ;   .
        MOVLW   .5        ; 5   ,
        SUBWF   SC1,0     ;
        BZ      ATTU5     ;   .
        MOVLW   .6        ;
        SUBWF   SC1,0     ; 6   ,
        BTFSC   STATUS,2  ;
        CLRF    SC1       ; .
        BSF     FLAG,6    ;   .
        GOTO    BIN       ;   .
ATTU4
        BCF     FLAG,6    ;  .
        MOVFW   SC0       ;   
        ADDWF   PC,1      ;  .
        GOTO    HATUB     ;  .
        GOTO    HOBI      ; .
        GOTO    HATU      ; .
        GOTO    DIN       ; .
        GOTO    INDSC     ; .
        GOTO    BUNE      ;  .
        GOTO    BU1       ; 1 .
        GOTO    BU5       ; 5 .
        GOTO    BOI       ; 1   .
        GOTO    BUVO      ; .
ATTU5
        BCF     FLAG,6    ;  .
        MOVFW   SC0       ;   
        ADDWF   PC,1      ;  .
        GOTO    BU67      ;    6  7.
        GOTO    BU7       ;   6.
        GOTO    BUV       ;  .
        GOTO    CORAT     ; .
        GOTO    BUOO      ;  .
        GOTO    ATOO      ; .
        RETURN            ;
        RETURN            ;
        RETURN            ;
        RETURN            ;
ATTUH
        BSF     FLAG3,0   ;  6 .
        BCF     FLAG,6    ;  .
        GOTO    HAT       ;  .
;=============================
; 7.    .
;=============================
ATOO
        CALL    HATU      ;    .
        BCF     FLAG,4    ;  .
ATOK
        BTFSS   PORTB,7   ;   .
        RETURN            ;.
        MOVLW   .9        ;.
        SUBWF   MINL,0    ;   9,
        BTFSC   STATUS,2  ; 
        CALL    HLU       ; .
        CLRF    SECL      ;   
        CLRF    SECH      ;
        CLRF    MINL      ;   .
        CLRF    MINH      ;
        BTFSC   FLAG3,4   ;   ,
        CALL    KYRAO     ;  .
        MOVLW   .6        ; 
        MOVWF   CAT       ;   6 .
        GOTO    HATUH     ;  .

;==================================
; 8.   .
;==================================
UST
        BTFSS   FLAG,2    ;   ,
        RETURN            ;.
        BCF     FLAG,2    ;  .
        MOVFW   CAT       ;  
        ADDWF   PC,1      ;  .
        GOTO    UST0      ;0
        GOTO    UST1      ;1
        GOTO    UST2      ;2
        GOTO    UST3      ;3
        GOTO    UST4      ;4
        GOTO    UST5      ;5
        GOTO    HAT       ; .
UST0
        INCF    SC0,1     ;   9.
        MOVLW   .10       ;
        SUBWF   SC0,0     ;
        BTFSC   STATUS,0  ;() = 1,  10  .
        CLRF    SC0       ;
        GOTO    UST6      ;
UST1
        INCF    SC1,1     ;   5.
        MOVLW   .6        ;
        SUBWF   SC1,0     ;
        BTFSC   STATUS,0  ;
        CLRF    SC1       ;
        GOTO    UST6      ;
UST2
        INCF    SC2,1     ;   9.
        MOVLW   .10       ;
        SUBWF   SC2,0     ;
        BTFSC   STATUS,0  ;
        CLRF    SC2       ;
        GOTO    UST6      ;
UST3
        INCF    SC3,1     ;   5.
        MOVLW   .6        ;
        SUBWF   SC3,0     ;
        BTFSC   STATUS,0  ;
        CLRF    SC3       ;
        GOTO    UST6      ;
UST4
        INCF    SC4,1     ;   9.
        MOVLW   .10       ;
        SUBWF   SC4,0     ;
        BTFSC   STATUS,0  ;
        CLRF    SC4       ;
        GOTO    UST6      ;
UST5
        INCF    SC5,1     ;   2.
        MOVLW   .3        ;
        SUBWF   SC5,0     ;
        BTFSC   STATUS,0  ;
        CLRF    SC5       ;
        GOTO    UST6      ;
;===============================
; 9.    .
;===============================
BUR7
        BCF     FLAG,4
        MOVLW   .7        ;  7 ,
        SUBWF   DAY1,0    ;
        SKPNZ             ;
        BSF     FLAG1,3   ;    .
        SKPZ              ;
        BCF     FLAG1,3   ;  .
        RETURN            ;
BUR67
        BCF     FLAG,4
        MOVLW   .6        ;  6 ,
        SUBWF   DAY1,0    ;
        SKPNZ             ;
        BSF     FLAG1,3   ;    .
        SKPZ              ;
        BCF     FLAG1,3   ;  .
        SKPZ              ;
        GOTO    BUR7      ;  7 .
        RETURN            ;
;================================
; 10.   .
;================================
HATUB
        BTFSC   FLAG1,0   ;    ,
        RETURN            ;.
        BTFSS   PORTB,7   ;    ,
        RETURN            ;.
        BSF     FLAG1,0   ;  .
        BCF     FLAG1,4   ;  .
        MOVLW   .6        ; 
        MOVWF   CAT       ;  .
        RETURN
BUNE
        BCF     FLAG,4
        BTFSS   PORTB,7   ;    ,
        RETURN            ;.
        BSF     FLAG1,5   ;    .
        BCF     FLAG1,6   ;   .
        BCF     FLAG1,7   ;
        BCF     FLAG2,0   ;
        BCF     FLAG2,5   ;   .
        GOTO    BUCAT     ;  .
BU1
        BCF     FLAG,4
        BTFSS   PORTB,7   ;    ,
        RETURN            ;.
        BSF     FLAG1,6   ;  1 .
        BCF     FLAG1,5   ;   .
        BCF     FLAG1,7   ;
        BCF     FLAG2,0   ;
        BCF     FLAG2,5   ;   .
        GOTO    BUCAT     ;  .
BU5
        BCF     FLAG,4
        BTFSS   PORTB,7   ;    ,
        RETURN            ;.
        BSF     FLAG1,7   ;  5 .
        BCF     FLAG1,6   ;   .
        BCF     FLAG1,5   ;
        BCF     FLAG2,0   ;
        BCF     FLAG2,5   ;   .
        GOTO    BUCAT     ;  .
BOI
        BCF     FLAG,4
        BTFSS   PORTB,7   ;    ,
        RETURN            ;.
        BSF     FLAG2,0   ;  1 .
        BSF     FLAG1,0   ;       .
        BCF     FLAG1,4   ;   .
        BCF     FLAG1,6   ;
        BCF     FLAG1,7   ;
        BCF     FLAG2,5   ;   .
        GOTO    BUCAT     ;  .
BU67
        BCF     FLAG,4
        BTFSS   PORTB,7   ;    ,
        RETURN            ;.
        BSF     FLAG2,2   ;     .
        BCF     FLAG2,3   ;     .
        BCF     FLAG2,4   ;
        GOTO    BUCAT     ;  .
BU7
        BCF     FLAG,4
        BTFSS   PORTB,7   ;    ,
        RETURN            ;.
        BSF     FLAG2,3   ;   .
        BCF     FLAG2,2   ;     .
        BCF     FLAG2,4   ;
        GOTO    BUCAT     ;  .
BUV
        BCF     FLAG,4
        BTFSS   PORTB,7   ;    ,
        RETURN            ;.
        BSF     FLAG2,4   ;    .
        BCF     FLAG1,3   ;    .
        BCF     FLAG2,3   ;     .
        BCF     FLAG2,2   ;
        GOTO    BUCAT     ;  .
BUVO
        BCF     FLAG,4
        BTFSS   PORTB,7   ;    ,
        RETURN            ;.
        BSF     FLAG1,3   ;     .
        BCF     FLAG2,3   ;     .
        BCF     FLAG2,4   ;
        BCF     FLAG2,2   ;
        GOTO    BUCAT     ;  .
BUOO
        BCF     FLAG,4
        BCF     FLAG2,1
        BTFSS   PORTB,7   ;    ,
        RETURN            ;.
        BSF     FLAG2,6   ;   .
        CLRF    SC0       ; 0  1 .
        CLRF    SC1       ;
        CLRF    BUDHEX    ;   .
        CALL    BUCAT     ;  .
        GOTO    KEYZ      ;   .
BUCAT
        MOVLW   .1        ;  
        MOVWF   CAT       ;    .
        RETURN            ;
;==================================
; 11.    .
;==================================
UST6
        BTFSC   FLAG,6    ;
        GOTO    BUST      ;: 
        BTFSC   FLAG,4   ;
        GOTO    HUST      ;
        BTFSC   FLAG1,1   ;
        GOTO    DUST      ;
        BTFSC   FLAG2,1   ;
        GOTO    CUST      ;.
        RETURN
;==================================================
; 12.     .
;==================================================
BUST
        BCF     FLAG,6    ;  .
        MOVFW   SC2       ;   
        MOVWF   BUML      ;  .
        MOVFW   SC3       ;
        MOVWF   BUMH      ;
        MOVFW   SC4       ;
        MOVWF   BUHL      ;
        MOVFW   SC5       ;
        MOVWF   BUHH      ;
        RETURN
HUST
        BCF     FLAG,4    ;   .
        MOVFW   SC2       ;   
        MOVWF   MINL      ;  .
        MOVFW   SC3       ;
        MOVWF   MINH      ;
        MOVFW   SC4       ;
        MOVWF   HOUL      ;
        MOVFW   SC5       ;
        MOVWF   HOUH      ;
        RETURN
DUST
        BCF     FLAG1,1   ;   .
        MOVLW   .10       ; 2,3,5   "".
        MOVWF   SC2       ;
        MOVWF   SC3       ;
        MOVWF   SC5       ;
        MOVLW   .8        ;8  .
        SUBWF   SC4,0     ;
        BTFSC   STATUS,0  ; 8  ,
        CLRF    SC4       ;.
        BTFSC   STATUS,0  ;
        BSF     SC4,0     ;   1.
        MOVFW   SC4       ;   .
        MOVWF   DAY1      ;
        RETURN
CUST
        BCF     FLAG2,1   ;   .
        MOVLW   .10       ; 3,5   "".
        MOVWF   SC3       ;
        MOVWF   SC5       ;
        MOVLW   .2        ;    ,
        SUBWF   CAT,0     ;
        SKPZ
        GOTO   CUSTG      ;.
        MOVLW   .5        ;     4.
        SUBWF   SC2,0     ;
        BTFSC   STATUS,0  ;
        CLRF    SC2       ;  .
        MOVFW   SC2       ;
        MOVWF   COR       ;   .
        RETURN
CUSTG
        MOVLW   .4        ; 
        SUBWF   CAT,0     ; 4 ,
        SKPZ
        RETURN            ;.
        MOVLW   .2        ;     1.
        SUBWF   SC4,0     ;
        BTFSC   STATUS,0  ;
        CLRF    SC4       ;  1, .
        MOVFW   SC4       ;  
        MOVWF   CORNEG    ;   .
        RETURN   
;=======================================
; 13.     .
;=======================================
HAT
        BTFSC   PORTA,3   ;   ,
        RETURN            ;.
        BTFSC   FLAG1,4   ;   ,
        GOTO    HOBI      ;   .
HATU
        BCF     FLAG1,0   ; :  ,
        BCF     FLAG1,1   ; .
        BSF     FLAG,4    ;   .
HATUH
        BTFSC   PORTA,3   ;    ,
        RETURN            ;.
        BTFSC   FLAG3,0   ;    6 ,
        CALL    HAT1      ;    .
        MOVFW   MINL      ;   
        MOVWF   SC2       ;  .
        MOVFW   MINH      ;
        MOVWF   SC3       ;
        MOVFW   HOUL      ;
        MOVWF   SC4       ;
        MOVFW   HOUH      ;
        MOVWF   SC5       ;
        BTFSC   FLAG1,4   ;
        BCF     FLAG,2    ;  
        RETURN            ;  .
HAT1
        MOVFW   SECL      ;   
        MOVWF   SC0       ;  .
        MOVFW   SECH      ;
        MOVWF   SC1       ;
        RETURN
BIN
        BCF     FLAG,4
        MOVLW   .2        ; 
        SUBWF   CAT,0     ;    
        BTFSC   STATUS,0  ;  .
        RETURN            ;
        CALL    ZAPIS     ;  , 
        MOVFW   BUDHEX    ;  .
        MOVWF   COUE      ;    .
BINHB
        CALL    AKTETE    ;  
        MOVFW   EEDATA    ;  .
        MOVWF   BUML      ;   
        MOVLW   B'00001111' ;
        ANDWF   BUML,1    ;
        MOVFW   EEDATA    ;
        MOVWF   BUMH      ;   .
        SWAPF   BUMH,1    ;
        MOVLW   B'00001111' ;
        ANDWF   BUMH,1    ;
        MOVFW   BUML      ;   .
        MOVWF   SC2       ;
        MOVFW   BUMH      ;
        MOVWF   SC3       ;
        MOVLW   .32       ;   31 ,
        ADDWF   COUE,1    ;  32 .
        CALL    AKTETE    ;  .
        MOVFW   EEDATA    ;   
        MOVWF   BUHL      ;
        MOVLW   B'00001111' ;
        ANDWF   BUHL,1    ;
        MOVFW   EEDATA    ;
        MOVWF   BUHH      ;   .
        SWAPF   BUHH,1    ;
        MOVLW   B'00001111' ;
        ANDWF   BUHH,1    ;
        MOVFW   BUHL      ;  
        MOVWF   SC4       ;  .
        MOVFW   BUHH      ;
        MOVWF   SC5       ;
        MOVLW   .32       ;   
        SUBWF   COUE,1    ;  .
        RETURN
DIN
        BCF     FLAG,4    ;   .
        BTFSC   PORTA,3   ;    ,
        RETURN            ;.
        BSF     FLAG1,1   ;   .
        MOVLW   .10       ; 2,3,5   "".
        MOVWF   SC2       ;
        MOVWF   SC3       ;
        MOVWF   SC5       ;
        MOVFW   DAY1      ;  
        MOVWF   SC4       ;   .
        RETURN
CORAT
        BCF     FLAG,4
        BTFSC   PORTA,3   ;    ,
        RETURN            ;.
        BSF     FLAG2,1   ;   .
        MOVLW   .10       ; 3,5   "".
        MOVWF   SC3       ;
        MOVWF   SC5       ;
        MOVFW   COR       ;  
        MOVWF   SC2       ;   .
        MOVFW   CORNEG    ;   
        MOVWF   SC4       ;   .
        RETURN
INDSC
        CLRF    SC2       ;   
        CLRF    SC3       ; .
        CLRF    SC4       ;
        CLRF    SC5       ;
        RETURN
HOBI
        BTFSC   FLAG,6    ;  
        RETURN            ;.
        BTFSC   PORTB,7   ;   ,
        GOTO    HOBU      ;   .
        BTFSC   PORTA,3   ;   ,
        RETURN            ;.
        BTFSS   FLAG1,4   ;    ,
        RETURN            ;.
        BTFSS   FLAG,2    ;    ,
        RETURN            ;.
        INCF    COBA,0    ;   .
        MOVWF   COUE      ;
        BSF     FLAG,6    ;  .
        CALL    BINHB     ;   .
        BCF     FLAG,6    ; .
        MOVFW   SC2       ;    
        MOVWF   SB2       ;    .
        MOVFW   SC3       ;
        MOVWF   SB3       ;
        MOVFW   SC4       ;
        MOVWF   SB4       ;
        MOVFW   SC5       ;
        MOVWF   SB5       ;
        INCF    COBAHU,1  ;    .
        BCF     STATUS,0  ;
        MOVLW   .11       ;10   .
        SUBWF   COBAHU,0  ;
        BTFSC   STATUS,0  ; ,
        GOTO    BUHOI     ;   .
        GOTO    HATU      ;   .
BUHOI
        BCF     STATUS,2  ;
        MOVLW   .12       ;2   .
        SUBWF   COBAHU,0  ;
        BTFSC   STATUS,2  ;  2 ,
        CLRF    COBAHU    ; .
        CLRF    SC0       ;    .
        CLRF    SC1       ;
        MOVFW   SB2       ;  
        MOVWF   SC2       ;  .
        MOVFW   SB3       ;
        MOVWF   SC3       ;
        MOVFW   SB4       ;
        MOVWF   SC4       ;
        MOVFW   SB5       ;
        MOVWF   SC5       ;
        BCF     FLAG,2    ;  .
        RETURN
HOBU
        BSF     FLAG1,4   ;  .
        BCF     FLAG1,0   ;  .
        MOVLW   .6        ;   .
        MOVWF   CAT       ;
        RETURN            ;
;===========================================
; 14.     .
;===========================================
U4851
         BTFSC  FLAG2,2   ;  6,7  ,
         GOTO   BUR67     ;  .
         BTFSC  FLAG2,3   ;  7  ,
         GOTO   BUR7      ;  .
         RETURN     
;==========================================================================
; 15. .     -    .
;==========================================================================
ZIKL
        CLRF    ANOD      ;  .  
ZS0
        BSF     INTCON,7  ; .
        MOVFW   SC0       ;    
        CALL    INDZIKL   ;   .
        CALL    ATTU      ;  .
ZS01
        BTFSS   INTCON,7  ; .
        GOTO    ZS1       ;  .
        GOTO    ZS01      ;      .
ZS1
        BSF     INTCON,7  ;    .
        MOVFW   SC1       ;
        CALL    INDZIKL   ;
        CALL    U4851     ;    .
ZS12
        BTFSS   INTCON,7  ;
        GOTO    ZS2       ;
        GOTO    ZS12      ;
ZS2
        BSF     INTCON,7  ;
        MOVFW   SC2       ;
        CALL    INDZIKL   ;
        CALL    KYRANT    ;     00 .
ZS23
        BTFSS   INTCON,7  ;
        GOTO    ZS3       ;
        GOTO    ZS23      ;
ZS3
        BSF     INTCON,7  ;
        MOVFW   SC3       ;
        CALL    INDZIKL   ;
        CALL    KEY       ; .
ZS34
        BTFSS   INTCON,7  ;
        GOTO    ZS4       ;
        GOTO    ZS34      ;
ZS4
        BSF     INTCON,7  ;
        MOVFW   SC4       ;
        CALL    INDZIKL   ;
        CALL    BUDC      ;   .
ZS45
        BTFSS   INTCON,7  ;
        GOTO    ZS5       ;
        GOTO    ZS45      ;
ZS5
        BSF     INTCON,7  ;
        MOVFW   SC5       ;
        CALL    INDZIKL   ;
ZS50
        BTFSS   INTCON,7  ;
        GOTO    ZIKL      ;
        GOTO    ZS50      ;
INDZIKL
        MOVWF   SEG       ;     .
        BCF     STATUS,0  ;  .
        RLF     SEG,1     ; ,   .
        MOVFW   ANOD      ;  .
        SUBWF   CAT,0     ;   .
        BTFSC   STATUS,2  ; ,
        BCF     SEG,5     ; .
        BTFSS   STATUS,2  ;
        BSF     SEG,5     ;  .
        BTFSS   PORTA,4   ;   ,
        GOTO    INDZVON   ;  .
        BTFSC   FLAG,0    ;   = 1,
        BSF     SEG,6     ;    RB6 (EXE).
        BTFSS   FLAG,0    ;   = 0,
INDZVON
        BCF     SEG,6     ;  .
        MOVFW   SEG       ;  
        MOVWF   PORTB     ;    TRISB.
        MOVFW   ANOD      ;  
        MOVWF   PORTA     ;  .
        INCF    ANOD,1    ;+1   .
        RETURN
;======================================================
; 16.       00 .
;======================================================
KYRANT
        BTFSC   FLAG3,4   ;  ,
        GOTO    ATOK      ;   .
        BTFSS   FLAG3,2   ;    ,
        GOTO    KYRAH     ;  .
        BTFSS   FLAG3,3   ;    ,
        GOTO    KYRAM     ;  .
        BTFSS   FLAG3,4   ;     ,
        GOTO    KYRASH    ;  .
        GOTO    KYRASL    ;   .
KYRAH
        MOVLW   023H      ;  23 ,
        SUBWF   BUH,0     ;
        BTFSC   STATUS,2  ;
        BSF     FLAG3,2   ;   .
        RETURN
KYRAM
        MOVLW   059H      ;  59 ,
        SUBWF   BUM,0     ;
        BTFSC   STATUS,2  ;
        BSF     FLAG3,3   ;   .
        RETURN
KYRASH
        MOVLW   .5        ;  50 ,
        SUBWF   SECH,0    ;
        BTFSC   STATUS,2  ;
        BSF     FLAG3,4   ;   .
        RETURN
KYRASL
        MOVLW   .1        ;     ,
        SUBWF   SECH,0    ; 10   .
        BTFSC   STATUS,2  ;
        GOTO    KYRAO     ;    .
        RETURN
KYRAO
        BCF    FLAG3,2    ;  
        BCF    FLAG3,3    ; 
        BCF    FLAG3,4    ;
        MOVLW  .6         ;  
        MOVWF  CAT        ; 6 .
        RETURN
;============================================
; 17.     .
;============================================
BUDC
        BTFSC   FLAG1,3   ;   ?
        RETURN            ;.
        BTFSC   FLAG2,5   ;   ?
        RETURN            ;.
        BTFSC   FLAG1,2   ; ?
        RETURN            ;.
        BTFSC   FLAG,6    ; ?
        RETURN            ;.
        SWAPF   HOUH,0    ;   
        IORWF   HOUL,0    ; 
        MOVWF   BUH       ;    .
        SWAPF   MINH,0    ;   
        IORWF   MINL,0    ; 
        MOVWF   BUM       ;    .
        CLRF    COUE      ;  .
        BCF     STATUS,2  ;  .
        MOVLW   .0        ;    ,
        SUBWF   BUH,0     ;
        BTFSS   STATUS,2  ;
        GOTO    AKTM      ;    .
        BCF     STATUS,2  ;
        MOVLW   .0        ;    ,
        SUBWF   BUM,0     ;
        BTFSS   STATUS,2  ;
        GOTO    AKTM      ;    .
        RETURN            ;   .
BUDH
        BCF      STATUS,2 ;
        MOVFW    EEDATA   ;   
        SUBWF    BUH,0    ;   .
        BTFSC    STATUS,2 ;  ,
        BSF      FLAG,7   ;   .
        BTFSS    STATUS,2 ;
        BCF      FLAG,3   ;    .
        MOVLW    .32      ; 
        SUBWF    COUE,1   ;    .
        BTFSS    FLAG,7   ;   ,
        GOTO     BUDM1    ;   .
        BSF      FLAG1,2  ;     .
        MOVFW    COUE     ;   
        MOVWF    COBA     ;   .
        BCF      FLAG,3   ;   
        BCF      FLAG,7   ; .
        BTFSC    FLAG1,6  ;    1 ,
        BSF      FLAG,0   ;  .
        BTFSC    FLAG1,5  ;    ,
        GOTO     BUDMZ    ;  .
        RETURN
BUDMZ
        BTFSS   ZVONNEP,0 ;   ,
        BSF     FLAG,0    ; .
        BTFSC   ZVONNEP,0 ;   ,
        BCF     FLAG,0    ;  .
        RETURN
BUDM
        MOVFW    EEDATA   ;  
        SUBWF    BUM,0    ;  .
        BTFSS    STATUS,2 ;  ,
        BCF      FLAG,3   ;   .
        BTFSC    STATUS,2 ; ,
        BSF      FLAG,3   ;   .
        BTFSC    FLAG,3   ;    ,
        GOTO     AKTH     ;  .
BUDM1
        BCF      STATUS,0
        INCF     COUE,1   ;
        MOVLW    .32      ;  
        SUBWF    COUE,0   ;    31.
        BTFSC    STATUS,0 ;  32,
        RETURN            ;  .
        GOTO     AKTETE   ;  .
;====================================================
; 18.   .
;====================================================
AKTH
        MOVLW    .32     ;   32 .
        ADDWF    COUE,1  ;
        GOTO     AKTETE  ;  .
AKTM
        CLRF    COUE     ;   .
AKTETE
        MOVFW   COUE       ;   
        MOVWF   EEADR      ;.
        BSF     STATUS,RP0 ; 1.
        BSF  EECON1^80H,RD ;.
        BCF     STATUS,RP0 ; 0.
        MOVLW   .255       ;   ,
        SUBWF   EEDATA,0   ; -0.
        BTFSC   STATUS,Z   ;
        CALL    AKTEO      ;
        BTFSC   FLAG,6     ;  , 
        RETURN             ;   .
        BTFSC   FLAG,3     ;   ,
        GOTO    BUDH       ;  .
        BTFSS   FLAG,3     ;    ,
        GOTO    BUDM       ;  .
        GOTO    BUDH       ;  .
AKTEO
        CLRF    EEDATA     ;, .. 255  .
        RETURN
;====================================================================
; 19.       .
;====================================================================
CONST
        MOVWF  W_TEMP      ;   W 
        MOVFW  STATUS      ;STATUS,
        MOVWF  STATUS_TEMP ;
        MOVFW  FSR         ;FSR.
        MOVWF  FSR_TEMP    ;
        CALL   S1          ; 1   .

RECONST                    ;  .
        BCF    INTCON,2    ;  (T0IF)   ( ).
        MOVFW  STATUS_TEMP ; :
        MOVWF  STATUS      ;STATUS,
        MOVFW  FSR_TEMP    ;
        MOVWF  FSR         ;FSR,
        MOVFW  W_TEMP      ;W.
        RETURN             ;  .
;==================================================
; 20.  ---.
;==================================================
S1
        INCF  SMC,1       ;  250.
        MOVFW SMC         ;
        ADDLW -0FAH       ;250=0FAH.
        BZ    SLF0        ;
        RETURN
SLF0
        CLRF  SMC         ;  .
        BSF   FLAG,2      ;  .
        MOVLW   .9        ;  9 ,
        SUBWF   SECL,0
        BC     SH         ;    .
        INCF  SECL,1      ;  .
        BTFSC FLAG2,0     ;   1 .  ,
        GOTO  SLF1        ;   .
        BTFSC FLAG1,7     ;  -5 ,
        GOTO  SLF5        ; .
        RETURN
SLF1
        BTFSC  FLAG,0     ;  .
        BCF    FLAG,0     ;   .
        RETURN
SLF5
        BTFSS FLAG1,2     ;  ,
        RETURN
        BSF   FLAG,0      ;  .
        INCF  ZVONS,1     ;    .
        MOVLW .6          ;  5 ,
        SUBWF ZVONS,0     ;
        BZ  SLF50         ;  .
        RETURN
SLF50
        CLRF  ZVONS       ;  .
        BCF   FLAG,0      ;  .
        BCF   FLAG1,2     ;   .
        BSF   FLAG2,5     ;   .
        RETURN
SH
        CLRF  SECL        ; .
        BCF   STATUS,2    ;   .
        MOVFW SECH        ;  
        ADDLW -5H         ; 5,
        BZ    ML          ;  .
        INCF  SECH,1      ;   .
        RETURN
ML
        CLRF  SECH        ;  .
MLU
        BCF   STATUS,2    ;   .
        MOVFW MINL        ;  
        ADDLW -9H         ; 9,
        BZ    MH          ;  .
        INCF  MINL,1      ;  .
        BTFSC FLAG1,7     ;
        BCF   FLAG2,5     ;
        BTFSC FLAG1,6     ;   1 ,
        GOTO  MHF         ;  .
        BTFSC FLAG1,5     ;    ,
        CALL  BUNZ        ;  .
        BCF     FLAG1,2   ;     1 .
        RETURN
MHF
        BTFSS FLAG1,2     ;  ,
        RETURN
        BCF   FLAG,0      ; 
        BCF   FLAG1,2     ;  .
        RETURN
BUNZ
        BTFSS   FLAG1,2   ;  ,
        RETURN
        INCF    ZVONNEP,1 ;    .
        BTFSC   ZVONNEP,0 ;  ,
        BSF     FLAG,0    ; .
        BTFSS   ZVONNEP,0 ;  ,
        BCF     FLAG,0    ; .
        RETURN
MH
        CLRF  MINL        ;  .
        BTFSC FLAG1,6     ;    1 ,
        CALL  MHF         ;  .
        BTFSC FLAG1,5     ;    ,
        CALL  BUNZ        ;   .
        BCF     FLAG1,2   ;  .

MHU
        BCF   STATUS,2    ;   .
        MOVFW MINH        ;  
        ADDLW -5H         ; 5,
        BZ    HL          ;  .
        INCF  MINH,1      ;   .
        RETURN
HL
        CLRF  MINH        ;  .
HLU
        BCF   STATUS,2    ;   .
        MOVFW HOUH        ;  
        ADDLW -2H         ; 2,
        BZ    HL4         ;  .
        MOVFW HOUL        ;    9,
        ADDLW -9H         ;
        BZ    HH          ;  .
        INCF  HOUL,1      ;   .
        BTFSC FLAG2,0     ;    1 . (),
        BSF   FLAG,0      ; .
        RETURN
HL4
        BCF   STATUS,2    ;   .
        MOVFW HOUL        ;  
        ADDLW -3H         ; 3,
        BZ    HH          ; .
        INCF  HOUL,1      ;  .
        BTFSC FLAG2,0     ;    1 . (),
        BSF   FLAG,0      ; .
        RETURN
HH
        CLRF  HOUL        ;  .
        BTFSC FLAG2,0     ;    1 . (),
        BSF   FLAG,0      ; .
HHU
        BCF   STATUS,2    ;   .
        MOVFW HOUH        ;  
        ADDLW -2H         ; ,
        BZ    DL          ;  .
        INCF  HOUH,1      ;   .
        RETURN
DL
        CLRF  HOUH        ;  .
DLU
        BCF   STATUS,2    ;   .
        MOVFW DAY1        ;  7 .
        ADDLW -7H         ; ,
        BZ    DAY         ;   1,   - .
        INCF  DAY1,1      ;   .
        RETURN
DAY
        MOVLW  01H        ;  1
        MOVWF  DAY1       ;  (0-  ).
        BSF    FLAG,1     ;   5 .  .
        RETURN
;====================================
; 21.    .
;====================================
CORN
        BTFSS  CORNEG,0   ;,    (=1),
        GOTO   CORN1      ;    .
        MOVFW  COR        ;   .
        MOVWF  NEGCOR     ;   .
        NEGF   NEGCOR,0   ;    
        ADDWF  SECL,1     ; .
        BCF    FLAG,1     ;  5 .
        RETURN
CORN1
        MOVFW  COR        ;  
        ADDWF  SECL,1     ; .
        BCF    FLAG,1     ;  5 .
        RETURN
;=============================================
 END
;==============================================
