;
;     .
;    .
;  -  .
;   .
;   .
; ., .
; saes@mail.ru
;
;  = TELEF.ASM
; : 20.02.03.
;   : MPLAB IDE, : 5.61.00.
;
            #INCLUDE P16F84A.INC
            __CONFIG 3FF0H
;======================================
;    32,768 K.
;======================================
; . .
;================
INDF     EQU  00H  ;    FSR.
TIMER0   EQU  01H  ;TMR0.
OPTIONR  EQU  81H  ;OPTION (RP0=1).
PC       EQU  02H  ; .
STATUS   EQU  03H  ;  .
FSR      EQU  04H  ;  .
PORTA    EQU  05H  ;  /.
PORTB    EQU  06H  ;  /.
TRISA    EQU  85H  ;   .
TRISB    EQU  86H  ;   .
INTCON   EQU  0BH  ;  .
;=============================================
;  .
;=============================================
; RB0 >   .
; RB1 >   .
; RB2 > ,  .
; RB3 > ,  .
; RA0 >   (1).
; RA1 >   (0).
;=================================
;  .
;=================================
SC0      EQU  10H  ;   .
SC1      EQU  11H  ;   .
COUS     EQU  12H  ; .
;============================================
;     FLAG.
;============================================
FLAG     EQU  14H   
;
;     0->  .
;     1->   .
;     2->   .
;     3->   .
;     4->   .
;     5->  .
;     6->  .
;     7->  .
;==============================
FLAG1    EQU  15H
;
;     0-> 0-  . ,
;         1-  . . 
;     1->   .
;         0-  ,
;         1-  .
;     2->    ().
;==================================
;   .
;================================== 
UC0      EQU  16H  ;  .
UC1      EQU  17H  ;  .
UCW0     EQU  18H  ;  .
UCW1     EQU  19H  ;  .
SEC1     EQU  1AH  ; .
MIN1     EQU  1BH  ; .
DSMH     EQU  1CH  ;   .
LSMH     EQU  1DH  ; ,  .
HOU1     EQU  1EH  ; .
H_LOW    EQU  1FH  ; .
H_HIGH   EQU  20H  ; .
HSMH     EQU  21H  ;,  .
UCW      EQU  22H  ;   .
UC       EQU  23H  ;   .
MIN5     EQU  24H  ;  5 .
;====================
;  .
;====================
W_TEMP      EQU  28H ;   W  .
STATUS_TEMP EQU  29H ;   STATUS  .
FSR_TEMP    EQU  2AH ;  FSR.
COUZ        EQU  2BH ; .
;=====================
; 1. .
;=====================
        ORG 0
           GOTO INIT 
        ORG 4
           GOTO CONST
;==================
; 2. .
;==================
INIT
 BSF   STATUS,RP0      ;   1.
 MOVLW B'00000010'     ;  , =8 =...10.
 MOVWF OPTION_REG^80H  ;
 MOVLW B'10100000'     ;    TMR0.
 MOVWF INTCON          ;
 MOVLW B'00000000'     ;  .
 MOVWF TRISA^80H
 MOVLW B'00000011'     ;RB0, RB1- ,  - .
 MOVWF TRISB^80H
 BCF   STATUS,RP0      ;   0. 
 CLRF  FLAG            ;  
 CLRF  FLAG1
 CLRF  TMR0            ;   
 CLRF  SC0
 CLRF  SC1
 CLRF  UC0
 CLRF  UC1
 CLRF  UC
 CLRF  UCW
 CLRF  UCW0
 CLRF  UCW1
 CLRF  COUS
 CLRF  COUZ
 BSF   COUZ,0      ;   1.
 CLRF  MIN5
 CLRF  LSMH
 CLRF  HSMH
 CLRF  SEC1
 CLRF  MIN1
 CLRF  HOU1
 CLRF  PORTB
 CLRF  PORTA
 BSF   PORTA,0
 GOTO  ZOO         ;  .
;============================
; 3.   .
;============================
KEY
         MOVFW  PORTB      ;   
         BCF    STATUS,2   ;  .
         ANDLW  B'00000011';.
         BTFSC  STATUS,2   ;  0,
         BSF    FLAG,4     ;   .
         BTFSC  FLAG,4     ;  ,
         BCF    FLAG,0     ;   .
         BTFSC  FLAG,4     ;    ,
         GOTO   KOZ        ;  .
         BTFSS  PORTB,0    ;   ,
         BSF    FLAG,2     ; .
         BTFSS  PORTB,0    ;  ,  .
         RETURN
         BTFSC  FLAG,2     ;  ,
         CALL   UST        ;  .
         BTFSS  PORTB,1    ;   ,
         BSF    FLAG,3     ; .
         BTFSS  PORTB,1    ;  ,  .
         RETURN
         BTFSC  FLAG,3     ;  ,
         CALL   UST        ;  .
         RETURN            ;   , .
KWK
         BSF    FLAG,5     ;    .
         BCF    FLAG,6     ;  .
         BCF    FLAG,7     ;
         RETURN
KWUK
         BSF    FLAG,6     ;    .
         BCF    FLAG,5     ;  .
         BCF    FLAG,7     ;
         RETURN
KHO
         BSF    FLAG,7     ;   .
         BCF    FLAG,5     ;  .
         BCF    FLAG,6     ;
         RETURN
KOZ
         BTFSS  PORTB,0    ;  ,  .
         RETURN
         BTFSS  PORTB,1    ;  ,  .
         RETURN
         BCF    FLAG,4     ; .
         BCF    FLAG,3     ;   
         BCF    FLAG,2     ;   .
         CLRF   MIN5       ;    5 .
         BCF    FLAG1,2    ; 2 .
         BCF    STATUS,0   ;    .
         RLF    COUZ,1     ;+1   .
         BTFSC  COUZ,3     ;     3 ,
         CALL   KOZO       ;  .
         BTFSC  COUZ,0     ; ,
         CALL   KWK        ;  .
         BTFSC  COUZ,1     ; ,
         CALL   KWUK       ;  .
         BTFSC  COUZ,2     ; ,
         CALL   KHO        ;  .
         RETURN
KOZO
         CLRF   COUZ       ;
         BSF    COUZ,0     ; .
         RETURN
;=================================
; 4.    .
;=================================
UST
        BTFSS   FLAG1,2   ; ,   2 .
        RETURN           ;
        BTFSC   FLAG,6   ;  ,
        GOTO    USTW     ;   .
        BTFSC   FLAG,7   ;  ,
        GOTO    USTH     ;  .
        BTFSC   FLAG,3   ;   ,
        GOTO    UST0     ;  .
        BTFSC   FLAG,2   ;   ,
        GOTO    UST1     ;  .
        RETURN
;=====================================================
; 5.   .
;=====================================================
UST0
        BCF     FLAG,3   ;   .
        INCF    UC0,1    ;    .
UST2
        MOVFW   UC1      ;  
        ADDLW   -002H    ; 2,
        SKPNZ
        CALL    UST4     ;  .
        BTFSC   FLAG,2   ;    ,
        RETURN           ;    .
        MOVLW   .10      ;   9.
        SUBWF   UC0,0    ;
        BTFSC   STATUS,0 ;() = 1,  10  .
        CLRF    UC0      ; .
        GOTO    UST3     ;   .
UST4
        MOVFW   UC0      ;    2,
        BCF     STATUS,0 ;  
        ADDLW   -004H    ;   4,
        SKPNC            ;
        CLRF    UC0      ;  .
        RETURN
UST1
        INCF    UC1,1    ;   2.
        CALL    UST2
        MOVLW   .3       ;
        SUBWF   UC1,0    ;
        BTFSC   STATUS,0 ; = 1,  3  .
        CLRF    UC1      ;  .
        BCF     FLAG,2   ;   .
        GOTO    UST3     ;   .
;========================================================
; 6.   .
;========================================================
USTW
        BTFSC   FLAG,3   ;   ,
        GOTO    USTW0    ;  .
        BTFSC   FLAG,2   ;   ,
        GOTO    USTW1    ;  .
        RETURN
USTW0
        BCF     FLAG,3   ;   .
        INCF    UCW0,1   ;    .
USTW2
        MOVFW   UCW1     ;  
        ADDLW   -002H    ; 2,
        SKPNZ
        CALL    USTW4    ;  .
        BTFSC   FLAG,2
        RETURN
        MOVLW   .10      ;   9.
        SUBWF   UCW0,0   ;
        BTFSC   STATUS,0 ;() = 1,  10  .
        CLRF    UCW0     ; .
        GOTO    USTW3    ;   .
USTW4
        MOVFW   UCW0
        BCF     STATUS,0
        ADDLW   -004H
        SKPNC
        CLRF    UCW0
        RETURN
USTW1
        INCF    UCW1,1   ;   2.
        CALL    USTW2
        MOVLW   .3       ;
        SUBWF   UCW1,0   ;
        BTFSC   STATUS,0 ; = 1,  3  .
        CLRF    UCW1     ; .
        BCF     FLAG,2   ;   .
        GOTO    USTW3    ;   .
;========================================================
; 7.  .
;========================================================
USTH
        BTFSC   FLAG,3   ;   ,
        GOTO    USTH0    ;  .
        BTFSC   FLAG,2   ;   ,
        GOTO    USTH1    ;  .
        RETURN
USTH0
        BCF     FLAG,3   ;   .
        INCF    H_LOW,1  ;    .
USTH2
        MOVFW   H_HIGH   ;  
        ADDLW   -002H    ; 2,
        SKPNZ
        CALL    USTH4    ;  .
        BTFSC   FLAG,2
        RETURN
        MOVLW   .10      ;   9.
        SUBWF   H_LOW,0  ;
        BTFSC   STATUS,0 ;() = 1,  10  .
        CLRF    H_LOW    ; .
        GOTO    USTHOO   ;   .
USTH4
        MOVFW   H_LOW
        BCF     STATUS,0
        ADDLW   -004H
        SKPNC
        CLRF    H_LOW
        RETURN
USTH1
        INCF    H_HIGH,1 ;   2.
        CALL    USTH2
        MOVLW   .3       ;
        SUBWF   H_HIGH,0 ;
        BTFSC   STATUS,0 ; = 1,  3  .
        CLRF    H_HIGH   ; .
        BCF     FLAG,2   ;   .
        GOTO    USTHOO   ;   .
;============================================================
; 8.      .
;============================================================
UST3
        MOVFW   UC0      ; 
        MOVWF   SC0      ; 
        MOVFW   UC1      ;    
        MOVWF   SC1      ;  .
        CALL    DECBIN   ;  , 
        ADDWF   UC0,0    ; 
        MOVWF   UC       ;  .
        RETURN
USTW3
        MOVFW   UCW0     ;   .
        MOVWF   SC0      ;
        MOVFW   UCW1     ;
        MOVWF   SC1      ;
        CALL    DECBIN   ;
        ADDWF   UCW0,0   ;
        MOVWF   UCW      ;
        RETURN
USTHOO
        CLRF    MIN1     ;     .
USTH3
        MOVFW   H_LOW    ;  .
        MOVWF   SC0      ;
        MOVFW   H_HIGH   ;
        MOVWF   SC1      ;
        MOVFW   H_HIGH   ;
        CALL    DECBIN   ;
        ADDWF   H_LOW,0  ;
        MOVWF   HOU1     ;:  + .
        RETURN
;==========================================================
; 9.       .
;==========================================================
DECBIN
        ADDWF   PC,1         ;
        RETLW   B'00000000'  ;0
        RETLW   B'00001010'  ;10
        RETLW   B'00010100'  ;20
;================================
; 10.   .
;================================
COMP
        BTFSS   FLAG,0   ;    ,
        GOTO    ZOO      ;   .
        BCF     FLAG,2
        BCF     FLAG,3
        BSF     PORTB,2  ;  .
        BSF     PORTB,3  ;
        MOVFW   HOU1     ;  
        SUBWF   UCW,0    ;   .
        BZ      COMW     ;  ,  .
        MOVFW   HOU1     ;  
        SUBWF   UC,0     ;   .
        BZ      COM      ;  ,  .
        GOTO    COMP     ; .
COM
        BSF     PORTA,0  ;  ().
        BCF     PORTA,1  ;.
        GOTO    COMP     ; .
COMW
        BCF     PORTA,0  ; .
        BSF     PORTA,1  ;.
        GOTO    COMP     ; .
;===========================
; 11.   .
;===========================
ZOO
        BTFSC   FLAG,0   ;  ,
        GOTO    COMP     ;  .
        BTFSS   PORTB,0  ;   ,
        BCF     PORTB,3  ; .
        BTFSS   PORTB,1  ;   ,
        BCF     PORTB,2  ; .
        BTFSS   FLAG1,2  ; 2    ,
        GOTO    ZOO      ;.
        BTFSS   PORTB,0  ;  ,  .
        GOTO    ZOO      ;.
        BTFSS   PORTB,1  ;  ,  .
        GOTO    ZOO      ;.
        BCF     FLAG1,2  ;  2 .
        BSF     PORTB,2  ; .
        BSF     PORTB,3  ;
        BTFSC   FLAG,6   ;  ,
        GOTO    WUKL     ;   .
        BTFSC   FLAG,7   ;  ,
        GOTO    HOKL     ;  .
;========================================
; 12.    .
;========================================
WKL
        BTFSC   FLAG1,0  ;    ,
        GOTO    ZH       ;  .
ZL
        BSF     PORTB,3  ;  .
        TSTF    SC0      ; 
        SKPNZ            ; ,
        GOTO    ZLO      ;   .
        BTFSC   FLAG1,1  ;  ,
        GOTO    ZOL      ;   .
        BTFSS   COUS,0   ; ,
        GOTO    ZOL      ; .
        DECF    SC0,1    ; 1   .
        BSF     FLAG1,1  ;  .
        BCF     PORTB,2  ;  .
ZOL
        BTFSS   FLAG,1   ;    ,
        GOTO    ZOL1
        BSF     PORTB,2  ;  .
        BCF     FLAG1,1  ;  .
ZOL1
        TSTF    SC0      ;     ,
        SKPZ             ;
        GOTO    WKL  ;ZL       ; .
ZLO
        BTFSC   FLAG1,1  ;,   
        GOTO    ZOL      ; .
        BSF     FLAG1,0  ;   .
        BCF     FLAG1,2  ;  2 .
        GOTO    ZOO      ; 2 .    .
ZH
        BSF     PORTB,2  ;  .
        TSTF    SC1      ;  ,
        SKPNZ            ;
        GOTO    ZHO      ;   .
        BTFSC   FLAG1,1  ;  ,
        GOTO    ZOH      ;   .
        BTFSS   SEC1,0   ; ,
        GOTO    ZOH      ; .
        DECF    SC1,1    ; 1   .
        BSF     FLAG1,1  ;  .
        BCF     PORTB,3  ;  .
ZOH
        BTFSC   SEC1,0   ;   ,
        GOTO    ZOH1
        BSF     PORTB,3  ; .
        BCF     FLAG1,1  ;  .
ZOH1
        TSTF    SC1      ;     ,
        SKPZ             ;
        GOTO    WKL ;ZH       ; .
ZHO
        BTFSC   FLAG1,1  ;,   
        GOTO    ZOH      ; .
        CALL    UST3     ;  .
        BCF     FLAG1,0  ;   .
        BCF     FLAG1,2  ;  2 .
        GOTO    ZOO      ;   .
;============================================
; 13.    .
;============================================
WUKL                     ;Ѩ   .
        BTFSC   FLAG1,0  ;    ,
        GOTO    UZH      ;  .
UZL
        BSF     PORTB,3  ;  .
        TSTF    SC0      ;  ,
        SKPNZ            ; ,
        GOTO    UZLO     ;   .
        BTFSC   FLAG1,1  ;  ,
        GOTO    UZOL     ;   .
        BTFSS   SEC1,0   ; ,
        GOTO    UZOL     ; .
        DECF    SC0,1    ; 1  .
        BSF     FLAG1,1  ;  .
        BCF     PORTB,2  ;  .
UZOL
        BTFSC   SEC1,0   ;   ,
        GOTO    UZOL1
        BSF     PORTB,2  ; .
        BCF     FLAG1,1  ;  .
UZOL1
        TSTF    SC0      ;     ,
        SKPZ             ;
        GOTO    WUKL
UZLO
        BTFSC   FLAG1,1  ;,   
        GOTO    UZOL     ; .
        BSF     FLAG1,0  ;   .
        BCF     FLAG1,2  ;  2 .
        GOTO    ZOO      ;   .
UZH
        BSF     PORTB,2  ;  .
        TSTF    SC1      ;  ,
        SKPNZ            ;
        GOTO    UZHO     ;   .
        BTFSC   FLAG1,1  ;  ,
        GOTO    UZOH     ;   .
        BTFSS   COUS,0   ; ,
        GOTO    UZOH     ; .
        DECF    SC1,1    ; . 
        BSF     FLAG1,1  ;  .
        BCF     PORTB,3  ;  .
UZOH
        BTFSS   FLAG,1   ;   ,
        GOTO    UZOH1
        BSF     PORTB,3  ; .
        BCF     FLAG1,1  ;  .
UZOH1
        TSTF    SC1      ;     ,
        SKPZ             ;
        GOTO    WUKL
UZHO
        BTFSC   FLAG1,1  ;,   
        GOTO    UZOH     ; .
        CALL    USTW3    ;  .
        BCF     FLAG1,0  ;   .
        BCF     FLAG1,2  ;  2 .
        GOTO    ZOO      ;   .
;========================================
; 14.   .
;========================================
HOKL                     ;Ѩ   .
        BTFSC   FLAG1,0  ;
        GOTO    HOZH     ;
HOZL
        BSF     PORTB,3
        TSTF    SC0      ;  ,
        SKPNZ            ; ,
        GOTO    HOZLO    ;   .
        BTFSC   FLAG1,1  ;
        GOTO    HOZOL    ;
        BTFSS   COUS,0   ;
        GOTO    HOZOL
        DECF    SC0,1    ; 1  .
        BSF     FLAG1,1  ;
        BCF     PORTB,2  ;  .
HOZOL
        BTFSS   FLAG,1
        GOTO    HOZOL1
        BSF     PORTB,2  ; .
        BCF     FLAG1,1  ;
HOZOL1
        TSTF    SC0      ;   ,
        SKPZ            ;
        GOTO    HOKL
HOZLO
        BTFSC   FLAG1,1  ;
        GOTO    HOZOL    ;
        BSF     FLAG1,0  ;
        BCF     FLAG1,2   ;
        GOTO    ZOO
HOZH
        BSF     PORTB,2
        TSTF    SC1      ;
        SKPNZ            ;
        GOTO    HOZHO    ;
        BTFSC   FLAG1,1  ;
        GOTO    HOZOH    ;
        BTFSS   COUS,0   ;
        GOTO    HOZOH
        DECF    SC1,1    ; .
        BSF     FLAG1,1  ;
        BCF     PORTB,3  ;  .
HOZOH
        BTFSS   FLAG,1
        GOTO    HOZOH1
        BSF     PORTB,3  ;
        BCF     FLAG1,1  ;  .
HOZOH1
        TSTF    SC1      ;   ,
        SKPZ            ;
        GOTO    HOKL
HOZHO
        BTFSC   FLAG1,1  ;
        GOTO    HOZOH   ;
        CALL    USTH3    ; .
        BCF     FLAG1,0  ;
        BCF     FLAG1,2   ;
        GOTO    ZOO      ;   .
;==========================================================
; 15. .     2-10  (2-_-2-10).
;==========================================================
BINDECH
        MOVLW   .10      ;10 >W.
BDH
        BSF     STATUS,0 ;  ""  STATUS.
        SUBWF   DSMH,1   ;   10 > DSMH.
        BNC     BINDECL  ;    .
        INCF    HSMH,1   ; 1   .
        GOTO    BDH      ;.                
BINDECL
        MOVF    DSMH,0   ;   
        ADDLW   .10      ;10+W >W.               
        MOVWF   LSMH     ;    .
        RETURN           ;
;==================================================================
; 16.       .
;===================================================================
CONST
        MOVWF  W_TEMP      ;   W 
        MOVFW  STATUS      ;STATUS,
        MOVWF  STATUS_TEMP ;
        MOVFW  FSR         ;FSR.
        MOVWF  FSR_TEMP    ;
        CALL   S1          ; 1  .
        BTFSC  FLAG1,2     ;   2 .
        CALL   KEY         ; .
RECONST                    ;  .
        BCF    INTCON,2    ;  .
        MOVFW  STATUS_TEMP ; :
        MOVWF  STATUS      ;STATUS,
        MOVFW  FSR_TEMP    ;
        MOVWF  FSR         ;FSR,
 ; MOVLW  .150
  ;MOVWF  TMR0
        MOVFW  W_TEMP      ;W.
        RETFIE             ;  .
;==================
; 17. .
;=================
S1
        INCF  COUS,1    ;+1  .
        BTFSS COUS,0
        BSF   FLAG,1
        BTFSC COUS,0
        BCF   FLAG,1
        MOVLW .4        ;  1 ,
        SUBWF COUS,0    ;
        SKPZ            ;
        RETURN
        CLRF  COUS      ; .
        MOVFW SEC1      ;  . .
        ADDLW  -3BH     ;   59.
        BZ      M1      ;  0,   ,   M1.
        INCF  SEC1,F    ; 1  .
        BTFSC  SEC1,1   ;  ,
        BSF    FLAG1,2  ;  2 .
        RETURN          ;
M1
        CLRF   SEC1     ;  .
        CALL   M5M      ;  5 .
M1M
        MOVFW  MIN1     ;   . .
        ADDLW  -3BH     ;-59.
        BZ     H1       ;  0,  ,   H1.
        INCF   MIN1,F   ; 1  .
        RETURN          ;
H1
        CLRF   MIN1     ;   .
H1H
        MOVFW  HOU1     ;   . .
        ADDLW  -17H     ;- 23. 
        BZ     H10      ;  0,  ,   H10.
        INCF   HOU1,F   ; 1  .
        MOVFW  HOU1     ;HOU >W.
H1U
        MOVWF  DSMH     ;W >DSMH.
        CALL   BINDECH  ;  .
        MOVFW  LSMH     ;LSMH >W .
        MOVWF  H_LOW    ;W > H_LOW     .
        MOVFW  HSMH     ;HSMH >W .
        MOVWF  H_HIGH   ;W > H_HIGH      .
        CLRF   HSMH     ; . . .
        CLRF   LSMH     ; .
        RETURN          ;
H10
        CLRF   HOU1     ;  .
        CLRF   H_LOW    ;  .
        CLRF   H_HIGH   ;  .
        RETURN
M5M
        INCF   MIN5,1   ;+1   5 .
        MOVLW  .5       ;  5 ,
        SUBWF  MIN5,0   ;
        SKPNZ           ;
        BSF    FLAG,0   ;   .
        SKPNZ           ;
        CLRF   MIN5     ;  .
        RETURN
;==============================================
        END
;==============================================

