;
;    .
;   - 30 ,  48 .
;   .
;   .
;    .
; ., .
; saes@mail.ru
;
;  = XOLOD.ASM
; : 27.04.03.
;   : MPLAB IDE, : 5.61.00.
;
            #INCLUDE P16F84A.INC
            __CONFIG 3FF0H
;======================================
;    32,768 K.
;======================================
HWK      EQU  06H  ;  6 
MWK      EQU  00H  ;  .
MWUK     EQU  1EH  ;  30 .
;================
; . .
;================
INDF     EQU  00H  ;    FSR.
TIMER0   EQU  01H  ;TMR0.
OPTIONR  EQU  81H  ;OPTION (RP0=1).
PC       EQU  02H  ; .
STATUS   EQU  03H  ;  .
FSR      EQU  04H  ;  .
PORTA    EQU  05H  ;  /.
PORTB    EQU  06H  ;  /.
TRISA    EQU  85H  ;   .
TRISB    EQU  86H  ;   .
INTCON   EQU  0BH  ;  .
;=============================================
;  .
;=============================================
; RB0 >  .
; RA0 >   (1).
; RA1 >   (0).
;==================================
;   .
;================================== 
SEC1     EQU  11H  ; .
MIN1     EQU  12H  ; .
HOU1     EQU  13H  ; .
;====================
;  .
;====================
W_TEMP      EQU  20H ;   W  .
STATUS_TEMP EQU  21H ;   STATUS  .
FSR_TEMP    EQU  22H ;  FSR.
;=====================
; 1. .
;=====================
        ORG 0
           GOTO INIT 
        ORG 4
           GOTO CONST
;==================
; 2. .
;==================
INIT
 BSF   STATUS,RP0      ;   1.
 MOVLW B'00000100'     ;  , =32 =...100.
 MOVWF OPTION_REG^80H  ;
 MOVLW B'10110000'     ;    TMR0
 MOVWF INTCON          ;    RB0.
 MOVLW B'00000000'     ;  .
 MOVWF TRISA^80H
 MOVLW B'00000001'     ;RB0- ,  - .
 MOVWF TRISB^80H
 BCF   STATUS,RP0      ;   0. 
 CLRF  TMR0            ;   .
 CLRF  SEC1
 CLRF  MIN1
 CLRF  HOU1
 CLRF  PORTB
 CLRF  PORTA
 BSF   PORTA,1
 GOTO  COMP         ; .
;================================
; 3. .
;================================
UST
        CLRF    SEC1
        CLRF    MIN1
        CLRF    HOU1
        RETURN
;================================
; 4.   .
;================================
COMP
        BTFSS   PORTA,1 ;  ,
        GOTO    COMWU   ; .
        MOVFW   HOU1    ;  
        SUBLW   HWK     ;   .
        BNZ     COM     ;   , .
        MOVFW   MIN1    ;  
        SUBLW   MWK     ;   .
        BZ      COMW    ;  ,  .
COM
        BCF     PORTA,0 ; .
        BSF     PORTA,1 ;.
        GOTO    COMP    ; .
COMW
        BSF     PORTA,0 ; .
        BCF     PORTA,1 ;.
        GOTO    COMP    ; .
COMWU
        MOVFW   HOU1    ;  
        SUBLW   HWK     ;   .
        BNZ     COM     ;   , .
        MOVFW   MIN1    ;  
        SUBLW   MWUK    ;   .
        BZ      COM     ;  ,  .
        GOTO    COMP    ; .
;==================================================================
; 5.       .
;===================================================================
CONST
        MOVWF  W_TEMP      ;   W 
        MOVFW  STATUS      ;STATUS,
        MOVWF  STATUS_TEMP ;
        MOVFW  FSR         ;FSR.
        MOVWF  FSR_TEMP    ;
        BTFSC  INTCON,1    ;   ,
        CALL   UST         ;.
        BTFSC  INTCON,2    ;   ,
        CALL   S1          ; 1  .
RECONST                    ;  .
        BCF    INTCON,2    ;    .
        BCF    INTCON,1    ;    .
        MOVFW  STATUS_TEMP ; :
        MOVWF  STATUS      ;STATUS,
        MOVFW  FSR_TEMP    ;
        MOVWF  FSR         ;FSR,
        MOVFW  W_TEMP      ;W.
        RETFIE             ;  .
;==================
; 6. .
;=================
S1
        MOVFW  SEC1     ;  . .
        ADDLW  -3BH     ;   59.
        BZ     M1       ;  0,   ,   M1.
        INCF   SEC1,1   ; 1  .
        BTFSS  SEC1,0   ; 
        BSF    PORTA,2  ; 
        BTFSC  SEC1,0   ;1 
        BCF    PORTA,2  ;   "2".
        RETURN          ;
M1
        CLRF   SEC1     ;  .
M1M
        MOVFW  MIN1     ;   . .
        ADDLW  -3BH     ;-59.
        BZ     H1       ;  0,  ,   H1.
        INCF   MIN1,F   ; 1  .
        RETURN          ;
H1
        CLRF   MIN1     ;   .
H1H
        MOVFW  HOU1     ;   . .
        ADDLW  -2FH     ;- 47. 
        BZ     H10      ;  0,  ,   H10.
        INCF   HOU1,F   ; 1  .
        RETURN
H10
        CLRF   HOU1     ;  .
        RETURN
;=============================================
        END
==============================================

